      SUBROUTINE INTPAR(IPAN)
***********************************************************
*  Calculates contribution to the interstitial potential  *
*  matrix elements from k=0 and large vectors G.          *
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS
     &                      ,IS,ILST,ILSB                     !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                       !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP,EK                !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                      !!! from readini
      USE COM_SPHERE  ,ONLY: SMT,SWZ                          !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT                !!! from readini
      USE COM_LATTICE ,ONLY: TAU                              !!! from readstr
      USE COM_POTDAT  ,ONLY: POTPS1                           !!! from potfull
	USE COM_LMTIND  ,ONLY: LMTIND                           !!! from lmtpar
      USE COM_PLWMESH ,ONLY: NPLW,GPLW                        !!! from plwmesh
	USE COM_RINPAR  ,ONLY: VINT0=>RINT0,XFUN=>RFUN          !!! from intpar
      USE COM_TEILORG ,ONLY: MBAS,KEYT                        !!! from readini
      USE COM_ETAPAR  ,ONLY: NBAS,LBAS                        !!! from setpar
      USE COM_INPTTR  ,ONLY: SH                               !!! from readini
      USE COM_KMESH   ,ONLY: NPNT,PNT                         !!! from tetra
      USE COM_LMTOUT  ,ONLY: ICSCR,SCRFILE                    !!! from readini
      USE COM_CHANNELS,ONLY: IUPIN                            !!! from setup
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                      !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
      COMPLEX*16, ALLOCATABLE :: YLM(:,:)
      COMPLEX*16, ALLOCATABLE :: CFTR(:,:,:,:)
      COMPLEX*16, ALLOCATABLE :: CHIK(:)
      COMPLEX*16, ALLOCATABLE :: CHIS(:)
      COMPLEX*16, ALLOCATABLE :: CONV(:)
      COMPLEX*16, ALLOCATABLE :: EXPS(:)
      COMPLEX*16, ALLOCATABLE :: EXPK(:)
	COMPLEX*16 GINT,HHH
	DIMENSION PNTR(3),PNTK(3)
	LOGICAL EXIST
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C OPEN SCRATCH FILE FOR STORING POTENTIAL PARAMETERSA
      NRECL=NVAL*(NBNDT(IPAN)*(MIN(NBAS,MBAS)+1)+
     &NBNDT(IPAN)**2)
      OPEN(UNIT=IUPIN,FILE=SCRFILE(IUPIN),STATUS='NEW',
     &ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECL)
C RETURN KEYS
      IF(KEYT.EQ.0)RETURN
	IF(NPLWMEM.EQ.-1)RETURN
C MEMORY ALLOCATIONS
      ALLOCATE(YLM(LIMBMEM,0:NBASMEM))
      SIZE_YLM=DBLE(SIZE(YLM)*LENCMP)/1024.D0**2
      ALLOCATE(CFTR(0:LMAXBMEM,NSORTMEM,NKAPMEM,0:NBASMEM))
      SIZE_CFTR=DBLE(SIZE(CFTR)*LENCMP)/1024.D0**2
      CURMEM=CURMEM+SIZE_YLM+SIZE_CFTR
      IF(TOTMEM.LT.CURMEM)TXTMEM='<INTPAR> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
      ALLOCATE(CHIK(0:NBASMEM))
      ALLOCATE(CHIS(0:NBASMEM))
      ALLOCATE(CONV(0:NBASMEM))
      ALLOCATE(EXPK(0:NBASMEM))
      ALLOCATE(EXPS(0:NBASMEM))
	PNTK(1)=0.D0
	PNTK(2)=0.D0
	PNTK(3)=0.D0
C  SET PSEUDOLMTOS FOR THE POINT IPNTK
      CALL FTRMAT(PNTK,1,IPAN,PNTR,YLM,CFTR)
C  DO OVER SPINS
	DO 2000 IORBS=1,NORBS             !!! over spins
	DO 1000 IUPDN=1,NSPIN             !!! over spins
	IF(IORBS.EQ.1)THEN
	IUPDN1=IUPDN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	SIGNF=1.D0
	ELSEIF(IORBS.EQ.2)THEN
	IUPDN1=NSPIN+1-IUPDN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	IF(ISPIN1.EQ.1.AND.ISPIN.EQ.2)SIGNF=-SQRT(2.D0) ! B^{+} * <S_{+}>
	IF(ISPIN1.EQ.2.AND.ISPIN.EQ.1)SIGNF=+SQRT(2.D0) ! B^{-} * <S_{-}>
	ENDIF
C  DO OVER LEFT INDEX
	DO IATOM1=1,NATOM                 !!! over iatom1
	ISORT1=IS(IATOM1)
C  CALCULATE EXPONENTIAL FACTOR
	DO IBAS=0,NBAS
	SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM1)+
     &    (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM1)+
     &    (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM1)
	EXPS(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
	DO IKAP1=1,NKAP(IPAN)             !!! over energy
	DO L1=0,ILSB(ISORT1)              !!! over l1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))CYCLE
	DO M1=-L1,L1                      !!! over m1
	L1M1=L1*(L1+1)+M1+1
	IPAR1=LMTIND(L1M1,IATOM1,IKAP1,1,IPAN)
C  FOURIER TRANSFORM OF THE PSEUDOORBITAL
	DO IBAS=0,LBAS(L1,ISORT1,IKAP1,IPAN)! NG_1
	CHIS(IBAS)=DCONJG(CFTR(L1,ISORT1,IKAP1,IBAS)*
     &YLM(L1M1,IBAS)*EXPS(IBAS))
	ENDDO
C  CONVOLUTION OF THE PSEUDOORBITAL WITH THE PSEUDOPOTENTIAL
      CALL CONVOL1(POTPS1(0,IUPDN1,IORBS),CHIS(0),CONV(0),'L',
     &            0,NBAS,MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN))
C  SET CONVOLUTION FROM THE TEILOR EXPANSION
	DO IBAS=0,MIN(NBAS,MBAS)          !!! NGMAX{small}
    	XFUN(IPAR1,IBAS)=CONV(IBAS)*SIGNF
	ENDDO
C  DO OVER RIGHT INDEX
	DO IATOM=1,NATOM                  !!! over iatom
	ISORT=IS(IATOM)
C  CALCULATE EXPONENTIAL FACTOR
	DO IBAS=0,NBAS                    !!! NGMAX{large}
	SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM)+
     &    (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM)+
     &    (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM)
	EXPK(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
	DO IKAP=1,NKAP(IPAN)              !!! over energy
	DO L=0,ILSB(ISORT)                !!! over l
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))CYCLE
	DO M=-L,L                         !!! over m
	LM=L*(L+1)+M+1
	IPAR=LMTIND(LM,IATOM,IKAP,1,IPAN)
	IF(IPAR1.GE.IPAR)THEN
C  FOURIER TRANSFORM OF THE PSEUDOORBITAL
	DO IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)  !!! NG_0{large}
	CHIK(IBAS)=CFTR(L,ISORT,IKAP,IBAS)*YLM(LM,IBAS)*EXPK(IBAS)
	ENDDO
C  ******** PSEUDOPOTENTIAL MATRIX ************
C     CONTRIBUTION FROM LARGE G, K-DEPENDENCE BY TEILOR WILL BE USED
	HHH=(0.D0,0.D0)
	DO IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)  !!! NG_0{large}
    	HHH=HHH+CONV(IBAS)*CHIK(IBAS)
	ENDDO
	HHH=HHH*SIGNF
C  FILL UP THE MATRICES
	HRE= DREAL(HHH)  ! real part of the hamiltonian matrix
	HIM= DIMAG(HHH)  ! imaginary part of the hamiltonian matrix
C     IF(ABS(HRE).LE.1.D-10)HRE=0.D0
C     IF(ABS(HIM).LE.1.D-10)HIM=0.D0
	IF(IPAR1.EQ.IPAR)HIM=0.D0
	VINT0(IPAR1,IPAR)=DCMPLX(HRE,+HIM)!!! the hamiltonian
	VINT0(IPAR,IPAR1)=DCMPLX(HRE,-HIM)!!! the hamiltonian
	ENDIF
      ENDDO                             !!! over m
      ENDDO                             !!! over l
      ENDDO                             !!! over energy
      ENDDO                             !!! over iatom
      ENDDO                             !!! over m1
      ENDDO                             !!! over l1
      ENDDO                             !!! over energy
      ENDDO                             !!! over iatom1
C  STORE DATA
      IREC=IUPDN+NSPIN*(IORBS-1)
      WRITE(IUPIN,REC=IREC)((VINT0(IPAR1,IPAR),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((XFUN(IPAR1,IBAS),
     &IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
1000  CONTINUE                          !!! over spins
2000  CONTINUE                          !!! over iorbs
C MEMORY DEALLOCATIONS
      DEALLOCATE(YLM)
      DEALLOCATE(CFTR)
      DEALLOCATE(CHIK)
      DEALLOCATE(CHIS)
      DEALLOCATE(CONV)
      DEALLOCATE(EXPK)
      DEALLOCATE(EXPS)
      CURMEM=CURMEM-SIZE_YLM-SIZE_CFTR
	END
