	SUBROUTINE LMTMAT(IPNT,IPAN,IENW)
************************************************************
* Subroutine  calculates Hamiltonian and overlap matricea  *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY: LMTO,IASA,NPFR,NOVR              !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS
     &                      ,IS,ILSB,ILST                     !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                       !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                      !!! from readini
      USE COM_SPHERE  ,ONLY: SMT,SWZ                          !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT                !!! from readini
      USE COM_OVRPAR  ,ONLY: OPARHH,OPARJH,OPARHJ,OPARJJ      !!! from ovrpar
      USE COM_HAMPAR  ,ONLY: HPARHH,HPARJH,HPARHJ,HPARJJ      !!! from nmtpar
      USE COM_LMTIND  ,ONLY: LMTIND                           !!! from lmtpar
      USE COM_LMTMAT  ,ONLY: HMAT,OMAT                        !!! from lmtmat
      USE COM_CHANNELS,ONLY: IUNMT                            !!! from lmtmat
      USE COM_STRCON  ,ONLY: SSCON,SDCON                      !!! from strgnt
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: HSS(:,:)
      COMPLEX*16  HHH,OOO
C MEMORY ALLOCATIONS
	CALL  ABORTNOW()
	ALLOCATE(HSS(LIMTMEM,NATOMMEM))
	NDIM=NBNDT(IPAN)*NSPIN
C DO GLOBALLY OVER SPINS, SET UP-UP, DN-DN HAMILTONIAN 
	DO 2000 IORBS=1,NORBS       !!! over iorbs
	DO 1000 IUPDN=1,NSPIN       !!! over spins
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO IKAP1=1,NKAP(IPAN)       !!! over energy
	DO IKAP =1,NKAP(IPAN)       !!! over energy
	DO IATOM=1,NATOM            !!! read three-center parameter
	ISORT=IS(IATOM)
	IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(IUPDN-1)+
     &NKAP(IPAN)**2*NATOM*NSPIN*(IORBS-1)
	READ(IUNMT,REC=IREC)((HPARHH(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARJH(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARHJ(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((HPARJJ(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
      ENDDO         
C SET HAMILTONIAN AND OVERLAP  MATRIX
	DO IATOM1=1,NATOM           !!! over iatom1
	ISORT1=IS(IATOM1)
	DO L1=0,ILSB(ISORT1)        !!! over l1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))CYCLE
	DO M1=-L1,L1                !!! over m1
	L1M1=L1*(L1+1)+M1+1
	IDIM1=LMTIND(L1M1,IATOM1,IKAP1,ISPIN1,IPAN)
	DO KATOM=1,NATOM
	DO L3M3=1,(ILST(IS(KATOM))+1)**2
	HSS(L3M3,KATOM)=(0.D0,0.D0)
	DO L2M2=1,(ILST(IS(KATOM))+1)**2
	HSS(L3M3,KATOM)=HSS(L3M3,KATOM)+
     &CONJG(SSCON(L2M2,KATOM,L1M1,IATOM1,IKAP1))*
     &HPARJJ(L2M2,L3M3,KATOM)
      ENDDO         
      ENDDO         
      ENDDO         
	DO IATOM=1,NATOM            !!! over iatom
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)          !!! over l
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))CYCLE
	DO M=-L,L                   !!! over m
	LM=L*(L+1)+M+1
	IDIM=LMTIND(LM,IATOM,IKAP,ISPIN,IPAN)
	IF(IDIM1.GE.IDIM)THEN
	HHH=(0.D0,0.D0)
	OOO=(0.D0,0.D0)
C ONE-CENTER TERM :
	IF(IATOM1.EQ.IATOM)THEN
	IF(L1M1.EQ.LM)
     &OOO=OOO+OPARHH(IKAP1,IKAP,L,ISORT,ISPIN)
	HHH=HHH+HPARHH(L1M1,LM,IATOM)
	ENDIF
C TWO-CENTER TERM :
	DO L2M2=1,(ILST(ISORT)+1)**2      !!! over l2m2
	HHH=HHH-HPARJH(L2M2,LM,IATOM)*
     &CONJG(SSCON(L2M2,IATOM,L1M1,IATOM1,IKAP1))
      ENDDO                             !!! over l2m2
	OOO=OOO-OPARJH(IKAP1,IKAP,L,ISORT,ISPIN)*
     &CONJG(SSCON(LM,IATOM,L1M1,IATOM1,IKAP1))
	DO L2M2=1,(ILST(ISORT1)+1)**2     !!! over l2m2
	HHH=HHH-HPARHJ(L1M1,L2M2,IATOM1)*
     &SSCON(L2M2,IATOM1,LM,IATOM,IKAP)
      ENDDO                             !!! over l2m2
	OOO=OOO-OPARHJ(IKAP1,IKAP,L1,ISORT1,ISPIN)*
     &SSCON(L1M1,IATOM1,LM,IATOM,IKAP)
C ADD SDCON MATRIX IN CASE EQUAL ENERGIES
	IF(ABS(EKAP(IKAP,1)-DCONJG(EKAP(IKAP1,1))).
     &   LE.1.D-10.AND.ISPIN1.EQ.ISPIN)THEN
	IF(NOVR.EQ.0)
     &OOO=OOO-CONJG(SDCON(LM,IATOM,L1M1,IATOM1,IKAP))*PAR**3
	HHH=HHH-CONJG(SDCON(LM,IATOM,L1M1,IATOM1,IKAP))*PAR**3*
     &EKAP(IKAP,IPAN)
	ENDIF
C THREE-CENTER TERM :
	DO KATOM=1,NATOM                  !!! over katom
	KSORT=IS(KATOM)
	DO L2=0,ILST(KSORT)               !!! over l2
	DO M2=-L2,L2                      !!! over m2
	L2M2=L2*(L2+1)+M2+1
	HHH=HHH+HSS(L2M2,KATOM)*SSCON(L2M2,KATOM,LM,IATOM,IKAP)
	OOO=OOO+CONJG(SSCON(L2M2,KATOM,L1M1,IATOM1,IKAP1))*
     &OPARJJ(IKAP1,IKAP,L2,KSORT,ISPIN)*
     &SSCON(L2M2,KATOM,LM,IATOM,IKAP)
      ENDDO                             !!! over m2
      ENDDO                             !!! over l2
      ENDDO                             !!! over katom
C SET ZEROES WHERE NECESSARY
	IF(ISPIN1.NE.ISPIN)OOO=(0.D0,0.D0)
	HRE= DREAL(HHH)  ! real part of the hamiltonian matrix
	HIM= DIMAG(HHH)  ! imaginary part of the hamiltonian matrix
	ORE= DREAL(OOO)  ! real part of the overlap matrix
	OIM= DIMAG(OOO)  ! imaginary part of the overlap matrix
C     IF(ABS(HRE).LE.1.D-10)HRE=0.D0
C     IF(ABS(HIM).LE.1.D-10)HIM=0.D0
C     IF(ABS(ORE).LE.1.D-10)ORE=0.D0   ! not necessary now !
C     IF(ABS(OIM).LE.1.D-10)OIM=0.D0
	IF(IDIM1.EQ.IDIM)HIM=0.D0
	IF(IDIM1.EQ.IDIM)OIM=0.D0
C SET HAMILTONIAN AND OVERLAP MATRICES
      HMAT(IDIM1,IDIM)=HMAT(IDIM1,IDIM)+DCMPLX(HRE,+HIM)
      OMAT(IDIM1,IDIM)=OMAT(IDIM1,IDIM)+DCMPLX(ORE,+OIM)
      HMAT(IDIM,IDIM1)=DCONJG(HMAT(IDIM1,IDIM))
      OMAT(IDIM,IDIM1)=DCONJG(OMAT(IDIM1,IDIM))
	ENDIF
      ENDDO                             !!! over m
      ENDDO                             !!! over l
      ENDDO                             !!! over iatom
      ENDDO                             !!! over m1
      ENDDO                             !!! over l1
      ENDDO                             !!! over iatom1
      ENDDO                             !!! over energy
      ENDDO                             !!! over energy
1000  CONTINUE                          !!! over spins
2000  CONTINUE                          !!! over iorbs
C MEMORY DEALLOCATIONS
	DEALLOCATE(HSS)
	END
