	SUBROUTINE LMTPAR(IPAN)
*********************************************************
*  Subroutine prepares arrays depended on potential     *
*  parameters for LMTBND program                        *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,IS,ILST,ILSB,LRTV    !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                             !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP,EK                      !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN,IATS,ISTS                  !!! from readini
      USE COM_SPHERE  ,ONLY: SMT,SASA,SWZ                           !!! from readini
      USE COM_INPPAR  ,ONLY: ENY,DNY                                !!! from readini
      USE COM_POTPAR  ,ONLY: FF,FFP,FPF,FPFP                        !!! from potpar
      USE COM_LMTPAR  ,ONLY: GAM,AAH,BBH,AAJ,BBJ                    !!! from potpar
      USE COM_ASAPAR  ,ONLY: HS,BS,DH,DJ                            !!! from potpar
      USE COM_MTSPAR  ,ONLY: OMTHH,OMTHJ,OMTJH,OMTJJ
     &                      ,HMTHH,HMTHJ,HMTJH,HMTJJ                !!! from lmtpar
      USE COM_LMTIND  ,ONLY: LMTIND                                 !!! from lmtpar
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                            !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 FHHFH,FJHFH,FHHFJ,FJHFJ,FHFH,FHFJ,FJFH,FJFJ
	LOGICAL LOG,FIRST
	SAVE FIRST
	DATA PI/3.141592653589793D0/,FIRST/.TRUE./
      CALL ABORTNOW()
C MEMORY ALLOCATIONS
	IF(FIRST)THEN
	FIRST=.FALSE.
	ALLOCATE(OMTHH(NKAPMEM,NKAPMEM,0:LMAXBMEM,NSORTMEM,NSPINMEM))
	ALLOCATE(OMTJH(NKAPMEM,NKAPMEM,0:LMAXBMEM,NSORTMEM,NSPINMEM))
	ALLOCATE(OMTHJ(NKAPMEM,NKAPMEM,0:LMAXBMEM,NSORTMEM,NSPINMEM))
	ALLOCATE(OMTJJ(NKAPMEM,NKAPMEM,0:LMAXTMEM,NSORTMEM,NSPINMEM))
	ALLOCATE(HMTHH(NKAPMEM,NKAPMEM,0:LMAXBMEM,NSORTMEM,NSPINMEM))
	ALLOCATE(HMTJH(NKAPMEM,NKAPMEM,0:LMAXBMEM,NSORTMEM,NSPINMEM))
	ALLOCATE(HMTHJ(NKAPMEM,NKAPMEM,0:LMAXBMEM,NSORTMEM,NSPINMEM))
	ALLOCATE(HMTJJ(NKAPMEM,NKAPMEM,0:LMAXTMEM,NSORTMEM,NSPINMEM))
	ENDIF
C COMPUTE POTENTIAL PARAMETERS FOR THE OVERLAP MATRIX AND HAMILTONIAN ::
	DO 2000 ISPIN=1,NSPIN                             !!! over ispin
	DO 1000 ISORT=1,NSORT                             !!! over isort
	DO L=0,ILST(ISORT)                                !!! over l
	DO IKAP1=1,NKAP(IPAN)                             !!! over ikap1
	DO IKAP=1,NKAP(IPAN)                              !!! over ikap
C SET POTENTIAL PARAMETERS TO ZERO
	IF(L.LE.ILSB(ISORT))THEN
	OMTHH(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	OMTJH(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	OMTHJ(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	HMTHH(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	HMTJH(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	HMTHJ(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	ENDIF
	OMTJJ(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	HMTJJ(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
C ONE- AND TWO-CENTER POTENTIAL PARAMETERS
	IF(LSPAN(L,ISORT,IKAP1,IPAN).AND.LSPAN(L,ISORT,IKAP,IPAN))THEN
	FHFH=CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)
     & *AAH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBH(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPFP(IKAP1,IKAP,L,ISORT,ISPIN)*BBH(L,ISORT,IKAP,IPAN,ISPIN)   
     & +CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FFP(IKAP1,IKAP,L,ISORT,ISPIN)
     & *BBH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBH(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPF(IKAP1,IKAP,L,ISORT,ISPIN)*AAH(L,ISORT,IKAP,IPAN,ISPIN)   
	OMTHH(IKAP1,IKAP,L,ISORT,ISPIN)=FHFH
	FHHFH=CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)
     & *BBH(L,ISORT,IKAP,IPAN,ISPIN)+
     *  CONJG(BBH(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPF(IKAP1,IKAP,L,ISORT,ISPIN)*BBH(L,ISORT,IKAP,IPAN,ISPIN) 
	HMTHH(IKAP1,IKAP,L,ISORT,ISPIN)=FHHFH+
     &  ENY(L,ISORT,IKAP,IPAN,ISPIN)*OMTHH(IKAP1,IKAP,L,ISORT,ISPIN)
	ENDIF
	IF(LSPAN(L,ISORT,IKAP,IPAN))THEN
	FJFH=CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)
     & *AAH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBJ(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPFP(IKAP1,IKAP,L,ISORT,ISPIN)*BBH(L,ISORT,IKAP,IPAN,ISPIN)    
     & +CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FFP(IKAP1,IKAP,L,ISORT,ISPIN)
     & *BBH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBJ(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPF(IKAP1,IKAP,L,ISORT,ISPIN)*AAH(L,ISORT,IKAP,IPAN,ISPIN)    
	OMTJH(IKAP1,IKAP,L,ISORT,ISPIN)=FJFH*GAM(L,ISORT)
	FJHFH=CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)
     & *BBH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBJ(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPF(IKAP1,IKAP,L,ISORT,ISPIN)*BBH(L,ISORT,IKAP,IPAN,ISPIN) 
	HMTJH(IKAP1,IKAP,L,ISORT,ISPIN)=FJHFH*GAM(L,ISORT)+
     &  ENY(L,ISORT,IKAP,IPAN,ISPIN)*OMTJH(IKAP1,IKAP,L,ISORT,ISPIN)
	ENDIF
	IF(LSPAN(L,ISORT,IKAP1,IPAN))THEN
	FHFJ=CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)
     & *AAJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBH(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPFP(IKAP1,IKAP,L,ISORT,ISPIN)*BBJ(L,ISORT,IKAP,IPAN,ISPIN)    
     & +CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FFP(IKAP1,IKAP,L,ISORT,ISPIN)
     & *BBJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBH(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPF(IKAP1,IKAP,L,ISORT,ISPIN)*AAJ(L,ISORT,IKAP,IPAN,ISPIN)
	OMTHJ(IKAP1,IKAP,L,ISORT,ISPIN)=FHFJ*GAM(L,ISORT)
	FHHFJ=CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)
     & *BBJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBH(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPF(IKAP1,IKAP,L,ISORT,ISPIN)*BBJ(L,ISORT,IKAP,IPAN,ISPIN) 
	HMTHJ(IKAP1,IKAP,L,ISORT,ISPIN)=FHHFJ*GAM(L,ISORT)+
     &  ENY(L,ISORT,IKAP,IPAN,ISPIN)*OMTHJ(IKAP1,IKAP,L,ISORT,ISPIN)
	ENDIF
C THREE-CENTER POTENTIAL PARAMETERS
	FJFJ=CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)
     & *AAJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBJ(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPFP(IKAP1,IKAP,L,ISORT,ISPIN)*BBJ(L,ISORT,IKAP,IPAN,ISPIN)
     & +CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FFP(IKAP1,IKAP,L,ISORT,ISPIN)
     & *BBJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBJ(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPF(IKAP1,IKAP,L,ISORT,ISPIN)*AAJ(L,ISORT,IKAP,IPAN,ISPIN)    
	FJHFJ=CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)
     & *BBJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBJ(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPF(IKAP1,IKAP,L,ISORT,ISPIN)*BBJ(L,ISORT,IKAP,IPAN,ISPIN)
	OMTJJ(IKAP1,IKAP,L,ISORT,ISPIN)=FJFJ*GAM(L,ISORT)*GAM(L,ISORT)
	HMTJJ(IKAP1,IKAP,L,ISORT,ISPIN)=FJHFJ*GAM(L,ISORT)*GAM(L,ISORT)+
     &  ENY(L,ISORT,IKAP,IPAN,ISPIN)*OMTJJ(IKAP1,IKAP,L,ISORT,ISPIN)
      ENDDO                                                    !!! over ikap
      ENDDO                                                    !!! over ikap1
      ENDDO                                                    !!! over l
1000  CONTINUE                                                 !!! over isort
2000	CONTINUE                                                 !!! over ispin
	END


	SUBROUTINE PRIPAR(IPAN)
*********************************************************
*  Prints potential parameters.                         *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,IDMF,NPFR              !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILST,ILSB
     &                      ,LRTV,NHSORT                           !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                            !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP,EK                     !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN,IATS,ISTS                 !!! from readini
      USE COM_SPHERE  ,ONLY: SMT,SASA,SWZ                          !!! from readini
      USE COM_INPTTR  ,ONLY: NDIV,NDIC,NDIVDIR,NDIR,PNTNOT         !!! from readini
      USE COM_INPPAR  ,ONLY: ENY,DNY,TNY,NODES,MNY                 !!! from readini
      USE COM_KKRPAR  ,ONLY: CNY,WNY,VNY                           !!! from kkrpar
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDC,NBNDT               !!! from readini
     &                      ,MBNDF,MBNDE,MBNDC                     !!! from bzint
      USE COM_LMTIND  ,ONLY: LMTIND                                !!! from lmtpar
      USE COM_KMESH   ,ONLY: NPNT,PNT                              !!! from makettr
      USE COM_FERMI   ,ONLY: EF                                    !!! from ttrints
      USE COM_LMTOUT  ,ONLY: ICPSI,PSIFILE,ICFAT,FATFILE           !!! from readini
     &                      ,ICDOS,DOSFILE,ICSCR,SCRFILE
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP                     !!! from readini
      USE COM_CHANNELS,ONLY: IUWFK,IUPSI,IUPUL,IUDOS,IUHAM         !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                           !!! from setup
      USE COM_MASHDEP ,ONLY: NVAL                                  !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	LOGICAL, ALLOCATABLE :: TPAN(:,:)
	CHARACTER TXTNY(0:3)*6,TL(0:3)*1,TN(9)*1
	LOGICAL LOG,FIRST,EXIST,OPEN
	SAVE FIRST
	DATA PI/3.141592653589793D0/,TL/'s','p','d','f'/,TN/'1','2'
     &      ,'3','4','5','6','7','8','9'/,TXTNY/'fix.E '
     &      ,'fix.D ','bind.E','center'/,FIRST/.TRUE./
C RETURN KEYS
C     none
      CALL ABORTNOW()
C MEMORY ALLOCATIONS
	ALLOCATE(TPAN(NSORTMEM,NKAPMEM))
C START CODE
	DO IKAP=1,NKAP(IPAN)
	DO IATOM=1,NATOM
	TPAN(IS(IATOM),IKAP)=.FALSE.
	DO L=0,ILSB(IS(IATOM))
	IF(LTPAN(L,IATOM,IKAP,IPAN))TPAN(IS(IATOM),IKAP)=.TRUE.
	ENDDO
	ENDDO
	ENDDO
C REDEFINE # OF BANDS 
	IF(MBNDF.NE.-1.AND.MBNDE.NE.-1.AND.MBNDC.NE.-1)THEN
	NBNDF(1)=MBNDF
	NBNDE(1)=MBNDE
	NBNDC(1)=MBNDC
	ENDIF
C **************************************************************
C OPEN FILE FOR WAVE COEFFICIENTS
	NRECL=0
	DO ISORT=1,NSORT  !!! estimate record lenght
	MAXLM=(ILST(ISORT)+1)**2+2*(ILSB(ISORT)+1)**2 
	NRECL=MAX(NRECL,NVAL*MAXLM*NATOM)
	ENDDO
	INQUIRE(FILE=SCRFILE(IUWFK),EXIST=EXIST,OPENED=OPEN)
	IF(.NOT.OPEN.AND.EXIST)
     &OPEN(UNIT=IUWFK,FILE=SCRFILE(IUWFK),STATUS='OLD',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECL)
	IF(EXIST)CLOSE(UNIT=IUWFK,STATUS='DELETE')
	OPEN(UNIT=IUWFK,FILE=SCRFILE(IUWFK),STATUS='NEW',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECL)
	IF(ICPSI.EQ.0.AND.IPAN.EQ.1)THEN ! storage is not necessary
	INQUIRE(FILE=SCRFILE(IUPSI),EXIST=EXIST,OPENED=OPEN)
	IF(.NOT.OPEN.AND.EXIST)
     &OPEN(UNIT=IUPSI,FILE=SCRFILE(IUPSI),STATUS='OLD',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECL)
	IF(EXIST)CLOSE(UNIT=IUPSI,STATUS='DELETE')
	OPEN(UNIT=IUPSI,FILE=SCRFILE(IUPSI),STATUS='NEW',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECL)
	ELSEIF(ICPSI.NE.0.AND.IPAN.EQ.1)THEN
	INQUIRE(FILE=PSIFILE,EXIST=EXIST,OPENED=OPEN)
	IF(.NOT.OPEN.AND.EXIST)
     &OPEN(UNIT=IUPSI,FILE=PSIFILE,STATUS='OLD',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECL)
	IF(EXIST)CLOSE(UNIT=IUPSI,STATUS='DELETE')
	OPEN(UNIT=IUPSI,FILE=PSIFILE,STATUS='NEW',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECL)
	ENDIF
C **************************************************************
C OPEN FILE FOR PULAY FORCES
      NRECL=NVAL*3*NATOM*2
      IF(NPFR.NE.0.AND.IPAN.EQ.1)THEN
	INQUIRE(FILE=SCRFILE(IUPUL),EXIST=EXIST,OPENED=OPEN)
	IF(.NOT.OPEN.AND.EXIST)
     &OPEN(UNIT=IUPUL,FILE=SCRFILE(IUPUL),STATUS='OLD',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECL)
	IF(EXIST)CLOSE(UNIT=IUPUL,STATUS='DELETE')
      OPEN(UNIT=IUPUL,FILE=SCRFILE(IUPUL),STATUS='NEW',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECL)
	ENDIF
C **************************************************************
C OPEN FILE FOR TLM-CHARACTERS
	IF((ICFAT.GT.0.OR.ICDOS.GT.0).AND.IPAN.EQ.1)THEN
	INQUIRE(FILE=SCRFILE(IUDOS),EXIST=EXIST,OPENED=OPEN)
	IF(.NOT.OPEN.AND.EXIST)
     &OPEN(UNIT=IUDOS,FILE=SCRFILE(IUDOS),STATUS='OLD',
     &ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
	IF(EXIST)CLOSE(UNIT=IUDOS,STATUS='DELETE')
	OPEN(UNIT=IUDOS,FILE=SCRFILE(IUDOS),STATUS='NEW',
     &ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
      ENDIF
C **************************************************************
C OPEN FILE FOR STORING HAMILTONIAN
	IF(IDMF.EQ.2.AND.IPAN.EQ.1)THEN
	NRECL=NVAL*2*NBNDT(1)*NBNDT(1)
	INQUIRE(FILE=SCRFILE(IUHAM),EXIST=EXIST,OPENED=OPEN)
	IF(.NOT.OPEN.AND.EXIST)
     &OPEN(UNIT=IUHAM,FILE=SCRFILE(IUHAM),STATUS='OLD',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECL)
	IF(EXIST)CLOSE(UNIT=IUHAM,STATUS='DELETE')
	OPEN(UNIT=IUHAM,FILE=SCRFILE(IUHAM),STATUS='NEW',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECL)
      ENDIF
C
	FIRST=.FALSE.
	DO ISPIN=1,NSPIN                          !!! over ispin
	IF(NSPIN.EQ.1)WRITE(IUN,1010)NKAP(IPAN),IPAN
	IF(NSPIN.EQ.2)WRITE(IUN,1015)NKAP(IPAN),TXTSP(ISPIN),IPAN
	DO ISORT=1,NSORT                          !!! over isort
	DO IKAP=1,NKAP(IPAN)                      !!! over ikap
	IF(ISTS(ISORT,IPAN).NE.0.AND.TPAN(ISORT,IKAP))
     &WRITE(IUN,1020)DREAL(EKAP(IKAP,IPAN)),TXTEL(ISORT)
	DO L=0,ILSB(ISORT)                        !!! over l
	MN=MNY(L,ISORT,IKAP,IPAN)
	NO=TNY(L,ISORT,IKAP,IPAN,ISPIN)+L+1
	IF(LSPAN(L,ISORT,IKAP,IPAN))
     &WRITE(IUN,1030)ENY(L,ISORT,IKAP,IPAN,ISPIN),
     &DNY(L,ISORT,IKAP,IPAN,ISPIN),CNY(L,ISORT,IKAP,IPAN,ISPIN),
     &WNY(L,ISORT,IKAP,IPAN,ISPIN),TN(NO)//TL(L),TXTNY(MN)
C	IF(.NOT.LSPAN(L,ISORT,IKAP,IPAN).AND.IPAN.EQ.1)
C    &WRITE(IUN,1040)ENY(L,ISORT,IKAP,IPAN,ISPIN),
C    &DNY(L,ISORT,IKAP,IPAN,ISPIN),TN(NO)//TL(L),TXTNY(MN)
	ENDDO                                     !!! over l
	ENDDO                                     !!! over ikap
	ENDDO                                     !!! over isort
	ENDDO                                     !!! over ispin
C MEMORY DEALLOCATIONS
	DEALLOCATE(TPAN)
1010  FORMAT(1X,I1,'kappa panel #',I2,
     &' : Band Structure Calculation of E(k) with :')
1015  FORMAT(1X,I1,'kappa spin-',A2,' panel #',I2,
     &' : Band Structure Calculation of E(k) with :')
1020  FORMAT('     Eny:    ','     Dny:    ','     Cny:    ',
     &       '     Wny:    ',' Et=',G10.3,A11)
1030  FORMAT(4(1X,G12.5),    ' for ',A2,'-state, ',A6)
1040  FORMAT(2(1X,G12.5),26X,' for ',A2,'-state, ',A6)
	END
