	SUBROUTINE SETFRS
******************************************************
*   Stores Fat Bands                                 *
******************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,LRWF,NPFR,IEXC    !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS       !!! from readini
     &                      ,ILST,ILSB,ILSV,LRTV,NHSORT
      USE COM_LATPAR  ,ONLY: PAR,ORTH,OMEGAC,STRAIN           !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_LATTICE ,ONLY: RBAS,GBAS,BBAS,AKBAS,ORIGIN      !!! from readstr
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC          !!! from readini
      USE COM_INPTTR  ,ONLY: NDIV,NDIC                        !!! from readstr
      USE COM_KMESH   ,ONLY: NPNT,PNT,WGT,IPQ,KCUT            !!! from makettr
      USE COM_FERMI   ,ONLY: EF                               !!! from ttrints
      USE COM_ENERGY  ,ONLY: EARR,WEIGH,WEIGD                 !!! from bands
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP                !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                  !!! from setup
      USE COM_CHANNELS,ONLY: IUAIN                            !!! from channels
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                      !!! from setup
      USE COM_LMTOUT                                          !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION CUBR(3,3),ORGR(3),PKT(3)
	LOGICAL EXIST,OPEN
	CHARACTER HELP*40
	DATA PI/3.141592653589793D0/
	IF(ICFRS.LE.0)RETURN
C STORE HEADER INFO.
	INQUIRE(FILE=FRSFILE,EXIST=EXIST)
	IF(EXIST)THEN
      OPEN(UNIT=IUAIN,FILE=FRSFILE,STATUS='OLD',FORM='FORMATTED')
	CLOSE(UNIT=IUAIN,STATUS='DELETE')
	ENDIF
	OPEN(UNIT=IUAIN,FILE=FRSFILE,STATUS='NEW',FORM='FORMATTED')
	WRITE(IUAIN,10010)
	WRITE(IUAIN,10020)
10010	FORMAT(1X,'<FILE=FRSFILE,INPUT=MODERN>')
10020 FORMAT('****************************************************')
	WRITE(IUAIN,10030)
10030 FORMAT(1X,'<SECTION=CTRL>               ! CONTROL PARAMETERS:')
	HELP='! Tetrahedron mesh                     '
	WRITE(IUAIN,10040)NDIV,HELP
10040 FORMAT(1X,'nDiv(:)=',I2,1X,I2,1X,I2,1X,12X,A40)
	HELP='! Tetrahedron mesh for weights         '
	WRITE(IUAIN,10050)NDIW,HELP
10050 FORMAT(1X,'nDiw(:)=',I2,1X,I2,1X,I2,1X,12X,A40)
	WRITE(IUAIN,10060)
10060 FORMAT(1X,'<SECTION=CUBE>               ! DRAWING CUBE:')
C APPLY STRAIN
      DO IVEC=1,3
      DO I=1,3
      CUBR(I,IVEC)=0.D0
      ORGR(I)=0.D0
      DO J=1,3
      CUBR(I,IVEC)=CUBR(I,IVEC)+BBAS(J,IVEC)*STRAIN(J,I,1)
      ORGR(I)=ORGR(I)+ORIGIN(J)*STRAIN(J,I,1)
	ENDDO
	ENDDO
	ENDDO
C ACCOUNT FOR ORTHOROMBICITY
      DO I=2,3
      DO IVEC=1,3
      CUBR(I,IVEC)=CUBR(I,IVEC)*ORTH(I)
	ENDDO
      ORGR(I)=ORGR(I)*ORTH(I)
	ENDDO
	DO IVEC=1,3
	WRITE(IUAIN,10070)(CUBR(I,IVEC),I=1,3)
	ENDDO
	WRITE(IUAIN,10070)(ORGR(I),I=1,3)
10070 FORMAT(1X,G14.7,1X,',',1X,G14.7,1X,',',1X,G14.7)
C STORE DOS DATA
	WRITE(IUAIN,10110)
10110 FORMAT(1X,'<SECTION=DATA>               ! FERMI SURFACE DATA:')
	NBND=NBNDT(1)
	NSPN=NSPIN
	IF(NORBS.EQ.2.AND.NSPIN.EQ.2)NBND=NBNDT(1)*NSPIN
	IF(NORBS.EQ.2.AND.NSPIN.EQ.2)NSPN=1
	WRITE(IUAIN,*)RBAS,GBAS,BBAS,NDIV,NBND,NSPN,KCUT
C DO OVER MICROCELLS
      DO I3=0,NDIV(3)
      DO I2=0,NDIV(2)
      DO I1=0,NDIV(1)
      PKT(1)=(I1*AKBAS(1,1,1)+I2*AKBAS(1,2,1)+I3*AKBAS(1,3,1))-ORIGIN(1)
      PKT(2)=(I1*AKBAS(2,1,1)+I2*AKBAS(2,2,1)+I3*AKBAS(2,3,1))-ORIGIN(2)
      PKT(3)=(I1*AKBAS(3,1,1)+I2*AKBAS(3,2,1)+I3*AKBAS(3,3,1))-ORIGIN(3)
	IPNT=IPQ(I1,I2,I3) ! irreducible point
	WRITE(IUAIN,10210)(PKT(I),I=1,3)
	DO IBNDS=1,NSPIN
	WRITE(IUAIN,10220)(EARR(IBNDS+NSPIN*(IBNDT-1),IPNT,1),
     &IBNDT=1,NBNDT(1))
	ENDDO
10210 FORMAT(3(1X,G12.5))
10220 FORMAT(5(1X,G12.5))
      ENDDO
      ENDDO
      ENDDO
	CLOSE(IUAIN)
	END SUBROUTINE SETFRS
