	SUBROUTINE MAKEGRP
************************************************************
*  Controls finding crystal group.                         *
************************************************************
C SET ARRAY-SIZE DATA
        USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_PARAM   ,ONLY : NATOM,NSORT,NSPIN,NORBS,IS   !!! from readini
     &                       ,ILST,ILSB,ILSV               !!! from readini
	USE COM_LATTICE ,ONLY : RBAS,TAO,TAU                 !!! from readstr
	USE COM_LATPAR  ,ONLY : PAR,PAR0,VV0                 !!! from readini
	USE COM_MAGDAT  ,ONLY : AXMAG                        !!! from readini
	USE COM_SPHERE  ,ONLY : ZNUC                         !!! from readini
	USE COM_LMTOUT  ,ONLY : ICKOV,KOVFILE,ICGRP,GRPFILE  !!! from readstr
	USE COM_GROUPS  ,ONLY : NGROUP,IKOV,IP,SHIFT,KELTAB  !!! from groups
	USE COM_LABELS  ,ONLY : TXTEL,TXTAT                  !!! from readini
	USE COM_UNIT    ,ONLY : IUN,IUR,IUT                  !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, ALLOCATABLE :: IS1(:)
	INTEGER, ALLOCATABLE :: IS2(:)
	INTEGER, ALLOCATABLE :: IP1(:,:)
	INTEGER, ALLOCATABLE :: IP2(:,:)
	INTEGER, ALLOCATABLE :: IPC1(:,:)
	INTEGER, ALLOCATABLE :: IPC2(:,:)
	INTEGER, ALLOCATABLE :: IPH1(:,:)
	INTEGER, ALLOCATABLE :: IPH2(:,:)
	INTEGER, ALLOCATABLE :: IRDIM(:)
	COMPLEX*16, ALLOCATABLE :: REPR(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: CHAR(:,:)
	CHARACTER SYS*1,FSYS*1,RFILE(0:48,4)*40,TS(3)*8,TDPS*8
     &    ,TCPS*19,TC(4)*19
	CHARACTER*150, ALLOCATABLE :: GRPDATA(:)
      DATA PI/3.141592653589793D0/,EPS/1.D-05/
C ********************************
C ANALYZE POINT GROUP
	WRITE(IUN,1010)
1010	FORMAT(1X,'Start analyzing crystal group from input data:'/)
C Set pointer according to Znuc
	ALLOCATE(IS1(NATOMMEM))
	DO IATOM=1,NATOM
	IS1(IATOM)=0
	ENDDO
	ISORT1=0
	DO IATOM=1,NATOM
	IF(IS1(IATOM).EQ.0)THEN
	ISORT1=ISORT1+1
	DO JATOM=1,NATOM
	IF(ABS(ZNUC(IS(JATOM))-ZNUC(IS(IATOM))).LE.1.D-10)THEN
	IS1(IATOM)=ISORT1
	IS1(JATOM)=ISORT1
	ENDIF
	ENDDO
	ENDIF
	ENDDO
	NSORT1=ISORT1 ! # of sorts according to Znuc
C APPLY CUBIC SYSTEM 
C Pure lattice
      CALL WIGMAT(2,'C',KOVFILE)
      CALL GROUPS(RBAS,TAU,IS1,2,NATOM,NSORT,NSPIN,NORBS,AXMAG,EPS)
	NC1=NGROUP
	ALLOCATE(IPC1(NATOMMEM,NC1))
	DO IATOM=1,NATOM
	DO IR=1,NC1
	IPC1(IATOM,IR)=IP(IATOM,IR)
	ENDDO
	ENDDO
C Lattice with atoms
      CALL WIGMAT(2,'C',KOVFILE)
      CALL GROUPS(RBAS,TAU,IS,2,NATOM,NSORT,NSPIN,NORBS,AXMAG,EPS)
	NC2=NGROUP
	ALLOCATE(IPC2(NATOMMEM,NC2))
	DO IATOM=1,NATOM
	DO IR=1,NC2
	IPC2(IATOM,IR)=IP(IATOM,IR)
	ENDDO
	ENDDO
C APPLY HEXAGONAL SYSTEM 
C Pure lattice
      CALL WIGMAT(2,'H',KOVFILE)
      CALL GROUPS(RBAS,TAU,IS1,2,NATOM,NSORT,NSPIN,NORBS,AXMAG,EPS)
	NH1=NGROUP
	ALLOCATE(IPH1(NATOMMEM,NH1))
	DO IATOM=1,NATOM
	DO IR=1,NH1
	IPH1(IATOM,IR)=IP(IATOM,IR)
	ENDDO
	ENDDO
C Lattice with atoms
      CALL WIGMAT(2,'H',KOVFILE)
      CALL GROUPS(RBAS,TAU,IS,2,NATOM,NSORT,NSPIN,NORBS,AXMAG,EPS)
	NH2=NGROUP
	ALLOCATE(IPH2(NATOMMEM,NH2))
	DO IATOM=1,NATOM
	DO IR=1,NH2
	IPH2(IATOM,IR)=IP(IATOM,IR)
	ENDDO
	ENDDO
	WRITE(IUN,1020)
	WRITE(IUN,1030)NC1,NH1
	WRITE(IUN,1040)NC2,NH2
1020	FORMAT(1X,'Rotational systems ---> Cubic   Hexagonal ')
1030	FORMAT(1X,'Pure  lattice   group :',I3,9X,I3)
1040	FORMAT(1X,'Operations with atoms :',I3,9X,I3) 
C SELECT OPTIMUM
      IF(ICKOV.EQ.0)SYS=' '
      IF(ICKOV.EQ.1)SYS='C'
      IF(ICKOV.EQ.2)SYS='H'
      IF(ICKOV.EQ.3)SYS='A'
	IF(NC2.GT.NH2)FSYS='C'
	IF(NH2.GT.NC2)FSYS='H'
	IF(NC2.EQ.NH2)FSYS='C'
	IF(ICKOV.EQ.0)SYS=FSYS
	IF(FSYS.NE.SYS.AND.SYS.NE.'A')THEN
	WRITE(IUN,*)'CHECK INPUT ROTATIONAL SYSTEM!'
	WRITE(IUN,*)'Found rotational system:'//FSYS
	WRITE(IUN,*)'Input rotational system:'//SYS
	ENDIF
	IF(FSYS.EQ.'C')NGRP1=NC1
	IF(FSYS.EQ.'C')NGRP2=NC2
	IF(FSYS.EQ.'H')NGRP1=NH1
	IF(FSYS.EQ.'H')NGRP2=NC2
	ALLOCATE(IP1(NATOMMEM,NGRP1))
	ALLOCATE(IP2(NATOMMEM,NGRP2))
	IF(FSYS.EQ.'C')THEN
	DO IATOM=1,NATOM
	DO IR=1,NGRP1
	IP1(IATOM,IR)=IPC1(IATOM,IR)	
	ENDDO
	DO IR=1,NGRP2
	IP2(IATOM,IR)=IPC2(IATOM,IR)	
	ENDDO
	ENDDO
	ELSEIF(FSYS.EQ.'H')THEN
	DO IATOM=1,NATOM
	DO IR=1,NGRP1
	IP1(IATOM,IR)=IPH1(IATOM,IR)	
	ENDDO
	DO IR=1,NGRP2
	IP2(IATOM,IR)=IPH2(IATOM,IR)	
	ENDDO
	ENDDO
	ENDIF
C CHECK OPERATIONS WITH ATOMS
	ALLOCATE(IS2(NATOMMEM))
	DO IATOM=1,NATOM
	IS2(IATOM)=0
	ENDDO
	ISORT2=0
	DO IATOM=1,NATOM
	IF(IS2(IATOM).EQ.0)THEN
	ISORT2=ISORT2+1
	DO IR=1,NGRP1
	IF(IS1(IP1(IATOM,IR)).EQ.IS1(IATOM))THEN
	IS2(IP1(IATOM,IR))=ISORT2
	ENDIF
	ENDDO
	ENDIF
	ENDDO
	NSORT2=ISORT2 ! # of sorts according to the group symmetry
C PRINT INFORMATION
	WRITE(IUN,1100)
C Printout # 1
	WRITE(IUN,1110)NSORT1
	DO ISORT1=1,NSORT1
	WRITE(IUN,1140)ISORT1
	DO IATOM=1,NATOM
	IF(IS1(IATOM).EQ.ISORT1)WRITE(IUN,1150)
     &IATOM,(TAU(I,IATOM),I=1,3),TXTAT(IS(IATOM))
	ENDDO
	ENDDO
C Printout # 2
	WRITE(IUN,1120)NSORT2
	DO ISORT2=1,NSORT2
	WRITE(IUN,1140)ISORT2
	DO IATOM=1,NATOM
	IF(IS2(IATOM).EQ.ISORT2)WRITE(IUN,1150)
     &IATOM,(TAU(I,IATOM),I=1,3),TXTAT(IS(IATOM))
	ENDDO
	ENDDO
C Printout # 3
	WRITE(IUN,1130)NSORT
	DO ISORT=1,NSORT
	WRITE(IUN,1140)ISORT
	DO IATOM=1,NATOM
	IF(IS(IATOM).EQ.ISORT)WRITE(IUN,1150)
     &  IATOM,(TAU(I,IATOM),I=1,3),TXTAT(IS(IATOM))
	ENDDO
	ENDDO
1100	FORMAT(/1X,'Classifying atoms over different sorts :')
1110	FORMAT(/1X,'PRINTOUT # 1'/,
     &  ' # of sorts according to input  nuclear charges:',I4)
1120	FORMAT(/1X,'PRINTOUT # 2'/,
     &  ' # of sorts according to  lattice  group  found:',I4)
1130	FORMAT(/1X,'PRINTOUT # 3'/,
     &  ' # of sorts read from input  data  file INIFILE:',I4)
1140	FORMAT(1X,'SORT ',I4,'; the following atoms are equivalent:')
1150	FORMAT(1X,'Atom ',I4,'; (',G12.5,',',G12.5,',',G12.5,') :',A10)
C WRITE WARNING
	IF(NSORT2.NE.NSORT)THEN
	WRITE(IUN,*)'Warning message from <MAKEGRP>:'
	WRITE(IUN,*)'It is not necessarily true that sorting due to'
	WRITE(IUN,*)'lattice group (printout # 2 above) gives exact'
	WRITE(IUN,*)'classification of atoms over different sorts'
	WRITE(IUN,*)'since sorting was done according to Znuc and'
	WRITE(IUN,*)'symmetry operations. This sorting does not'
	WRITE(IUN,*)'take into account the difference caused by, e.g.'
	WRITE(IUN,*)'magnetic structure. However, since sorting read'
	WRITE(IUN,*)'from INIFILE (printout # 3) is different from'
	WRITE(IUN,*)'printout # 2, it is recommended to check input'
	WRITE(IUN,*)'IS(iatom) array.'
	ENDIF
C CALCULATE FINAL TRANSFORMATION MATRICES
      CALL WIGMAT(LMAXCMEM,SYS,KOVFILE)
      CALL GROUPS(RBAS,TAU,IS,LMAXCMEM,NATOM,NSORT,NSPIN,
     &NORBS,AXMAG,EPS)
      WRITE(IUN,1200)NGROUP
	IF(SYS.EQ.'C')WRITE(IUN,1210)SYS
	IF(SYS.EQ.'H')WRITE(IUN,1220)SYS
1200  FORMAT(/1X,'Group elements discovered for lattice :',I4)
1210  FORMAT( 1X,'Cubic rotational system  is  selected :',3X,A1/)
1220  FORMAT( 1X,'Hexagonal rotational  system is  used :',3X,A1/)
C COMPUTE IRREDUCIBLE REPRESENTATIONS AND THEIR CHARACTERS
      ALLOCATE(KELTAB(NGROUP,NGROUP))
      CALL KELITAB              !!! calculate Keli table
	IF(NGROUP.LE.48)THEN
	ALLOCATE(IRDIM(48))
	ALLOCATE(CHAR(NGROUP,48))
	ALLOCATE(REPR(6,6,NGROUP,48))
	NRP=0
 	CALL RPR48(NGROUP,KELTAB,NRP,IRDIM,CHAR,REPR)
 	WRITE(IUN,1230)NRP
	DO IRP=1,NRP
	WRITE(IUN,1240)IRP,IRDIM(IRP)
C	WRITE(IUN,1250)
	DO IR4=1,NGROUP/4
	DO I=1,4
	IR=I+4*(IR4-1)
	TC(I)=TCPS(CHAR(IR,IRP),1.D-05)
	ENDDO
C	WRITE(IUN,1260)(TC(I),I=1,4)
	ENDDO
	ENDDO
	DEALLOCATE(IRDIM,CHAR,REPR)
1230	FORMAT(/1X,'# of irreducible representations found:',I4)
1240	FORMAT( 1X,I2,'th  representation , dimension found:',I4)
1250	FORMAT( 1X,I2,'Characters table follows --------------->')
1260	FORMAT( 1X,4(A19,1X))
	ENDIF
C STORE GROUP FILE
      IF(ICGRP.GT.0)THEN
      IF(FSYS.EQ.'C')CALL DATACUB(RFILE)
      IF(FSYS.EQ.'H')CALL DATAHEX(RFILE)
      IF(FSYS.EQ.'A')CALL DATAARB(RFILE,KOVFILE)
      OPEN(UNIT=3,FILE=GRPFILE,STATUS='NEW',FORM='FORMATTED')
	WRITE(3,1310)
	WRITE(3,1320)
	WRITE(3,1330)
	WRITE(3,1340)FSYS
	WRITE(3,1350)NGROUP
	WRITE(3,1360)
	DO IR=1,NGROUP
	IG=IKOV(IR)
	WRITE(3,1365)
	IF(RFILE(IG,1).EQ.'U')THEN
	WRITE(3,1370)RFILE(IG,1)
	WRITE(3,1380)RFILE(IG,2)
	WRITE(3,1390)'0,0,0                                   '
	WRITE(3,1400)'0*pi                                    '
	WRITE(3,1410)'n'
	TS(1)=TDPS(SHIFT(1,IR),1.D-05)
	TS(2)=TDPS(SHIFT(2,IR),1.D-05)
	TS(3)=TDPS(SHIFT(3,IR),1.D-05)
	WRITE(3,1420)TS(1)//','//TS(2)//','//TS(3)
	ELSEIF(RFILE(IG,1).EQ.'A'.OR.RFILE(IG,1).EQ.'Z')THEN
      WRITE(3,1370)RFILE(IG,1)
      WRITE(3,1380)RFILE(IG,2)
      WRITE(3,1390)RFILE(IG,4)
      WRITE(3,1400)RFILE(IG,3)
      WRITE(3,1410)'n'
      TS(1)=TDPS(SHIFT(1,IR),1.D-05)
      TS(2)=TDPS(SHIFT(2,IR),1.D-05)
      TS(3)=TDPS(SHIFT(3,IR),1.D-05)
      WRITE(3,1420)TS(1)//','//TS(2)//','//TS(3)
	ELSEIF(RFILE(IG,1).EQ.'I')THEN
      WRITE(3,1370)RFILE(IG,1)
      WRITE(3,1380)RFILE(IG,2)
      WRITE(3,1390)'0,0,0                                   '
      WRITE(3,1400)'0*pi                                    '
      WRITE(3,1410)'y'
      TS(1)=TDPS(SHIFT(1,IR),1.D-05)
      TS(2)=TDPS(SHIFT(2,IR),1.D-05)
      TS(3)=TDPS(SHIFT(3,IR),1.D-05)
      WRITE(3,1420)TS(1)//','//TS(2)//','//TS(3)
	ELSEIF(RFILE(IG,1).EQ.'C')THEN
      WRITE(3,1370)RFILE(IG,1)
      WRITE(3,1380)RFILE(IG,2)
	READ(RFILE(IG,3),*)IGINV,IGOPR
      WRITE(3,1390)RFILE(IGOPR,4)
      WRITE(3,1400)RFILE(IGOPR,3)
      WRITE(3,1410)'y'
      TS(1)=TDPS(SHIFT(1,IR),1.D-05)
      TS(2)=TDPS(SHIFT(2,IR),1.D-05)
      TS(3)=TDPS(SHIFT(3,IR),1.D-05)
      WRITE(3,1420)TS(1)//','//TS(2)//','//TS(3)
	ENDIF
	ENDDO
      CLOSE(3)
C ********************************
C UNDERSTAND THE LENGHT OF STRFILE
      CALL FILE_LENGHT(GRPFILE,NLEN)
      ALLOCATE(GRPDATA(NLEN))
C ********************************
C READ STRFILE TO INTERNAL FILE
      OPEN(UNIT=3,FILE=GRPFILE,STATUS='OLD',FORM='FORMATTED')
      DO ILEN=1,NLEN
      READ(3,FMT='(A150)')GRPDATA(ILEN)
      ENDDO
      CLOSE(3)
C APPLY FORMATTING
      CALL READINI_OVWR(GRPFILE,GRPDATA,NLEN)
	DEALLOCATE(GRPDATA)
      ENDIF
1310	FORMAT('<FILE=GRPFILE,INPUT=MODERN>')
1320	FORMAT('*******************************************************')
1330	FORMAT('<SECTION=CTRL>', ' ! Control parameters')
1340	FORMAT(1X,'fSys = ',A1,  ' ! Rotational system, Cubic/Hexagonal')
1350	FORMAT(1X,'nSys =' ,I3,  ' ! # of elements found               ')
1360	FORMAT('<SECTION=ELEM>', ' ! Group elements                    ')
1365	FORMAT('****  Element description                              ')
1370	FORMAT(1X,'Oper = ',A40, ' ! Unit/Arb.axis/Z-axis/Combined     ')
1380	FORMAT(1X,'iKov = ',A40, ' ! Kovalev element                   ')
1390	FORMAT(1X,'Axis = ',A40, ' ! Rotational axis                   ')
1400	FORMAT(1X,'Angle= ',A40, ' ! Angle                             ')
1410	FORMAT(1X,'Inv  = ',A1 , ' ! Inversion [y/n]                   ')
1420	FORMAT(1X,'Shift= ',A26, ' ! Non-symmorphic shift              ')
C MEMORY DEALLOCATIONS
	DEALLOCATE(IS1)
	DEALLOCATE(IS2)
	DEALLOCATE(IP1)
	DEALLOCATE(IP2)
	DEALLOCATE(IPC1)
	DEALLOCATE(IPC2)
	DEALLOCATE(IPH1)
	DEALLOCATE(IPH2)
	END SUBROUTINE MAKEGRP
