	SUBROUTINE MAKESCF
**************************************************
* Prepares initial charge density file by using  *
* Mattheiss prescription.                        *
**************************************************
C SET ARRAY SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY: IASA,LRWF                        !!! from readini
	USE COM_LMTINP  ,ONLY: PROJECT,INPINFO,SCSFILE,SCSMADE,SCFMADE ! init
	USE COM_EXTENS  ,ONLY: EXTNSCS,LENEXTN                  !!! from setup
	USE COM_LMTOUT  ,ONLY: ICSCF,SCFFILE                    !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,ILST,ILSV,IS   !!! from readini
      USE COM_SPHERE  ,ONLY: ZNUC,SMT,SASA,SWZ                !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                       !!! from readini
      USE COM_LATTICE ,ONLY: RBAS,TAU                         !!! from readstr
	USE COM_DENDAT  ,ONLY: RHO,RHOCOR,RHOPS                 !!! from makescf
	USE COM_PLWMESH ,ONLY: NPLW,GPLW                        !!! from makeplw
	USE COM_RADMESH ,ONLY: NRAD,H,R,DR,RL,WEIGHT            !!! from makerad
      USE COM_LIBMESH ,ONLY: NLIB,HLIB,RLIB,DRLIB             !!! from libmesh
	USE COM_SYMMLM  ,ONLY: NSYM,LMSYM,SYM                   !!! from readini
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,ELEMENT,NAMEDENS     !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                      !!! from readini
      USE COM_MASHDEP ,ONLY: LENCMP,LENREL,LENINT             !!! from readini
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, INTRINSIC :: SIZE
      REAL*8, ALLOCATABLE :: RHOATOM(:,:)
      REAL*8, ALLOCATABLE :: WORK1(:)
      REAL*8, ALLOCATABLE :: WORK2(:)
      CHARACTER FILE*130,INF*130,TDP*10,SPR*10
	COMPLEX*16 GINT
      LOGICAL EXIST,PRESENT
      DATA PI/3.141592653589793D0/
	IF(IASA.EQ.0)RETURN
C CHECK INPINFO
      INF=INPINFO
      CALL SUBSTR_IN_STR(PRESENT,INF,130,EXTNSCS,LENEXTN)
      IF(.NOT.PRESENT)CALL MAKESCF_MESG00
C SET FILE NAME
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNSCS,60,NBE)
      SCSFILE=PROJECT(:NBP)//'.'//EXTNSCS(:NBE)
C CHECK WHETHER SCSFILE EXISTS
	INQUIRE(FILE=SCSFILE,EXIST=EXIST)
	IF(EXIST)SCSMADE=.FALSE.
	IF(EXIST)RETURN
	SCSMADE=.TRUE.
	SCFMADE=.FALSE.
      WRITE(IUN,1010)
1010  FORMAT(1X,'Start building initial charge density:'/)
C ****************************************************
C MEMORY ALLOCATIONS FOR SCRATCH ARRAYS
      ALLOCATE(RHOATOM(0:NLIBMEM,NSORTMEM))
      SIZE_RHOATOM=DBLE(SIZE(RHOATOM)*LENREL)/1024.D0**2
      CURMEM=CURMEM+SIZE_RHOATOM
      ALLOCATE(WORK1(0:MAX(NLIBMEM,NRADMEM)))
      ALLOCATE(WORK2(0:MAX(NLIBMEM,NRADMEM)))
C INITIALIZE CRYSTAL DENSITIES
 	CALL RHOFILES(4,'!','A')
C READ ATOMIC DENSITIES
      DO 1000 ISORT=1,NSORT                   !!! over atoms
      NUCZ=NINT(ZNUC(ISORT))
      CALL FIND_LBLANK(NAMEDENS,130,NBL)
      FILE=NAMEDENS(1:NBL)//ELEMENT(NUCZ)
      INQUIRE(FILE=FILE,EXIST=EXIST)
      IF(.NOT.EXIST)CALL MAKESCF_MESG01
      OPEN(UNIT=1,FILE=FILE,STATUS='OLD',FORM='FORMATTED')
      READ(1,*)
      READ(1,*)JC,JM,NLIBC
      IF(NLIBC.NE.NLIB)CALL MAKESCF_MESG03
      READ(1,*)(RHOATOM(IRAD,ISORT),IRAD=1,NLIB)
      CLOSE(1)
C INTERPOLATE TO THE NUCLEUS
      RHOATOM(0,ISORT)=RHOATOM(1,ISORT)
C CHECK CHARGE
      DO IRAD=0,NLIB
      WORK1(IRAD)=RHOATOM(IRAD,ISORT)*4.D0*PI*RLIB(IRAD,ISORT)**2*
     &DRLIB(IRAD,ISORT)
      ENDDO
      CALL QD(HLIB(ISORT),WORK1,WORK2,NLIB)
      CHARGE=WORK2(NLIB-1)
C PRINT CHARGE
      CALL FIND_LBLANK(FILE,130,NBL)
      WRITE(IUN,1020)ZNUC(ISORT),CHARGE,TXTEL(ISORT),FILE(1:NBL)
1020  FORMAT(1X,'Charge checking: ',G12.5,1X,G12.5,1X,A10,';',A)
1000  CONTINUE                               !!! over atoms
C ***********************************************************
C BUILD CRYSTAL DENSITY WITHIN MTS
	CALL MAKESCF_SMTS(RHOATOM,NLIBMEM,NATOMMEM)
C BULID CRYSTAL DENSITY IN THE INTERSTITIALS
 	CALL MAKESCF_SINT(RHOATOM,NLIBMEM,NATOMMEM)
C ***********************************************************
C CRYSTAL DENSITIES DONE, SEE NORMALIZATION CONSTANTS
      ZMTS=0.D0
      ZTOT=0.D0
	OMEGAM=0.D0
      DO IATOM=1,NATOM                   !!! over atoms
      ISORT=IS(IATOM)
C Find charges within MTs
	DO ISPIN=1,NSPIN
      DO IRAD=0,NRAD(ISORT)
      WORK1(IRAD)=DREAL(RHO(IRAD,1,IATOM,ISPIN,1))*
     &WEIGHT(IRAD,ISORT)/SQRT(4.D0*PI)
	ENDDO
      CALL QD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
      ZMTS=ZMTS+WORK2(NRAD(ISORT))
	ENDDO
	OMEGAM=OMEGAM+4.D0/3.D0*PI*SMT(ISORT)**3
      ZTOT=ZTOT+ZNUC(ISORT)
      ENDDO                                 !!! over atoms
	OMEGAI=OMEGAC-OMEGAM
C Find pseudocharge
      ZINT=0.D0
	IF(IASA.EQ.2)THEN
      DO IPLW=0,NPLW
      CALL MAKEPLW_SINT(GPLW(1,IPLW),GPLW(2,IPLW),GPLW(3,IPLW),GINT)
	DO ISPIN=1,NSPIN
      ZINT=ZINT+RHOPS(IPLW,ISPIN,1)*GINT
	ENDDO
	ENDDO
	ELSEIF(IASA.EQ.1)THEN
	DO ISPIN=1,NSPIN
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	ZINT=ZINT+RHO(NRAD(ISORT),1,IATOM,ISPIN,1)/SQRT(4.D0*PI)*
     &4.D0*PI/3.D0*(SASA(ISORT)**3-SMT(ISORT)**3)
	ENDDO
	ENDDO
	ENDIF
      ZTTL=ZMTS+ZINT
      ANORM=ZTOT/ZTTL
      WRITE(IUN,1110)ZTOT
      WRITE(IUN,1120)ZTTL
      WRITE(IUN,1130)ANORM
	WRITE(IUN,1140)ZINT
1110  FORMAT(1X,'Charge in elementary cell must be ',G14.7)
1120  FORMAT(1X,'Charge  found in elementary  cell ',G14.7)
1130  FORMAT(1X,'Renormalization of the density is ',G14.7)
1140  FORMAT(1X,'Charge in the interstitial region ',G14.7/)
C RENORMALZATIONS
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO ISPIN=1,NSPIN
	DO IRAD=0,NRAD(ISORT)
	RHO(IRAD,1,IATOM,ISPIN,1)=RHO(IRAD,1,IATOM,ISPIN,1)*ANORM
	ENDDO
	ENDDO
	ENDDO
	IF(IASA.EQ.2)THEN
	DO ISPIN=1,NSPIN
	DO IPLW=0,NPLW
	RHOPS(IPLW,ISPIN,1)=RHOPS(IPLW,ISPIN,1)*ANORM
	ENDDO
	ENDDO
	ENDIF
C ALL CALCULATIONS DONE. STORE CHARGE DENSITY
	FILE=SCFFILE    !! save temporarily name
	I=ICSCF         !! save temporarily case
	ICSCF=2
	SCFFILE=SCSFILE !! reassign name
 	CALL RHOFILES(4,'W','D')
	SCFFILE=FILE    !! put it back 
	ICSCF=I
C CHECK POTENTIAL KEY
	IF(LRWF.EQ.0.AND.SCSMADE)THEN
	WRITE(IUT,*)'Warning from <MAKESCF>:'
	WRITE(IUT,*)'Since initial density is just made, no frozing'
	WRITE(IUT,*)'potential key LRWF=0 avaiable. LRWF is set to 2,'
	WRITE(IUT,*)'i.e. to fully adjusted potential.' 
	LRWF=2
	ENDIF
C MEMORY DEALLOCATIONS
      DEALLOCATE(RHOATOM)
      DEALLOCATE(WORK1)
      DEALLOCATE(WORK2)
	CURMEM=CURMEM-SIZE_RHOATOM
C ERROR HANDLINGS
      CONTAINS
      SUBROUTINE MAKESCF_MESG00
      WRITE(IUT,*)'Terminated in <MAKESCF>:'
      WRITE(IUT,*)
     &'SCSFILE identificator << '//EXTNSCS(1:LENEXTN)//' >>'
      WRITE(IUT,*)'is not found in INPINFO string.'
      CALL FULLSTOP(' ')
      END SUBROUTINE MAKESCF_MESG00
      SUBROUTINE MAKESCF_MESG01
      WRITE(IUT,*)'Terminated in <MAKESCF>:'
      WRITE(IUT,*)'Atomic density file ',FILE
      WRITE(IUT,*)'cannot be found. Check path to the atomic data'
      WRITE(IUT,*)'library specified in <SETUP> subroutine.'
      CALL FULLSTOP(' ')
      END SUBROUTINE MAKESCF_MESG01
      SUBROUTINE MAKESCF_MESG02(CHARV,LSIZE)
      CHARACTER CHARV*(*)
      WRITE(IUT,*)'Terminated in <MAKESCF>:'
      WRITE(IUT,*)'Memory allocation problem detected from'
      WRITE(IUT,*)'the system. Complex array '//CHARV//' of the size:'
      WRITE(IUT,*) DBLE(LSIZE*LENCMP)/1024.D0**2,' Mbyte'
      WRITE(IUT,*)'cannot be allocated.'
      CALL FULLSTOP(' ')
      END SUBROUTINE MAKESCF_MESG02
      SUBROUTINE MAKESCF_MESG03
      WRITE(IUT,*)'Terminated in <MAKESCF>:'
      WRITE(IUT,*)'# of radial points in atomic density file ',FILE
      WRITE(IUT,*)'does not coincide with array declaration.'
      WRITE(IUT,*)'Declared # =',NLIB,'; # read =',NLIBC
      CALL FULLSTOP(' ')
      END SUBROUTINE MAKESCF_MESG03
      END SUBROUTINE MAKESCF



	SUBROUTINE MAKESCF_SMTS(RHOATOM,NLIBPAS,NATOMPAS)
************************************************************
*   Finds charge density according to Mattheiss procedure. *
************************************************************
C SET ARRAY SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                           !!! from setup
      USE COM_PARAM,   ONLY : NATOM,NSORT,NSPIN,ILST,ILSV,IS   !!! from readini
      USE COM_SPHERE,  ONLY : ZNUC,SMT                         !!! from readini
      USE COM_LATPAR,  ONLY : PAR,OMEGAC                       !!! from readini
      USE COM_LATTICE, ONLY : RBAS,TAU                         !!! from readstr
	USE COM_DENDAT,  ONLY : RHO,RHOCOR                       !!! from makescf
      USE COM_SITEGEN, ONLY : NSITES,SITES,IREFSITES           !!! from sitegen
	USE COM_RADMESH, ONLY : NRAD,H,R,DR,RL,WEIGHT            !!! from makerad
      USE COM_LIBMESH, ONLY : NLIB,HLIB,RLIB,DRLIB             !!! from libmesh
	USE COM_SYMMLM,  ONLY : NSYM,LMSYM,SYM                   !!! from readini
      USE COM_UNIT    ,ONLY : IUN,IUR,IUT                      !!! from readini
      USE COM_MASHDEP, ONLY : LENCMP,LENREL,LENINT             !!! from readini
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, INTRINSIC :: SIZE
	REAL*8 RHOATOM(0:NLIBPAS,NATOMPAS)
C Allocatable arrays
      INTEGER, ALLOCATABLE :: NSIT(:)
      INTEGER, ALLOCATABLE :: IRSIT(:,:)
	INTEGER, ALLOCATABLE :: MINRAD(:)
	INTEGER, ALLOCATABLE :: MAXRAD(:)
      REAL*8,  ALLOCATABLE :: DELTA(:,:)
	REAL*8,  ALLOCATABLE :: DERIV(:,:,:)
	REAL*8,  ALLOCATABLE :: DEROUT(:,:)
	REAL*8,  ALLOCATABLE :: DERIN(:,:)
	REAL*8,  ALLOCATABLE :: FDERIV(:,:)
	REAL*8,  ALLOCATABLE :: WORK0(:,:)
	REAL*8,  ALLOCATABLE :: WORK1(:,:)
	REAL*8,  ALLOCATABLE :: WORK2(:)
	REAL*8,  ALLOCATABLE :: WORK3(:,:)
	REAL*8,  ALLOCATABLE :: WORK4(:,:)
	REAL*8,  ALLOCATABLE :: RHONEW(:)
	REAL*8,  ALLOCATABLE :: RNEW(:)
	REAL*8,  ALLOCATABLE :: ANSW(:)
	REAL*8,  ALLOCATABLE :: POL(:)
	REAL*8,  ALLOCATABLE :: TAUT(:,:)
	COMPLEX*16, ALLOCATABLE :: YLM(:)
      COMPLEX*16, ALLOCATABLE :: RHOLIB(:,:,:)
      COMPLEX*16, ALLOCATABLE :: WD(:,:,:)
	COMPLEX*16 CL,DL,DRODR,DIML
      DATA PI/3.141592653589793D0/,C2/0.000013312838D0/
	SQPI4=SQRT(4.D0*PI)
C MEMORY ALLOCATIONS FOR SCRATCH ARRAYS
	ALLOCATE(TAUT(3,NATOMMEM))
	ALLOCATE(YLM(LIMVMEM))
	ALLOCATE(NSIT(NATOMMEM))
C GET #  OF CLUSTER SITES
      RMAX=10.D0/PAR+1.D-05
 100	NSITMEM=-1
      DO IATOM=1,NATOM
      DO JATOM=1,NATOM
      DO I=1,3
      TAUT(I,JATOM)=TAU(I,JATOM)-TAU(I,IATOM)
      ENDDO
      ENDDO
      CALL SITEGEN(RMAX,RBAS,TAUT,NATOM)
	IF(NSITES.EQ.0)CALL MAKESCF_MESG01
	IF(NSITES.EQ.0)GOTO 100
      NSITMEM=MAX(NSITES,NSITMEM)
      DEALLOCATE(SITES)
      DEALLOCATE(IREFSITES)
      ENDDO
C MEMORY ALLOCATIONS FOR SCRATCH ARRAYS
	ALLOCATE(IRSIT(NSITMEM,NATOMMEM))
	ALLOCATE(DELTA(NSITMEM,NATOMMEM))
	ALLOCATE(WD(NSITMEM,NSYMMEM,NATOMMEM))
C GET CLUSTER SITES
      DO 2000 IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO JATOM=1,NATOM
      DO I=1,3
      TAUT(I,JATOM)=TAU(I,JATOM)-TAU(I,IATOM)
	ENDDO
	ENDDO
      CALL SITEGEN(RMAX,RBAS,TAUT,NATOM)
C SORT VECTORS ACCORDING TO THEIR LENGTH
      ISN=0
      DO 1000 ISITES=0,NSITES
      DELS=SQRT(SITES(1,ISITES)**2+SITES(2,ISITES)**2+
     &          SITES(3,ISITES)**2)
      IF(ABS(DELS).LE.1.D-10)GOTO1000
      DELX=SITES(1,ISITES)/DELS
      DELY=SITES(2,ISITES)/DELS
      DELZ=SITES(3,ISITES)/DELS
C FIND SPHERICAL HARMONICS (WIGNER'S MATRICES WHEN M=0)
      CALL SPHHARM(DELX,DELY,DELZ,ILSV(ISORT),YLM)
      KEY=1
C COMPARE WITH PREVIOUS VECTORS
      DO JSN=1,ISN
      IF(DELTA(JSN,IATOM).EQ.DELS*PAR.AND.IRSIT(JSN,IATOM).EQ.
     &IREFSITES(ISITES))THEN
      KEY=0
      DO LM=1,(ILSV(ISORT)+1)**2
      IF(SYM(LM,IATOM))THEN
      ISYM=LMSYM(LM,IATOM)
      WD(JSN,ISYM,IATOM)=WD(JSN,ISYM,IATOM)+CONJG(YLM(LM))
      ENDIF
	ENDDO
      GOTO 1000
      ENDIF
	ENDDO
      IF(KEY.NE.1)GOTO 1000
C IF NONE ADD TO ARRAY
      ISN=ISN+1
      DELTA(ISN,IATOM)=DELS*PAR
      DO LM=1,(ILSV(ISORT)+1)**2
      IF(SYM(LM,IATOM))THEN
      ISYM=LMSYM(LM,IATOM)
      WD(ISN,ISYM,IATOM)=CONJG(YLM(LM))
      ENDIF
	ENDDO
      IRSIT(ISN,IATOM)=IREFSITES(ISITES)
1000  CONTINUE
      NSIT(IATOM)=ISN
	DEALLOCATE(SITES)
	DEALLOCATE(IREFSITES)
2000  CONTINUE
C MEMORY DEALLOCATIONS
	DEALLOCATE(TAUT)
	DEALLOCATE(YLM)
C SITES ARE READY NOW!
C MEMORY ALLOCATIONS FOR SCRATCH ARRAYS
C Large arrays
	ALLOCATE(RHOLIB(0:NLIBMEM,NSYMMEM,NATOMMEM),STAT=IALLOC)
	IF(IALLOC.EQ.1)CALL MAKESCF_MESG02('RHOLIB',
     &(NLIBMEM+1)*NSYMMEM*NATOMMEM)
      SIZE_RHOLIB=DBLE(SIZE(RHOLIB)*LENCMP)/1024.D0**2
	ALLOCATE(WORK1(0:NLIBMEM,NATOMMEM))
      SIZE_WORK1=DBLE(SIZE(WORK1)*LENREL)/1024.D0**2
	ALLOCATE(DERIV(0:NLIBMEM,2,NATOMMEM))
      SIZE_DERIV=DBLE(SIZE(DERIV)*LENREL)/1024.D0**2
	ALLOCATE(WORK0(0:NLIBMEM,NSYMMEM))
      SIZE_WORK0=DBLE(SIZE(WORK0)*LENREL)/1024.D0**2
C Small arrays
	ALLOCATE(DEROUT(0:NLIBMEM,2))
	ALLOCATE(DERIN(0:NRADMEM,2))
	ALLOCATE(WORK2(0:NLIBMEM))
	ALLOCATE(WORK3(0:NLIBMEM,2))
	ALLOCATE(WORK4(0:NRADMEM,2))
	ALLOCATE(RNEW(0:NLIBMEM))
	ALLOCATE(RHONEW(0:NLIBMEM))
	ALLOCATE(ANSW(NSYMMEM))
	ALLOCATE(FDERIV(0:NLIBMEM,2))
	ALLOCATE(MINRAD(NSORTMEM))
	ALLOCATE(MAXRAD(NSORTMEM))
	ALLOCATE(POL(0:LMAXVMEM))
C Current memory
      CURMEM=CURMEM+SIZE_RHOLIB+SIZE_WORK1+SIZE_WORK0+
     &SIZE_DERIV
      IF(TOTMEM.LT.CURMEM)TXTMEM='<MAKESCF> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
C GET STARTING AND END POINTS
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO IRAD=0,NLIB
      RHOLIB(IRAD,1,IATOM)=RHOATOM(IRAD,ISORT)
      DO ISYM=2,NSYM(IATOM)
      RHOLIB(IRAD,ISYM,IATOM)=(0.D0,0.D0)
	ENDDO
	ENDDO
      DO IRAD=0,NLIB
      IF(RLIB(IRAD,ISORT).LT.0.5D0*SMT(ISORT))MINRAD(ISORT)=IRAD
      IF(ABS(RLIB(IRAD,ISORT)-SMT(ISORT)).LE.1.D-10)MID=IRAD
      IF(RLIB(IRAD,ISORT).GT.SMT(ISORT))EXIT
	ENDDO
      MAXRAD(ISORT)=IRAD
	ENDDO
C ***************************************************
C PERFORM SUMMMATION OF THE ATOMIC DENSITIES
C ***************************************************
C CALCULATE SPLINE COEFFICIENTS FOR THE DENSITY
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO IRAD=0,NLIB
      WORK1(IRAD,IATOM)=DREAL(RHOLIB(IRAD,1,IATOM))
      RHOLIB(IRAD,1,IATOM)=RHOLIB(IRAD,1,IATOM)*SQPI4
	ENDDO
      CALL SPLIN3(RLIB(0,ISORT),WORK1(0,IATOM),DERIV(0,1,IATOM),
     &NLIB+1,NLIBMEM+1,0.D0,0.D0,0.D0,0,1,-1)
	ENDDO
C CALCULATE TAIL CONTRIBUTION TO THE DENSITY
      DO 5000 IATOM=1,NATOM
      XMAX=LOG(60.D0)
      XMIN=XMAX-DBLE(NLIB-1)*HLIB(ISORT)
      COEF=EXP(XMIN-HLIB(ISORT))
      ISORT=IS(IATOM)
      DO 4000 ISIT=1,NSIT(IATOM)
      JATOM=IRSIT(ISIT,IATOM)
      JSORT=IS(JATOM)
      IF(ABS(ZNUC(JSORT)).LE.1.D-05)GOTO4000   !!! empty sphere case
      IF(DELTA(ISIT,IATOM).EQ.0.D0)GOTO4000
      DO 3000 IRAD=1,MAXRAD(ISORT)         !!! over radial points
C MAKE A GRID FOR TAKING THE INTEGRALS
      RMD=ABS(DELTA(ISIT,IATOM)-RLIB(IRAD,ISORT))
      RPD=    DELTA(ISIT,IATOM)+RLIB(IRAD,ISORT)
      RIMIN=LOG(RMD/COEF)/HLIB(ISORT)     !!! real lower limit point
      RIMAX=LOG(RPD/COEF)/HLIB(ISORT)     !!! real upper limit point
      IRAD1=    (RIMIN)                   !!! integer lower point
      IRAD2=NINT(RIMAX)
      NUM=IRAD2-IRAD1
      NUM=((NUM+1)/2)*2+10                 !!! number of points
      IRAD2=NUM+IRAD1                      !!! integer upper point
      IF(IRAD.LT.MINRAD(ISORT))ILMAX=0
      IF(IRAD.GE.MINRAD(ISORT))ILMAX=ILSV(ISORT)
      HNEW=LOG(RPD/RMD)/DBLE(NUM)
      CNEW=RMD*EXP(-HNEW*IRAD1)
C MAKE THE INTEGRAND
      DO I=IRAD1,IRAD2                     !!! over I
      RNEW(I)=CNEW*EXP(HNEW*I)
      XPNT=0.5D0*(RLIB(IRAD,ISORT)**2+DELTA(ISIT,IATOM)**2-
     &RNEW(I)**2)/(RLIB(IRAD,ISORT)*DELTA(ISIT,IATOM))
      CALL LEGPOL(POL,XPNT,ILMAX)
      LP=-1
      DO L=0,ILMAX                         !!! over l
      DO M=-L,L                            !!! over m
      LM=L*(L+1)+M+1
      IF(SYM(LM,IATOM).AND.LP.NE.L)THEN
      ISYM=LMSYM(LM,IATOM)
      WORK0(I,ISYM)=RNEW(I)*POL(L)*RNEW(I)
      LP=L
      ENDIF
	ENDDO                                !!! over m
	ENDDO                                !!! over l
	ENDDO                                !!! over I
      CALL SPLIN3(RLIB(0,JSORT),WORK1(0,JATOM),DERIV(0,1,JATOM),
     &NLIB+1,NLIBMEM+1,RNEW(IRAD1),RHONEW(IRAD1),FDERIV,NUM+1,
     &NLIBMEM+1,+1)
      LP=-1
      DO L=0,ILMAX                         !!! over l
      DO M=-L,L                            !!! over m
      LM=L*(L+1)+M+1
      IF(SYM(LM,IATOM))THEN
      ISYM=LMSYM(LM,IATOM)
      IF(LP.NE.L)THEN
      DO I=IRAD1,IRAD2
      WORK0(I,ISYM)=WORK0(I,ISYM)*RHONEW(I)
	ENDDO
      CALL QD(HNEW,WORK0(IRAD1,ISYM),WORK2(IRAD1),NUM+1)
      ANSW(ISYM)=WORK2(IRAD2)
      LP=L
      ISYMP=ISYM
      ELSE
      ANSW(ISYM)=ANSW(ISYMP)
      ENDIF
      ENDIF
	ENDDO                               !!! over m
	ENDDO                               !!! over l
      DO L=0,ILMAX                        !!! over l
      DIML=(0.D0,1.D0)**(-L)
      DO M=-L,L                           !!! over m
      LM=L*(L+1)+M+1
      IF(SYM(LM,IATOM))THEN
      ISYM=LMSYM(LM,IATOM)
      RHOLIB(IRAD,ISYM,IATOM)=RHOLIB(IRAD,ISYM,IATOM)+
     &2.D0*PI/RLIB(IRAD,ISORT)/DELTA(ISIT,IATOM)*ANSW(ISYM)*
     &WD(ISIT,ISYM,IATOM)*DIML
      ENDIF
	ENDDO                               !!! over m
	ENDDO                               !!! over l
3000	CONTINUE                            !!! over irad
4000  CONTINUE                            !!! over cluster
C SET TAIL-PART AT THE CENTER OF ATOM
      RHOLIB(0,1,IATOM)=RHOLIB(1,1,IATOM)-(
     &RHOLIB(2,1,IATOM)-RHOLIB(1,1,IATOM))/
     &(RLIB(2,ISORT)-RLIB(1,ISORT))*RLIB(1,ISORT)
C EXTRAPOLATE NON-SPHERICAL PART TO THE NUCLEUS
      IRAD0=MINRAD(ISORT)
      DO L=1,ILSV(ISORT)
      DO M=-L,L
      LM=L*(L+1)+M+1
      IF(SYM(LM,IATOM))THEN
      ISYM=LMSYM(LM,IATOM)
      DEG=SQRT(L*(L+1)+1.D0-4.D0*ZNUC(ISORT)*C2)
      DRODR=(RHOLIB(IRAD0+1,ISYM,IATOM)-RHOLIB(IRAD0,ISYM,IATOM))/
     &     (RLIB(IRAD0+1,ISORT)-RLIB(IRAD0,ISORT))
      CL=-1.D0/RLIB(IRAD0,ISORT)**(DEG-2.D0)*(DRODR-DEG
     &      /RLIB(IRAD0,ISORT)*RHOLIB(IRAD0,ISYM,IATOM))
      DL=+1.D0/RLIB(IRAD0,ISORT)**(DEG-1.D0)*(DRODR-(DEG-1.D0)
     &      /RLIB(IRAD0,ISORT)*RHOLIB(IRAD0,ISYM,IATOM))
      DO IRAD=0,MINRAD(ISORT)
      RHOLIB(IRAD,ISYM,IATOM)=CL*RLIB(IRAD,ISORT)**(DEG-1)
     &                       +DL*RLIB(IRAD,ISORT)**DEG
	ENDDO
      ENDIF
	ENDDO
	ENDDO
5000  CONTINUE                            !!! over atoms
C  RETURN TO THE OLD MESH FOR THE FULL CHARGE DENSITY
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO ISYM=1,NSYM(IATOM)
      DO I=0,NLIB
      WORK3(I,1)=DREAL(RHOLIB(I,ISYM,IATOM))
      WORK3(I,2)=DIMAG(RHOLIB(I,ISYM,IATOM))
	ENDDO
      CALL SPLIN3(RLIB(0,ISORT),WORK3(0,1),DEROUT,MAXRAD(ISORT)+1,
     &NLIBMEM+1,R(0,ISORT),WORK4(0,1),DERIN,NRAD(ISORT)+1,
     &NRADMEM+1,-1)
      CALL SPLIN3(RLIB(0,ISORT),WORK3(0,2),DEROUT,MAXRAD(ISORT)+1,
     &NLIBMEM+1,R(0,ISORT),WORK4(0,2),DERIN,NRAD(ISORT)+1,
     &NRADMEM+1,-1)
      DO IRAD=0,NRAD(ISORT)
      RHO(IRAD,ISYM,IATOM,1,1)=DCMPLX(WORK4(IRAD,1),WORK4(IRAD,2))/
     &DBLE(NSPIN)
      RHO(IRAD,ISYM,IATOM,NSPIN,1)=RHO(IRAD,ISYM,IATOM,1,1)
      RHOCOR(IRAD,ISORT,1)=(0.D0,0.D0)
      RHOCOR(IRAD,ISORT,NSPIN)=RHOCOR(IRAD,ISORT,1)
	ENDDO
	ENDDO
	ENDDO
C MEMORY DEALLOCATIONS FOR SCRATCH ARRAYS
	DEALLOCATE(RHOLIB)
	DEALLOCATE(FDERIV)
	DEALLOCATE(RHONEW)
	DEALLOCATE(DERIV)
	DEALLOCATE(WORK0)
	DEALLOCATE(WORK1)
	DEALLOCATE(WORK2)
	DEALLOCATE(WORK3)
	DEALLOCATE(WORK4)
	DEALLOCATE(RNEW)
	DEALLOCATE(ANSW)
	DEALLOCATE(POL)
      CURMEM=CURMEM-SIZE_RHOLIB-SIZE_WORK1-SIZE_DERIV-
     &SIZE_WORK0
C MEMORY DEALLOACTIONS
	DEALLOCATE(NSIT)
	DEALLOCATE(IRSIT)
	DEALLOCATE(DELTA)
	DEALLOCATE(WD)
C ERROR HANDLINGS
      CONTAINS
      SUBROUTINE MAKESCF_MESG01
      WRITE(IUT,*)'Warning from <MAKESCF>:'
      WRITE(IUT,*)'Cluster size is too small. Trying to increase...'
      WRITE(IUT,*)'New Rmax =',1.3D0*RMAX
      RMAX=1.3D0*RMAX
      IF(RMAX.GT.30.D0/PAR)
     &CALL FULLSTOP('Cannot find nearest neighbor.')
      END SUBROUTINE MAKESCF_MESG01
      SUBROUTINE MAKESCF_MESG02(CHARV,LSIZE)
      CHARACTER CHARV*(*)
      WRITE(IUT,*)'Terminated in <MAKESCF>:'
      WRITE(IUT,*)'Memory allocation problem detected from'
      WRITE(IUT,*)'the system. Complex array '//CHARV//' of the size:'
      WRITE(IUT,*) DBLE(LSIZE*LENCMP)/1024.D0**2,' Mbyte'
      WRITE(IUT,*)'cannot be allocated.'
      CALL FULLSTOP(' ')
      END SUBROUTINE MAKESCF_MESG02
      END SUBROUTINE MAKESCF_SMTS



      SUBROUTINE LEGPOL(P,X,LMAX)
*********************************************************
*  Calculate Legandere polynoms up to l equal to Lmax   *
*********************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION P(0:LMAX)
      P(0)=1.D0
      IF(LMAX.EQ.0)RETURN
      P(1)=X
      DO L=1,LMAX-1
      A=DBLE(2*L+1)/DBLE(L+1)
      B=DBLE(  L  )/DBLE(L+1)
      P(L+1)=A*X*P(L)-B*P(L-1)
	ENDDO
      END




	SUBROUTINE MAKESCF_SINT(RHOATOM,NLIBPAS,NATOMPAS)
**************************************************************
* Calculates pseudocharge density by fast fourier transform. *
**************************************************************
C SET ARRAY SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                           !!! from setup
      USE COM_PARAM,   ONLY : NATOM,NSORT,NSPIN,ILST,ILSV,IS   !!! from readini
      USE COM_SPHERE,  ONLY : ZNUC,SMT                         !!! from readini
      USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                  !!! from readini
      USE COM_LATTICE, ONLY : RBAS,GBAS,TAU                    !!! from readstr
	USE COM_DENDAT,  ONLY : RHOPS                            !!! from makescf
      USE COM_SITEGEN, ONLY : NSITES,SITES,IREFSITES           !!! from sitegen
      USE COM_PLWMESH, ONLY : NPLW,GPLW,INDG,KVEC,KGMIN,KGMAX  !!! from plwmesh
      USE COM_FFTMESH, ONLY : NFFTG,AD,RD,INTFFT               !!! from fftmesh
      USE COM_LIBMESH, ONLY : NLIB,HLIB,RLIB,DRLIB             !!! from libmesh
      USE COM_MASHDEP, ONLY : LENCMP,LENREL,LENINT             !!! from readini
      USE COM_UNIT    ,ONLY : IUN,IUR,IUT                      !!! from readini
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, INTRINSIC :: SIZE
	INTEGER MF(3),MR(3)
	REAL*8 RHOATOM(0:NLIBPAS,NATOMPAS),RHOT(5),GL(3)
	COMPLEX*16 EXPGR
C ALLOCATABLE ARRAYS
      COMPLEX*16, ALLOCATABLE :: RHORS(:)
      COMPLEX*16, ALLOCATABLE :: RHOTM(:)
	REAL*8, ALLOCATABLE :: WX(:,:)
	REAL*8, ALLOCATABLE :: WY(:,:)
	REAL*8, ALLOCATABLE :: WZ(:,:)
	REAL*8, ALLOCATABLE :: TAUT(:,:)
	REAL*8, ALLOCATABLE :: PREF(:)
	REAL*8, ALLOCATABLE :: EXPF(:)
      DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
	IF(NPLWMEM.EQ.-1)RETURN
C MEMORY ALLOCATIONS FOR SCRATCH ARRAYS
	ALLOCATE(RHORS(NFFTMEM))
      SIZE_RHORS=DBLE(SIZE(RHORS)*LENCMP)/1024.D0**2
	ALLOCATE(RHOTM(NFFTMEM))
      SIZE_RHOTM=DBLE(SIZE(RHOTM)*LENCMP)/1024.D0**2
	ALLOCATE(WX(0:NLIBMEM,NSORTMEM))
      SIZE_WX=DBLE(SIZE(WX)*LENREL)/1024.D0**2
	ALLOCATE(WY(0:NLIBMEM,NSORTMEM))
      SIZE_WY=DBLE(SIZE(WY)*LENREL)/1024.D0**2
	ALLOCATE(WZ(0:NLIBMEM,NSORTMEM))
      SIZE_WZ=DBLE(SIZE(WZ)*LENREL)/1024.D0**2
C Current memory
	CURMEM=CURMEM+SIZE_RHORS+SIZE_RHOTM+
     &SIZE_WX+SIZE_WY+SIZE_WZ
      IF(TOTMEM.LT.CURMEM)TXTMEM='<MAKESCF> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
	ALLOCATE(TAUT(3,NATOMMEM)) 
	ALLOCATE(PREF(NSORTMEM)) 
	ALLOCATE(EXPF(NSORTMEM)) 
      DO ISORT=1,NSORT                             !!! over sorts
C DEFINE SPLINE COEFFICIENTS
      CALL SPLKFF(NLIB+1,RLIB(0,ISORT),RHOATOM(0,ISORT),
     &WX(0,ISORT),WY(0,ISORT),WZ(0,ISORT))
C DEFINE SMOOTH MT-PART BY A*EXP(-B*R^2)
      STEP=SMT(ISORT)/100.D0
      DO ID=1,5
      RR=SMT(ISORT)+DBLE(ID-3)*STEP
      RHOT(ID)=SPLPNT(NLIB+1,RR,RLIB(0,ISORT),RHOATOM(0,ISORT),
     &WX(0,ISORT),WY(0,ISORT),WZ(0,ISORT))
	ENDDO
      RHOS=RHOT(3)
      RHOD=(RHOT(1)-RHOT(5)+8.D0*(RHOT(4)-RHOT(2)))/12.D0/STEP
      IF(ABS(RHOS).GT.1.D-07)
     &EXPF(ISORT)=-RHOD/RHOS/2.D0/SMT(ISORT)
      IF(ABS(RHOS).LE.1.D-07)
     &EXPF(ISORT)=0.D0
      PREF(ISORT)=RHOS*EXP(EXPF(ISORT)*SMT(ISORT)**2)
	ENDDO                                       !!! over sorts
C DO GLOBALLY OVER GRID POINTS OF FFT
	IERR=0
      DO MFFT3=0,NFFTG(3)-1                       !!! over mfft3
      DO MFFT2=0,NFFTG(2)-1                       !!! over mfft2
      DO MFFT1=0,NFFTG(1)-1                       !!! over mfft1
      IFFT=1+MFFT1+MFFT2*NFFTG(1)+MFFT3*NFFTG(1)*NFFTG(2)
      IATOM0=INTFFT(IFFT)
      ISORT0=0
      IF(IATOM0.GT.0)ISORT0=IS(IATOM0)
      RHORS(IFFT)=(0.D0,0.D0)
C RADIUS-VECTOR IS GIVEN BY
      RSX=MFFT1*AD(1,1)+MFFT2*AD(1,2)+MFFT3*AD(1,3)
      RSY=MFFT1*AD(2,1)+MFFT2*AD(2,2)+MFFT3*AD(2,3)
      RSZ=MFFT1*AD(3,1)+MFFT2*AD(3,2)+MFFT3*AD(3,3)
C CALCULATE ENVIRONMET SITES FOR THE POINT "RS"
      DO IATOM=1,NATOM
      TAUT(1,IATOM)=TAU(1,IATOM)-RSX
      TAUT(2,IATOM)=TAU(2,IATOM)-RSY
      TAUT(3,IATOM)=TAU(3,IATOM)-RSZ
	ENDDO
      RMAX=10.D0/PAR+1.D-05
 100  CALL SITEGEN(RMAX,RBAS,TAUT,NATOM)
	IF(NSITES.EQ.0)CALL MAKESCF_MESG01
	IF(NSITES.EQ.0)GOTO 100
      DO ISITES=0,NSITES                             !!! over isite
      IATOMR=IREFSITES(ISITES)
      ISORTR=IS(IATOMR)
      RTX=-SITES(1,ISITES)
      RTY=-SITES(2,ISITES)
      RTZ=-SITES(3,ISITES)
      RT=SQRT(RTX*RTX+RTY*RTY+RTZ*RTZ)
      KEYOUT=1
      IF(RT*PAR.LE.SMT(ISORTR))KEYOUT=0
C CALCULATE PSEUDOCHARGE DENSITY AT THE POINT "RT"
      IF(KEYOUT.EQ.1)THEN
      RHOPNT=SPLPNT(NLIB+1,RT*PAR,RLIB(0,ISORTR),
     &RHOATOM(0,ISORTR),WX(0,ISORTR),WY(0,ISORTR),WZ(0,ISORTR))
      ELSEIF(KEYOUT.EQ.0)THEN
      IF(ISORT0.NE.ISORTR)IERR=1
      RHOPNT=PREF(ISORT0)*EXP(-EXPF(ISORT0)*(RT*PAR)**2)
      ENDIF
      RHORS(IFFT)=RHORS(IFFT)+RHOPNT
	ENDDO                                         !!! over isite
	DEALLOCATE(SITES)
	DEALLOCATE(IREFSITES)
	ENDDO
	ENDDO
	ENDDO
	IF(IERR.EQ.1)CALL MAKESCF_MESG02
C MAKE FAST FOURIER TRANSFORM FOR THE PSEUDOCHARGE DENSITY
C DO OVER "R2","R3" AND "G1", *** GET RHO{G1,R2,R3} ***
      DO MFFT3=0,NFFTG(3)-1
      DO MFFT2=0,NFFTG(2)-1
      DO MFTR1=0,NFFTG(1)-1
      IFTR=1+MFTR1+MFFT2*NFFTG(1)+MFFT3*NFFTG(1)*NFFTG(2)
      GX=MFTR1*GBAS(1,1)
      GY=MFTR1*GBAS(2,1)
      GZ=MFTR1*GBAS(3,1)
      RHOTM(IFTR)=(0.D0,0.D0)
C SUM OVER "R1"
      DO MFFT1=0,NFFTG(1)-1
      IFFT=1+MFFT1+MFFT2*NFFTG(1)+MFFT3*NFFTG(1)*NFFTG(2)
      SCP=GX*MFFT1*AD(1,1)+GY*MFFT1*AD(2,1)+GZ*MFFT1*AD(3,1)
      EXPGR=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
      RHOTM(IFTR)=RHOTM(IFTR)+EXPGR*RHORS(IFFT)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C DO OVER "R3","G1" AND "G2", *** GET RHO{G1,G2,R3} ***
      DO MFFT3=0,NFFTG(3)-1
      DO MFTR1=0,NFFTG(1)-1
      DO MFTR2=0,NFFTG(2)-1
      IFTR=1+MFTR1+MFTR2*NFFTG(1)+MFFT3*NFFTG(1)*NFFTG(2)
      GX=MFTR2*GBAS(1,2)
      GY=MFTR2*GBAS(2,2)
      GZ=MFTR2*GBAS(3,2)
      RHORS(IFTR)=(0.D0,0.D0)
C SUM OVER "R2"
      DO MFFT2=0,NFFTG(2)-1
      IFFT=1+MFTR1+MFFT2*NFFTG(1)+MFFT3*NFFTG(1)*NFFTG(2)
      SCP=GX*MFFT2*AD(1,2)+GY*MFFT2*AD(2,2)+GZ*MFFT2*AD(3,2)
      EXPGR=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
      RHORS(IFTR)=RHORS(IFTR)+EXPGR*RHOTM(IFFT)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C DO OVER "G1","G2" AND "G3", *** GET RHO{G1,G2,G3} ***
      DO MFTR1=0,NFFTG(1)-1
      DO MFTR2=0,NFFTG(2)-1
      DO MFTR3=0,NFFTG(3)-1
      IFTR=1+MFTR1+MFTR2*NFFTG(1)+MFTR3*NFFTG(1)*NFFTG(2)
      GX=MFTR3*GBAS(1,3)
      GY=MFTR3*GBAS(2,3)
      GZ=MFTR3*GBAS(3,3)
      RHOTM(IFTR)=(0.D0,0.D0)
C SUM OVER "R3"
      DO MFFT3=0,NFFTG(3)-1
      IFFT=1+MFTR1+MFTR2*NFFTG(1)+MFFT3*NFFTG(1)*NFFTG(2)
      SCP=GX*MFFT3*AD(1,3)+GY*MFFT3*AD(2,3)+GZ*MFFT3*AD(3,3)
      EXPGR=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
      RHOTM(IFTR)=RHOTM(IFTR)+EXPGR*RHORS(IFFT)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C **** SET PSEUDODENSITY WITHIN SPHERE GMAX ***
      ANORM=1.D0/DBLE(NFFTG(1)*NFFTG(2)*NFFTG(3))
      DO M3=KGMIN(3),KGMAX(3)
      DO M2=KGMIN(2),KGMAX(2)
      DO M1=KGMIN(1),KGMAX(1)
      IDIM=1+M1-KGMIN(1)+(KGMAX(1)-KGMIN(1)+1)*(M2-KGMIN(2))+
     &(KGMAX(1)-KGMIN(1)+1)*(KGMAX(2)-KGMIN(2)+1)*(M3-KGMIN(3))
      IPLW=INDG(IDIM)
      IF(IPLW.NE.-1)THEN
      GL(1)=M1*GBAS(1,1)+M2*GBAS(1,2)+M3*GBAS(1,3)
      GL(2)=M1*GBAS(2,1)+M2*GBAS(2,2)+M3*GBAS(2,3)
      GL(3)=M1*GBAS(3,1)+M2*GBAS(3,2)+M3*GBAS(3,3)
C REDUCE TO FIRST CELL GIVEN BY RD(I,1..3)
      CALL MAKESCF_FCEL(GL,GBAS,RBAS,NFFTG,MF)
      IFTR=1+MF(1)+MF(2)*NFFTG(1)+MF(3)*NFFTG(1)*NFFTG(2)
      RHOPS(IPLW,1,1)=ANORM*RHOTM(IFTR)/DBLE(NSPIN)
      RHOPS(IPLW,NSPIN,1)=RHOPS(IPLW,1,1)
	ENDIF
	ENDDO
	ENDDO
	ENDDO
C MEMORY DEALLOCATIONS FOR SCRATCH ARRAYS
	DEALLOCATE(RHORS)
	DEALLOCATE(RHOTM)
	DEALLOCATE(WX)
	DEALLOCATE(WY)
	DEALLOCATE(WZ)
	CURMEM=CURMEM-SIZE_RHORS-SIZE_RHOTM-
     &SIZE_WX-SIZE_WY-SIZE_WZ
	DEALLOCATE(TAUT) 
	DEALLOCATE(PREF) 
	DEALLOCATE(EXPF)
C ERROR HANDLINGS
      CONTAINS
      SUBROUTINE MAKESCF_MESG01
      WRITE(IUT,*)'Warning from <MAKESCF>:'
      WRITE(IUT,*)'Cluster size is too small. Trying to increase...'
      WRITE(IUT,*)'New Rmax =',1.3D0*RMAX
      RMAX=1.3D0*RMAX
      IF(RMAX.GT.30.D0/PAR)
     &CALL FULLSTOP('Cannot find nearest neighbor.')
      END SUBROUTINE MAKESCF_MESG01
      SUBROUTINE MAKESCF_MESG02
	WRITE(IUT,*)'Warning from <MAKESCF>:'
	WRITE(IUT,*)'Error during building interstitial density'
	WRITE(IUT,*)'was detected. Probably MT spheres OVERLAP!'
	WRITE(IUT,*)'If this is intended, ignore this message.'
      END SUBROUTINE MAKESCF_MESG02
      END SUBROUTINE MAKESCF_SINT




      SUBROUTINE MAKESCF_FCEL(X,AD,RD,NDIV,NR)
*********************************************************
*  Finds coordinates of vector X in the first cell      *
*  defined by Ad*Ndiv. Rd - reciprocals to Ad.          *
*********************************************************
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                      !!! from readini
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER NDIV(3),NR(3)
      DIMENSION X(3),AD(3,3),RD(3,3)
      X1=X(1)*RD(1,1)+X(2)*RD(2,1)+X(3)*RD(3,1)
      X2=X(1)*RD(1,2)+X(2)*RD(2,2)+X(3)*RD(3,2)
      X3=X(1)*RD(1,3)+X(2)*RD(2,3)+X(3)*RD(3,3)
      N1=ANINT(X1)
      N2=ANINT(X2)
      N3=ANINT(X3)
      IF(ABS(N1-X1).GE.1.D-05.OR.ABS(N2-X2).GE.1.D-05.
     &OR.ABS(N3-X3).GE.1.D-05)CALL MAKESCF_MESG01
      NR(1)=MOD(N1,NDIV(1))
      NR(2)=MOD(N2,NDIV(2))
      NR(3)=MOD(N3,NDIV(3))
      IF(NR(1).LT.0)NR(1)=NR(1)+NDIV(1)
      IF(NR(2).LT.0)NR(2)=NR(2)+NDIV(2)
      IF(NR(3).LT.0)NR(3)=NR(3)+NDIV(3)
C ERROR HANDLINGS
	CONTAINS
	SUBROUTINE MAKESCF_MESG01
	WRITE(IUT,*)'Terminated in <MAKESCF_MESG01>:'
	WRITE(IUT,*)'Internal error detected. The point'
	WRITE(IUT,*)'cannot be reduced to the first cell.'
	WRITE(IUT,*)'Point X (:)=',X
	WRITE(IUT,*)'Basis AD(:)=',AD
	CALL FULLSTOP(' ')
	END SUBROUTINE MAKESCF_MESG01
      END SUBROUTINE MAKESCF_FCEL
