      SUBROUTINE READSTR
************************************************************
*  <READSTR> reads crystalline structure and IBZ data      *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_PARAM   ,ONLY: NATOM,NSORT,IS                  !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,ORTH,OMEGAC,STRAIN          !!! from readini
      USE COM_LATTICE ,ONLY: RBAS,GBAS,BBAS,TAU,TAO          !!! from readstr
     &                      ,ORIGIN,ISTRAIN
      USE COM_VECGEN  ,ONLY: NIVEC,ALPHEVL                   !!! from readstr
	USE COM_INPTTR  ,ONLY: NDIR,HSPNT,PNTNOT               !!! from readstr
      USE COM_LMTINP  ,ONLY: PROJECT,INPINFO,STRFILE         !!! from init
	USE COM_EXTENS  ,ONLY: EXTNSTR,EXTNKOV,LENEXTN         !!! from setup
      USE COM_LMTOUT  ,ONLY: ICKOV,KOVFILE                  !!! from readstr
      USE COM_LABELS  ,ONLY: TXTEL,TXTAT,TXTST,HEADSTR       !!! from readstr
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                     !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: TAUR(:,:)
	REAL*8, ALLOCATABLE :: TAOR(:,:)
	REAL*8, ALLOCATABLE :: HSPNTR(:,:,:)
	DIMENSION RBASR(3,3),BBASR(3,3),BASR(3),RSTN(3,3)
      CHARACTER STRARR(80)*1,STRING*150,HELP*40,TXT*72
     &  ,SYS*1,SYST*10,INF*130
      CHARACTER*150, ALLOCATABLE :: STRDATA(:)
      CHARACTER*150, ALLOCATABLE :: STRCOPY(:)
      LOGICAL EXIST,MODIFIED,PRESENT,DEF,ASK,VAL,NTH,MDF
      DATA PI/3.141592653589793D0/
C CHECK INPINFO
      INF=INPINFO
      CALL SUBSTR_IN_STR(PRESENT,INF,130,EXTNSTR,LENEXTN)
      IF(.NOT.PRESENT)CALL READSTR_MESG00
C SET FILE NAME
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNSTR,60,NBE)
      STRFILE=PROJECT(:NBP)//'.'//EXTNSTR(:NBE)
      INQUIRE(FILE=STRFILE,EXIST=EXIST)
      IF(.NOT.EXIST)CALL READSTR_MESG01
C ********************************
C UNDERSTAND THE LENGHT OF STRFILE
      CALL FILE_LENGHT(STRFILE,NLEN)
      ALLOCATE(STRDATA(NLEN))
C ********************************
C READ STRFILE TO INTERNAL FILE
      OPEN(UNIT=1,FILE=STRFILE,STATUS='OLD',FORM='FORMATTED')
      DO ILEN=1,NLEN
      READ(1,FMT='(A150)')STRDATA(ILEN)
      ENDDO
      CLOSE(1)
C ********************************
C UNDERSTAND INPUT: CLASSIC or MODERN
      STRING=STRDATA(1)
      CALL CONVLOW(STRING,150)
      MODERN=0
      DO IPOS=1,80
      IF(STRING(IPOS:IPOS+11).EQ.'input=modern')MODERN=2
      IF(MODERN.NE.0)EXIT
      ENDDO
	IF(MODERN.NE.2)CALL READSTR_MESG06
      IF(MODERN.EQ.2)MODIFIED=.TRUE.
C **************************************
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
	ALLOCATE(TAU(3,NATOMMEM))
	ALLOCATE(TAO(3,NATOMMEM))
	ALLOCATE(TAUR(3,NATOMMEM))
	ALLOCATE(TAOR(3,NATOMMEM))
C
C **************************************
C READING THE DATA: SELECT HEADING
C **************************************
C
C MODERN INPUT IS USED, DEFAULTS ARE AVAIABLE
      CALL READINI_SECT(STRDATA(1),NLEN,ISEC,NSEC,MSEC,
     &  '<section=heds',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(STRDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)STRDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! STRUCTURE TITLE:                     '
      IF(MSEC.NE.0)STRDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(STRCOPY(NSEC))
      DO ILIN=1,MSEC
      STRCOPY(ILIN)=STRDATA(ILIN+ISEC-1)
      ENDDO
C Set HEADSTR
      HEADSTR='struc'
      CALL READINI_CHAR(STRDATA(ISEC),STRCOPY(1),NSEC,MSEC,
     &'slabl',5,IN,1,0,RE,1,0,CM,1,0,HEADSTR,64,1,' ',1,
     &DEF,ASK,VAL,NTH,.TRUE.)
C **************************************
      CALL READINI_ERRR(STRDATA(ISEC),STRCOPY(1),NSEC,MSEC,'HEDS')
      DEALLOCATE(STRCOPY)
C
C **************************************
C READING THE DATA: SELECT CONTROLS
C **************************************
C
C MODERN INPUT IS USED, DEFAULTS ARE AVAIABLE
      CALL READINI_SECT(STRDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=ctrs',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(STRDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)STRDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! CONTROL STRUCTURE:                   '
      IF(MSEC.NE.0)STRDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(STRCOPY(NSEC))
      DO ILIN=1,MSEC
      STRCOPY(ILIN)=STRDATA(ILIN+ISEC-1)
      ENDDO
C Process NATOM
      HELP='! # of atoms                           '
      LHLP=40
      CALL READINI_CHAR(STRDATA(ISEC),STRCOPY(1),NSEC,MSEC,
     &'natom',5,NATOM,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.)
C Process BtoA
      ORTH(2)=1.D0
      HELP='! b over a ratio                       '
      LHLP=40
      CALL READINI_CHAR(STRDATA(ISEC),STRCOPY(1),NSEC,MSEC,
     &'btoa',4,IN,1,0,ORTH(2),1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.)
C Process CtoA
      ORTH(3)=1.D0
      HELP='! c over a ratio                       '
      LHLP=40
      CALL READINI_CHAR(STRDATA(ISEC),STRCOPY(1),NSEC,MSEC,
     &'ctoa',4,IN,1,0,ORTH(3),1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.)
C Process IBAS
	IBAS=1
      HELP='! controls coordinate system           '
      LHLP=40
      CALL READINI_CHAR(STRDATA(ISEC),STRCOPY(1),NSEC,MSEC,
     &'icrd',4,IBAS,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.)
C Process IBZ
	IBZ=1
      HELP='! controls BZ choice                   '
      LHLP=40
      CALL READINI_CHAR(STRDATA(ISEC),STRCOPY(1),NSEC,MSEC,
     &'ibrz',4,IBZ,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.)
C Process ICALC
	ICALC=1
      HELP='! switches on/off calculator           '
      LHLP=40
      CALL READINI_CHAR(STRDATA(ISEC),STRCOPY(1),NSEC,MSEC,
     &'icalc',5,ICALC,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.)
C Process ISTRAIN
	ISTRAIN=1
      HELP='! applies strain to PLW sphere         '
      LHLP=40
      CALL READINI_CHAR(STRDATA(ISEC),STRCOPY(1),NSEC,MSEC,
     &'istrn',5,ISTRAIN,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.)
C Process NIVEC
	NIVEC=500
      HELP='! # of structure vectors               '
      LHLP=40
      CALL READINI_CHAR(STRDATA(ISEC),STRCOPY(1),NSEC,MSEC,
     &'nvecs',5,NIVEC,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.)
C Process ALPHEVL
      ALPHEVL=1.D0
      HELP='! Evalds splitting parameter           '
      LHLP=40
      CALL READINI_CHAR(STRDATA(ISEC),STRCOPY(1),NSEC,MSEC,
     &'evald',5,IN,1,0,ALPHEVL,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.)
C **************************************
      CALL READINI_ERRR(STRDATA(ISEC),STRCOPY(1),NSEC,MSEC,'CTRS')
      DEALLOCATE(STRCOPY)
C
C **************************************
C READING THE DATA: SELECT TRANSLATIONS
C RBAS(1:3,IVEC) - x,y,z components of translations
C **************************************
C
C MODERN INPUT IS USED, DEFAULTS ARE AVAIABLE
      CALL READINI_SECT(STRDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=tran',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(STRDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)STRDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! PRIMITIVE TRANSLATIONS:              '
      IF(MSEC.NE.0)STRDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
	IF(MSEC.NE.4)CALL READSTR_MESG02
C Process RBAS
      DO IVEC=1,3
      IF(ICALC.NE.1)THEN
      READ(STRDATA(ISEC+IVEC),*)(RBASR(I,IVEC),I=1,3)
      ELSEIF(ICALC.EQ.1)THEN
      READ(STRDATA(ISEC+IVEC),FMT='(80A1)')STRARR
      CALL COMPVEC(STRARR,RBASR(1,IVEC),3)
      ENDIF
	ENDDO
C **************************************
C
C TRY TO GUESS THE STRUCTURE FROM THE DATABASE
	CALL READSTR_BASE(RBASR,ORTH,IDBASE,NDIRDB)
C
C **************************************
C READING THE DATA: SELECT BASIS ATOMS
C TAU(1:3,IATOM) - x,y,z components 
C **************************************
C
C MODERN INPUT IS USED, DEFAULTS ARE AVAIABLE
      CALL READINI_SECT(STRDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=bass',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(STRDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)STRDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! BASIS ATOMS :                        '
      IF(MSEC.NE.0)STRDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
	IF(MSEC.NE.NATOM+1)CALL READSTR_MESG03
C PROCESS TAU
      DO IATOM=1,NATOM
	IREC=ISEC+IATOM
      IF(IBAS.EQ.1)THEN     !!! basis in Cartesian coordinates
      IF(ICALC.NE.1)THEN
      READ(STRDATA(IREC),*)(TAOR(I,IATOM),I=1,3)
      ELSEIF(ICALC.EQ.1)THEN!!! using calculator
      READ(STRDATA(IREC),FMT='(80A1)')STRARR
      CALL COMPVEC(STRARR,TAOR(1,IATOM),3)
      ENDIF
      ELSEIF(IBAS.NE.1)THEN !!! basis in units of RBAS
      IF(ICALC.NE.1)THEN
      READ(STRDATA(IREC),*)(BASR(I),I=1,3)
      ELSEIF(ICALC.EQ.1)THEN!!! using calculator
      READ(STRDATA(IREC),FMT='(80A1)')STRARR
      CALL COMPVEC(STRARR,BASR(1),3)
      ENDIF
	DO IX=1,3
      TAOR(IX,IATOM)=BASR(1)*RBASR(IX,1)
     &              +BASR(2)*RBASR(IX,2)
     &              +BASR(3)*RBASR(IX,3)
	ENDDO
      ENDIF
	ENDDO
C
C **************************************
C READING THE DATA: SELECT DISTORTIONS
C TAU(1:3,IATOM) - x,y,z components 
C **************************************
C
C MODERN INPUT IS USED, DEFAULTS ARE AVAIABLE
      CALL READINI_SECT(STRDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=dist',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(STRDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)STRDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! DISPLACEMENTS FILED:                 '
      IF(MSEC.NE.0)STRDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C PROCESS TAU
	DO IATOM=1,NATOM
	TAUR(1,IATOM)=0.D0
	TAUR(2,IATOM)=0.D0
	TAUR(3,IATOM)=0.D0
	ENDDO
	IF(MSEC.GT.1)THEN     !!! distortions present
      DO IATOM=1,NATOM
	IREC=ISEC+IATOM
      IF(IBAS.EQ.1)THEN     !!! basis in Cartesian coordinates
      IF(ICALC.NE.1)THEN
      READ(STRDATA(IREC),*)(TAUR(I,IATOM),I=1,3)
      ELSEIF(ICALC.EQ.1)THEN!!! using calculator
      READ(STRDATA(IREC),FMT='(80A1)')STRARR
      CALL COMPVEC(STRARR,TAUR(1,IATOM),3)
      ENDIF
      ELSEIF(IBAS.NE.1)THEN !!! basis in units of RBAS
      IF(ICALC.NE.1)THEN
      READ(STRDATA(IREC),*)(BASR(I),I=1,3)
      ELSEIF(ICALC.EQ.1)THEN!!! using calculator
      READ(STRDATA(IREC),FMT='(80A1)')STRARR
      CALL COMPVEC(STRARR,BASR(1),3)
      ENDIF
	DO IX=1,3
      TAUR(IX,IATOM)=BASR(1)*RBASR(IX,1)
     &              +BASR(2)*RBASR(IX,2)
     &              +BASR(3)*RBASR(IX,3)
	ENDDO
      ENDIF
	ENDDO
	ENDIF                !!! distortions present
	DO IATOM=1,NATOM
	TAUR(1,IATOM)=TAUR(1,IATOM)+TAOR(1,IATOM)
	TAUR(2,IATOM)=TAUR(2,IATOM)+TAOR(2,IATOM)
	TAUR(3,IATOM)=TAUR(3,IATOM)+TAOR(3,IATOM)
	ENDDO
C
C **************************************
C READING THE DATA: SELECT STRAIN MATRIX
C STRAIN(1..3,1..3) - matrix applied to translations and basis R'=S*R
C Its diagonal components in case no strain are just 1,1,1
C **************************************
C
C MODERN INPUT IS USED, DEFAULTS ARE AVAIABLE
      CALL READINI_SECT(STRDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=strn',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(STRDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)STRDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! STRAIN MATRIX:                       '
      IF(MSEC.NE.0)STRDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C PROCESS STRAIN
	DO I=1,3
	DO J=1,3
	STRAIN(I,J,1)=0.D0
	ENDDO
	STRAIN(I,I,1)=1.D0
	ENDDO
	IF(MSEC.GT.1)THEN
      DO I=1,3
	IREC=I+ISEC
      IF(ICALC.NE.1)THEN
      READ(STRDATA(IREC),*)(STRAIN(I,J,1),J=1,3)
      ELSEIF(ICALC.EQ.1)THEN
      READ(STRDATA(IREC),FMT='(80A1)')STRARR
      CALL COMPVEC(STRARR,BASR(1),3)
      STRAIN(I,1,1)=BASR(1)
      STRAIN(I,2,1)=BASR(2)
      STRAIN(I,3,1)=BASR(3)
      ENDIF
	ENDDO
	ENDIF
C **************************************
C  SET RECIPROCAL STRAIN MATRIX: S*S^(-1)=1
      CALL READSTR_CROS(RSTN(1,1),STRAIN(1,2,1),STRAIN(1,3,1))
      CALL READSTR_CROS(RSTN(1,2),STRAIN(1,3,1),STRAIN(1,1,1))
      CALL READSTR_CROS(RSTN(1,3),STRAIN(1,1,1),STRAIN(1,2,1))
      W=STRAIN(1,1,1)*RSTN(1,1)
     & +STRAIN(2,1,1)*RSTN(2,1)
     & +STRAIN(3,1,1)*RSTN(3,1)
      IF(ABS(W).LE.1.D-10)CALL READSTR_MESG04
      DO I=1,3
      STRAIN(1,I,2)=RSTN(I,1)/W
      STRAIN(2,I,2)=RSTN(I,2)/W
      STRAIN(3,I,2)=RSTN(I,3)/W
	ENDDO
C
C **************************************
C READING THE DATA: SELECT POINT GROUP
C SYS - C(cubic) or H(hexogonal) system of rotations
C     - A(arbitrary) system can be also specified.
C       Group operations must be listed in KOVFILE,
C       see WIGMAT subroutine for more details.
C **************************************
C
C MODERN INPUT IS USED, DEFAULTS ARE AVAIABLE
      CALL READINI_SECT(STRDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=symm',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(STRDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)STRDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! SYMMETRY GROUP:                      '
      IF(MSEC.NE.0)STRDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(STRCOPY(NSEC))
      DO ILIN=1,MSEC
      STRCOPY(ILIN)=STRDATA(ILIN+ISEC-1)
      ENDDO
C Process Rsys
      SYST='         '
      HELP='! (C)ubic or (H)exagonal system        '
      LHLP=40
      CALL READINI_CHAR(STRDATA(ISEC),STRCOPY(1),NSEC,MSEC,
     &'rsys',4,IN,1,0,RE,1,0,CM,1,0,SYST,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.)
	CALL RMBLANK(SYST,10)
	SYS=SYST(1:1)
      IF(SYS.EQ.' ')ICKOV=0
      IF(SYS.EQ.'C')ICKOV=1
      IF(SYS.EQ.'H')ICKOV=2
      IF(SYS.EQ.'A')ICKOV=3
C Process KOVFILE
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNKOV,60,NBE)
      KOVFILE=PROJECT(:NBP)//'.'//EXTNKOV(:NBE)
	IF(SYS.EQ.'A')THEN
      HELP='! Contains symmetry operations.        '
      LHLP=40
      CALL READINI_CHAR(STRDATA(ISEC),STRCOPY(1),NSEC,MSEC,
     &'kovfile',7,IN,1,0,RE,1,0,CM,1,0,KOVFILE,130,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.)
	CALL RMBLANK(KOVFILE,130)
	ENDIF
C **************************************
      CALL READINI_ERRR(STRDATA(ISEC),STRCOPY(1),NSEC,MSEC,'SYMM')
      DEALLOCATE(STRCOPY)
C
C **************************************
C READING THE DATA: SELECT BRILLOUIN ZONE
C BBAS - three primitive translations 
C (possibly reciprocal lattice vectors)
C **************************************
C
C **************************************
C MODERN INPUT IS USED, DEFAULTS ARE AVAIABLE
      CALL READINI_SECT(STRDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=zone',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(STRDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)STRDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! BRILLOUIN ZONE :                     '
      IF(MSEC.NE.0)STRDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Process BBAS
	IF(MSEC.GT.1)THEN
      DO IVEC=1,3
      IF(ICALC.NE.1)THEN
      READ(STRDATA(ISEC+IVEC),*)(BBASR(I,IVEC),I=1,3)
      ELSEIF(ICALC.EQ.1)THEN
      READ(STRDATA(ISEC+IVEC),FMT='(80A1)')STRARR
      CALL COMPVEC(STRARR,BBASR(1,IVEC),3)
      ENDIF
	ENDDO
	ELSE
	DO IVEC=1,3
	BBASR(1,IVEC)=0.D0
	BBASR(2,IVEC)=0.D0
	BBASR(3,IVEC)=0.D0
	ENDDO 
	IBZ=1
	ENDIF
C **************************************
C
C **************************************
C READING THE DATA: SELECT HIGH SYMMETRY DIRECTIONS
C NDIR - number of directions to be calculated
C HSPNT(1:3,1:2,IDIR) - starting and end points
C **************************************
C
C **************************************
C MODERN INPUT IS USED, DEFAULTS ARE AVAIABLE
      CALL READINI_SECT(STRDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=dirs',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(STRDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)STRDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! HIGH-SYMMETRY LINES:                 '
      IF(MSEC.NE.0)STRDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
	NDIR=0
	IF(MSEC.GT.1)THEN
	IREC=ISEC+1
      READ(STRDATA(IREC),*)NDIR
	ALLOCATE(HSPNT(3,2,NDIR))
	ALLOCATE(HSPNTR(3,2,NDIR))
	ALLOCATE(PNTNOT(2,NDIR))
      DO IDIR=1,NDIR
	IREC=IREC+1
      READ(STRDATA(IREC),FMT='(2(1X,A1))')
     &(PNTNOT(IVEC,IDIR),IVEC=1,2)
	IREC=IREC+1
      IF(ICALC.NE.1)THEN
      READ(STRDATA(IREC),*)
     &((HSPNTR(I,IVEC,IDIR),I=1,3),IVEC=1,2) ! high-symmetry dirs
      ELSEIF(ICALC.EQ.1)THEN
      READ(STRDATA(IREC),FMT='(80A1)')STRARR
      CALL COMPVEC(STRARR,HSPNTR(1,1,IDIR),6)
      ENDIF
	ENDDO
	ELSEIF(IDBASE.NE.0)THEN
C GET FROM THE DATABASE
	NDIR=NDIRDB
	ALLOCATE(HSPNT(3,2,NDIR))
	ALLOCATE(HSPNTR(3,2,NDIR))
	ALLOCATE(PNTNOT(2,NDIR))
	CALL READSTR_DIRS(IDBASE,PNTNOT,HSPNTR,NDIR)
	ENDIF
C **************************************
C ALL STRUCTURE DATA READ NOW, UPDATE STRFILE
	IF(MODIFIED) 
     &CALL READINI_OVWR(STRFILE,STRDATA,NLEN)
C **************************************
C ACCOUNT FOR ORTHOROMBICITY PARAMETERS
      DO I=2,3
      DO IVEC=1,3
      RBASR(I,IVEC)=RBASR(I,IVEC)*ORTH(I)
      BBASR(I,IVEC)=BBASR(I,IVEC)/ORTH(I)
	ENDDO
      DO IATOM=1,NATOM
      TAOR(I,IATOM)=TAOR(I,IATOM)*ORTH(I)
      TAUR(I,IATOM)=TAUR(I,IATOM)*ORTH(I)
	ENDDO
	ENDDO
      DO I=2,3
      DO IVEC=1,2
      DO IDIR=1,NDIR
      HSPNTR(I,IVEC,IDIR)=HSPNTR(I,IVEC,IDIR)/ORTH(I)
	ENDDO
	ENDDO
	ENDDO
C APPLY STRAIN MATRIX FOR TRANSLATIONS:  R'=S*R
      DO IVEC=1,3
      DO I=1,3
      RBAS(I,IVEC)=0.D0
      DO J=1,3
      RBAS(I,IVEC)=RBAS(I,IVEC)+STRAIN(I,J,1)*RBASR(J,IVEC)
	ENDDO
	ENDDO
	ENDDO
C APPLY STRAIN FOR BASIS VECTORS:  T'=S*T
      DO IATOM=1,NATOM
      DO I=1,3
      TAU(I,IATOM)=0.D0
      TAO(I,IATOM)=0.D0
      DO J=1,3
      TAU(I,IATOM)=TAU(I,IATOM)+STRAIN(I,J,1)*TAUR(J,IATOM)
      TAO(I,IATOM)=TAO(I,IATOM)+STRAIN(I,J,1)*TAOR(J,IATOM)
	ENDDO
	ENDDO
	ENDDO
C APPLY INVERSE STRAIN FOR BRILLOUIN ZONE: BZ'=BZ*S^(-1)
      DO IVEC=1,3
      DO I=1,3
      BBAS(I,IVEC)=0.D0
      DO J=1,3
      BBAS(I,IVEC)=BBAS(I,IVEC)+BBASR(J,IVEC)*STRAIN(J,I,2)
	ENDDO
	ENDDO
	ENDDO
C APPLY INVERSE STRAIN TO HIGH-SYMMETRY DIRECTIONS: K'=K*S^(-1)
      DO IDIR=1,NDIR
      DO IVEC=1,2
      DO I=1,3
      HSPNT(I,IVEC,IDIR)=0.D0
      DO J=1,3
      HSPNT(I,IVEC,IDIR)=HSPNT(I,IVEC,IDIR)+
     &HSPNTR(J,IVEC,IDIR)*STRAIN(J,I,2)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C SET RECIPROCAL LATTICE VECTORS WITHOUT 2*PI
      CALL READSTR_CROS(GBAS(1,1),RBAS(1,2),RBAS(1,3))
      CALL READSTR_CROS(GBAS(1,2),RBAS(1,3),RBAS(1,1))
      CALL READSTR_CROS(GBAS(1,3),RBAS(1,1),RBAS(1,2))
      W=RBAS(1,1)*GBAS(1,1)
     & +RBAS(2,1)*GBAS(2,1)
     & +RBAS(3,1)*GBAS(3,1)
      DO I=1,3
      GBAS(I,1)=GBAS(I,1)/W
      GBAS(I,2)=GBAS(I,2)/W
      GBAS(I,3)=GBAS(I,3)/W
	ENDDO
      OMEGAC=ABS(W)*PAR**3
C SET BRILLOUIN ZONE TO GBAS IF REQUIRED
      IF(IBZ.EQ.1)THEN
      DO I=1,3
      BBAS(I,1)=GBAS(I,1)
      BBAS(I,2)=GBAS(I,2)
      BBAS(I,3)=GBAS(I,3)
	ENDDO
      ENDIF
C SET ORIGIN TO ZERO
	ORIGIN(1)=0.D0
	ORIGIN(2)=0.D0
	ORIGIN(3)=0.D0
C MEMORY DEALLOCATIONS
	DEALLOCATE(TAUR) 
	DEALLOCATE(TAOR) 
	DEALLOCATE(STRDATA) 
	IF(NDIR.NE.0)DEALLOCATE(HSPNTR)
C ERROR HANDLINGS

	CONTAINS

      SUBROUTINE READSTR_MESG00
      WRITE(IUT,*)'Terminated in <READSTR>:'
      WRITE(IUT,*)
     &'STRFILE identificator << '//EXTNSTR(1:LENEXTN)//' >>'
      WRITE(IUT,*)'is not found in INPINFO string.'
      CALL FULLSTOP(' ')
      END SUBROUTINE READSTR_MESG00

	SUBROUTINE READSTR_MESG01
      WRITE(IUT,*)'Terminated in <READSTR>:'
      WRITE(IUT,*)'Input data file STRFILE ',STRFILE
      WRITE(IUT,*)'cannot be found. Check for its existence'
      WRITE(IUT,*)'and/or correct path.'
	CALL FULLSTOP(' ')
      END SUBROUTINE READSTR_MESG01

	SUBROUTINE READSTR_MESG02
      WRITE(IUT,*)'Terminated in <READSTR>:'
      WRITE(IUT,*)'Section TRAN in STRFILE ',STRFILE
      WRITE(IUT,*)'cannot be found. It should be present'
	WRITE(IUT,*)'and describe primitive translations.'
	CALL FULLSTOP(' ')
      END SUBROUTINE READSTR_MESG02

	SUBROUTINE READSTR_MESG03
      WRITE(IUT,*)'Terminated in <READSTR>:'
      WRITE(IUT,*)'Section BASS in STRFILE ',STRFILE
      WRITE(IUT,*)'cannot be found. It should be present'
	WRITE(IUT,*)'and describe basis atoms in the cell.'
	CALL FULLSTOP(' ')
      END SUBROUTINE READSTR_MESG03

	SUBROUTINE READSTR_MESG04
      WRITE(IUT,*)'Terminated in <READSTR>:'
      WRITE(IUT,*)'Section STRN in STRFILE ',STRFILE
      WRITE(IUT,*)'contains wrong STRAIN matrix:'
	DO I=1,3
	WRITE(IUT,*)(STRAIN(J,I,1),J=1,3)
	ENDDO
	WRITE(IUT,*)'Its determinant is equal to zero.'
	CALL FULLSTOP(' ')
      END SUBROUTINE READSTR_MESG04

	SUBROUTINE READSTR_MESG05
      WRITE(IUT,*)'Terminated in <READSTR>:'
      WRITE(IUT,*)'Section DIRS in STRFILE ',STRFILE
      WRITE(IUT,*)'does not contain symmetry direction settings,'
	WRITE(IUT,*)'while control parameter NDIVDIR is set to', NDIVDIR
	WRITE(IUT,*)'in order to plot energy bands along symmetry lines.'
	CALL FULLSTOP(' ')
      END SUBROUTINE READSTR_MESG05

	SUBROUTINE READSTR_MESG06
      WRITE(IUT,*)'Terminated in <READSTR>:'
	WRITE(IUT,*)'Structure file STRFILE is not recoginized.'
	WRITE(IUT,*)'Check its format.'
	CALL FULLSTOP(' ')
      END SUBROUTINE READSTR_MESG06
C **************************************************************
	END SUBROUTINE READSTR






	SUBROUTINE READSTR_BASE(RBAS,ORTH,IDBASE,NDIRDB)
****************************************************************
* Contains database of known crystal strcutures.               *
*     IDbase      TXTST                                        *
*        1         bcc    Body Center Cubic                    *
*        2         bct    Body Center Tetragonal               *
*        3         bco    Body Center Orthorombic              *
*        4         fcc    Face Center Cubic                    *
*        5         fct    Face Center Tetragonal               *
*        6         fco    Face Center Orthorombic              *
*        7         scc    Simple Cubic                         *
*        8         sct    Simple Tetragonal                    *
*        9         sco    Simple Orthorombic                   *
*       10         hcp    Hexagonal Close Packed               *
*  or    0  when the structure is undetermined.                *
****************************************************************
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                     !!! from setup
      USE COM_LABELS,  ONLY : NAMESTRC,TXTST
	IMPLICIT REAL*8 (A-H,O-Z)
	PARAMETER (NDB=10)         ! currently avaiable structures
	DIMENSION DBAS(3,3),GBAS(3,3),RBAS(3,3),TBAS(3,3),ORTH(2:3)
      CHARACTER*150, ALLOCATABLE :: STRBASE(:)
	CHARACTER DTXT(0:NDB)*10,FILE*130,STRARR(80)*1
      LOGICAL EXIST,MODIFIED,DEF,ASK,VAL,NTH,MDF
C Set known structures
	DTXT( 0)='unknown   '
	DTXT( 1)='bcc       '
	DTXT( 2)='bct       '
	DTXT( 3)='bco       '
	DTXT( 4)='fcc       '
	DTXT( 5)='fct       '
	DTXT( 6)='fco       '
	DTXT( 7)='scc       '
	DTXT( 8)='sct       '
	DTXT( 9)='sco       '
	DTXT(10)='hcp       '
C Start looping over structures
	IYES=0
	DO 1000 IDB=1,NDB                          !!! over sorts
	CALL FIND_LBLANK(NAMESTRC,130,NBL1)
	CALL FIND_LBLANK(DTXT(IDB),10,NBL2)
	FILE=NAMESTRC(1:NBL1)//DTXT(IDB)(1:NBL2)
      INQUIRE(FILE=FILE,EXIST=EXIST)
      IF(.NOT.EXIST)GOTO1000
C ********************************
C UNDERSTAND THE LENGHT OF INIFILE
      CALL FILE_LENGHT(FILE,NLEN)
      ALLOCATE(STRBASE(NLEN))
C ********************************
C READ STRBASE TO INTERNAL FILE
      OPEN(UNIT=1,FILE=FILE,STATUS='OLD',FORM='FORMATTED')
      DO ILEN=1,NLEN
      READ(1,FMT='(A150)')STRBASE(ILEN)
      ENDDO
      CLOSE(1)
C GET SECTION CTRS
      CALL READINI_SECT(STRBASE(1),NLEN,ISEC,NSEC,MSEC,
     &  '<section=ctrs',13,'<section=',9,'ok',2)
C Process BtoA
      CALL READINI_CHAR(STRBASE(ISEC),STRBASE(ISEC),NSEC,MSEC,
     &  'btoa',4,IN,1,0,BOA,1,1,CM,1,0,' ',1,0,' ',1,
     &  DEF,ASK,VAL,NTH,.FALSE.)
C Process CtoA
      CALL READINI_CHAR(STRBASE(ISEC),STRBASE(ISEC),NSEC,MSEC,
     &  'ctoa',4,IN,1,0,COA,1,1,CM,1,0,' ',1,0,' ',1,
     &  DEF,ASK,VAL,NTH,.FALSE.)
C GET SECTION TRAN
      CALL READINI_SECT(STRBASE(1),NLEN,ISEC,NSEC,MSEC,
     &  '<section=tran',13,'<section=',9,'ok',2)
C Process RBAS
      DO IVEC=1,3
      READ(STRBASE(ISEC+IVEC),FMT='(80A1)')STRARR
      CALL COMPVEC(STRARR,DBAS(1,IVEC),3)
	ENDDO
C GET SECTION DIRS
      CALL READINI_SECT(STRBASE(1),NLEN,ISEC,NSEC,MSEC,
     &  '<section=dirs',13,'<section=',9,'ok',2)
        READ(STRBASE(ISEC+1),*)NDIRDEF
C ALL NECESSARY INFORMATION READ
	DEALLOCATE(STRBASE)
C Apply b/a,c/a from the database
	DO IVEC=1,3
	DBAS(2,IVEC)=DBAS(2,IVEC)*BOA
	DBAS(3,IVEC)=DBAS(3,IVEC)*COA
	ENDDO
	DO IVEC=1,3
      TBAS(1,IVEC)=RBAS(1,IVEC)
      TBAS(2,IVEC)=RBAS(2,IVEC)
      TBAS(3,IVEC)=RBAS(3,IVEC)
      IF(ABS(ORTH(2)-1.D0).GT.1.D-10.AND.
     &   ABS(BOA    -1.D0).GT.1.D-10)
     &TBAS(2,IVEC)=RBAS(2,IVEC)*BOA
      IF(ABS(ORTH(2)-1.D0).GT.1.D-10.AND.
     &   ABS(BOA    -1.D0).LE.1.D-10)
     &TBAS(2,IVEC)=RBAS(2,IVEC)*ORTH(2)
      IF(ABS(ORTH(3)-1.D0).GT.1.D-10.AND.
     &   ABS(COA    -1.D0).GT.1.D-10)
     &TBAS(3,IVEC)=RBAS(3,IVEC)*COA
      IF(ABS(ORTH(3)-1.D0).GT.1.D-10.AND.
     &   ABS(COA    -1.D0).LE.1.D-10)
     &TBAS(3,IVEC)=RBAS(3,IVEC)*ORTH(3)
	ENDDO
C CHECK STRUCTURE NOW
      CALL READSTR_CROS(GBAS(1,1),DBAS(1,2),DBAS(1,3))
      CALL READSTR_CROS(GBAS(1,2),DBAS(1,3),DBAS(1,1))
      CALL READSTR_CROS(GBAS(1,3),DBAS(1,1),DBAS(1,2))
      W=DBAS(1,1)*GBAS(1,1)
     & +DBAS(2,1)*GBAS(2,1)
     & +DBAS(3,1)*GBAS(3,1)
      DO I=1,3
      GBAS(I,1)=GBAS(I,1)/W
      GBAS(I,2)=GBAS(I,2)/W
      GBAS(I,3)=GBAS(I,3)/W
      ENDDO
C Check whether vector is on the grid
      IYES=0
      DO IVEC=1,3
      X1=TBAS(1,IVEC)*GBAS(1,1)+
     &   TBAS(2,IVEC)*GBAS(2,1)+
     &   TBAS(3,IVEC)*GBAS(3,1)
      X2=TBAS(1,IVEC)*GBAS(1,2)+
     &   TBAS(2,IVEC)*GBAS(2,2)+
     &   TBAS(3,IVEC)*GBAS(3,2)
      X3=TBAS(1,IVEC)*GBAS(1,3)+
     &   TBAS(2,IVEC)*GBAS(2,3)+
     &   TBAS(3,IVEC)*GBAS(3,3)
      J1=NINT(X1)
      J2=NINT(X2)
      J3=NINT(X3)
      IF(ABS(X1-DBLE(J1)).LE.1.D-05.AND.
     &   ABS(X2-DBLE(J2)).LE.1.D-05.AND.
     &   ABS(X3-DBLE(J3)).LE.1.D-05.AND.
     &   ABS(J1)+ABS(J2)+ABS(J3).LE.1)IYES=IYES+1
      ENDDO
      IF(IYES.EQ.3)GOTO 2000
1000	CONTINUE                            !!! over sorts
2000	CONTINUE
C STRUCTURE FOUND IN THE DATABASE
	IF(IYES.EQ.3)IDBASE=IDB
	IF(IYES.EQ.3)NDIRDB=NDIRDEF
C STRUCTURE IS NOT PRESENT 
	IF(IYES.NE.3)IDBASE=0  
	IF(IYES.NE.3)NDIRDB=0
	TXTST=DTXT(IDBASE)
	END SUBROUTINE READSTR_BASE


	SUBROUTINE READSTR_DIRS(IDBASE,PNTNOT,HSPNTR,NDIR)
*****************************************************************
* Specifies high-symmetry lines for the structure from database.*
*****************************************************************
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                     !!! from setup
      USE COM_LABELS,  ONLY : NAMESTRC,TXTST
	PARAMETER (NDB=10)         ! currently avaiable structures
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION HSPNTR(3,2,NDIR)
      CHARACTER*150, ALLOCATABLE :: STRBASE(:)
	CHARACTER DTXT(0:NDB)*10,FILE*130,STRARR(80)*1,PNTNOT(2,NDIR)*1
      LOGICAL EXIST,MODIFIED,DEF,ASK,VAL,NTH,MDF
	IF(IDBASE.EQ.0)RETURN
C Set known structures
	DTXT( 0)='unknown   '
	DTXT( 1)='bcc       '
	DTXT( 2)='bct       '
	DTXT( 3)='bco       '
	DTXT( 4)='fcc       '
	DTXT( 5)='fct       '
	DTXT( 6)='fco       '
	DTXT( 7)='scc       '
	DTXT( 8)='sct       '
	DTXT( 9)='sco       '
	DTXT(10)='hcp       '
C Start looping over structures
	CALL FIND_LBLANK(NAMESTRC,130,NBL1)
	CALL FIND_LBLANK(DTXT(IDBASE),10,NBL2)
	FILE=NAMESTRC(1:NBL1)//DTXT(IDBASE)(1:NBL2)
C ********************************
C UNDERSTAND THE LENGHT OF INIFILE
      CALL FILE_LENGHT(FILE,NLEN)
      ALLOCATE(STRBASE(NLEN))
C ********************************
C READ STRBASE TO INTERNAL FILE
      OPEN(UNIT=1,FILE=FILE,STATUS='OLD',FORM='FORMATTED')
      DO ILEN=1,NLEN
      READ(1,FMT='(A150)')STRBASE(ILEN)
      ENDDO
      CLOSE(1)
C GET SECTION DIRS
      CALL READINI_SECT(STRBASE(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=dirs',13,'<section=',9,'ok',2)
	IREC=ISEC+1
      READ(STRBASE(IREC),*)NDIRDF
      DO IDIR=1,NDIR
	IREC=IREC+1
      READ(STRBASE(IREC),FMT='(2(1X,A1))')
     &(PNTNOT(IVEC,IDIR),IVEC=1,2)
	IREC=IREC+1
      READ(STRBASE(IREC),FMT='(80A1)')STRARR
      CALL COMPVEC(STRARR,HSPNTR(1,1,IDIR),6)
	ENDDO
C ALL NECESSARY INFORMATION READ
	DEALLOCATE(STRBASE)
	END SUBROUTINE READSTR_DIRS



      SUBROUTINE READSTR_CROS(A,B,C)
**********************************************************
*    Cross product (AX,AY,AZ)=(BX,BY,BZ)*(CX,CY,CZ)      *
**********************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(3),B(3),C(3)
      A(1)=B(2)*C(3)-B(3)*C(2)
      A(2)=B(3)*C(1)-B(1)*C(3)
      A(3)=B(1)*C(2)-B(2)*C(1)
      END SUBROUTINE READSTR_CROS






      SUBROUTINE READSTR_SHOW
***************************************************
*  Print STRFILE data                             *
***************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_PARAM,   ONLY : NATOM,NSORT,NSPIN,IS            !!! from readini
      USE COM_LATPAR,  ONLY : PAR,PAR0,VV0,ORTH,STRAIN,OMEGAC !!! from readini
      USE COM_INPTTR,  ONLY : NDIR,HSPNT,PNTNOT               !!! from readstr
      USE COM_LATTICE, ONLY : RBAS,GBAS,BBAS,TAU,TAO,ISTRAIN  !!! from readstr
      USE COM_VECGEN,  ONLY : NIVEC,ALPHEVL                   !!! from readstr
      USE COM_LMTINP,  ONLY : STRFILE                         !!! from readini
      USE COM_LMTOUT,  ONLY : ICKOV,KOVFILE                   !!! from readini
      USE COM_LABELS,  ONLY : TXTEL,TXTAT,TXTSP,HEADSTR       !!! from readini
      USE COM_UNIT,    ONLY : IUN,IUR,IUT                     !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER SYS*1,TXT*72
      INTEGER M3(5)
C  PRINT HEAD
      WRITE(IUN,1000)
1000  FORMAT(/'<<<--- STRFILE READ --->>>'/)
	CALL FIND_LBLANK(STRFILE,130,NBL)
	WRITE(IUN,1001)
	WRITE(IUN,1002)
1001	FORMAT(1X,'<FILE=STRFILE,INPUT=MODERN>')
1002  FORMAT('****************************************************')
C  PRINT TITLE
	WRITE(IUN,1010)
      WRITE(IUN,1011)HEADSTR
1010	FORMAT(1X,'<SECTION=HEDS>            ! STRUCTURE TITLE:')
1011  FORMAT(1X,'Slabl =',A64)
C  PRINT CONTROL PARAMETERS
      WRITE(IUN,1030)
1030  FORMAT(1X,'<SECTION=CTRS>            ! CONTROL STRUCTURE: ')
      WRITE(IUN,1031)NATOM
      WRITE(IUN,1032)ORTH(2)
      WRITE(IUN,1033)ORTH(3)
1031  FORMAT(1X,'Natom =',I3,15X,  ' ! # of atoms in unit-cell')
1032  FORMAT(1X,'BtoA  =',G12.5,6X,' ! orthorombicity  along b')
1033  FORMAT(1X,'CtoA  =',G12.5,6X,' ! orthorombicity  along c')
      IF(ISTRAIN.EQ.1)WRITE(IUN,1034)ISTRAIN
      IF(ISTRAIN.NE.1)WRITE(IUN,1035)ISTRAIN
1034  FORMAT(1X,'Istrn =',I3,15X,  ' ! distort cutoff sphere  ')
1035  FORMAT(1X,'Istrn =',I3,15X,  ' ! select plws in sphere  ')
      WRITE(IUN,1036)NIVEC 
      WRITE(IUN,1037)ALPHEVL
1036  FORMAT(1X,'Nvecs =',I5,13X,  ' ! vectors in Evald method')
1037  FORMAT(1X,'Evald =',G12.5,6X,' ! splitting factor  there')
      WRITE(IUN,1040)
1040  FORMAT(1X,'<SECTION=TRAN>            ! PRIMITIVE TRANSLATIONS:')
      WRITE(IUN,1041)(RBAS(J,1),J=1,3)
      WRITE(IUN,1042)(RBAS(J,2),J=1,3)
      WRITE(IUN,1043)(RBAS(J,3),J=1,3)
1041  FORMAT(1X,' ',G12.5,',',G12.5,',',G12.5,'  ! R1x,R1y,R1z')
1042  FORMAT(1X,' ',G12.5,',',G12.5,',',G12.5,'  ! R2x,R2y,R2z')
1043  FORMAT(1X,' ',G12.5,',',G12.5,',',G12.5,'  ! R3x,R3y,R3z')
      WRITE(IUN,1050)
1050  FORMAT(1X,'<SECTION=BASS>            ! BASIS ATOMS :')
      DO IATOM=1,NATOM
      WRITE(IUN,1051)(TAO(J,IATOM),J=1,3),TXTEL(IS(IATOM))
  	ENDDO      
1051  FORMAT(1X,' ',G12.5,',',G12.5,',',G12.5,'  ! ',A10)
      WRITE(IUN,1052)
1052  FORMAT(1X,'<SECTION=DIST>            ! DISPLACEMENT FIELD:')
      DO IATOM=1,NATOM
      WRITE(IUN,1051)(TAU(J,IATOM)-TAO(J,IATOM),J=1,3),
     &TXTEL(IS(IATOM))
  	ENDDO      
      WRITE(IUN,1070)
1070  FORMAT(1X,'<SECTION=STRN>            ! STRAIN MATRIX:')
      WRITE(IUN,1071)(STRAIN(1,I,1),I=1,3)
      WRITE(IUN,1072)(STRAIN(2,I,1),I=1,3)
      WRITE(IUN,1073)(STRAIN(3,I,1),I=1,3)
1071  FORMAT(1X,' ',G12.5,',',G12.5,',',G12.5,'  ! Rxx,Rxy,Rxz')
1072  FORMAT(1X,' ',G12.5,',',G12.5,',',G12.5,'  ! Ryx,Ryy,Ryz')
1073  FORMAT(1X,' ',G12.5,',',G12.5,',',G12.5,'  ! Rzx,Rzy,Rzz')
      WRITE(IUN,1080)
1080  FORMAT(1X,'<SECTION=SYMM>            ! SYMMETRY GROUP:')
	CALL FIND_LBLANK(KOVFILE,130,NB)
      IF(ICKOV.EQ.1)WRITE(IUN,1081)
      IF(ICKOV.EQ.2)WRITE(IUN,1082)
      IF(ICKOV.EQ.3)WRITE(IUN,1083)KOVFILE(:NB)
      IF(ICKOV.EQ.0)WRITE(IUN,1084)
1081  FORMAT(1X,'Rsys  = C                 ! Cubic system')
1082  FORMAT(1X,'Rsys  = H                 ! Hex.  system')
1083  FORMAT(1X,'Rsys  = A ; kovfile= ',A)
1084  FORMAT(1X,'! will be determined below')
      WRITE(IUN,1090)
1090  FORMAT(1X,'<SECTION=RLAT>            ! RECIPROCAL LATTICE:')
      WRITE(IUN,1091)(GBAS(J,1),J=1,3)
      WRITE(IUN,1092)(GBAS(J,2),J=1,3)
      WRITE(IUN,1093)(GBAS(J,3),J=1,3)
1091  FORMAT(1X,' ',G12.5,',',G12.5,',',G12.5,'  ! G1x,G1y,G1z')
1092  FORMAT(1X,' ',G12.5,',',G12.5,',',G12.5,'  ! G2x,G2y,G2z')
1093  FORMAT(1X,' ',G12.5,',',G12.5,',',G12.5,'  ! G3x,G3y,G3z')
      WRITE(IUN,1100)
1100  FORMAT(1X,'<SECTION=ZONE>            ! BRILLOUIN ZONE :')
      WRITE(IUN,1101)(BBAS(J,1),J=1,3)
      WRITE(IUN,1102)(BBAS(J,2),J=1,3)
      WRITE(IUN,1103)(BBAS(J,3),J=1,3)
1101  FORMAT(1X,' ',G12.5,',',G12.5,',',G12.5,'  ! K1x,K1y,K1z')
1102  FORMAT(1X,' ',G12.5,',',G12.5,',',G12.5,'  ! K2x,K2y,K2z')
1103  FORMAT(1X,' ',G12.5,',',G12.5,',',G12.5,'  ! K3x,K3y,K3z')
      WRITE(IUN,1110)
1110  FORMAT(1X,'<SECTION=DIRS>            ! HIGH-SYMMETRY LINES:')
      WRITE(IUN,1111)NDIR
1111  FORMAT(1X,'       ',I3,15X,' ! # of directions in BZ')
      DO 20 IDIR=1,NDIR
      WRITE(IUN,1112)(PNTNOT(K,IDIR),K=1,2)
      WRITE(IUN,1113)(HSPNT(J,1,IDIR),J=1,3)
      WRITE(IUN,1114)(HSPNT(J,2,IDIR),J=1,3)
  20  CONTINUE
1112  FORMAT(1X,A1,'-',A1,10X,' ! point notations')
1113  FORMAT(1X,' ',G12.5,',',G12.5,',',G12.5,'  ! lx,ly,1z')
1114  FORMAT(1X,' ',G12.5,',',G12.5,',',G12.5,'  ! nx,ny,nz')
      WRITE(IUN,1200)OMEGAC
1200  FORMAT(1X,'Cell Volume =',G14.7)
      END
	
