	SUBROUTINE VEXCH(KEY)
************************************************************
*  The calculation of the exchange-correlation potential   *
*  within MTS using direct spherical-harmonic expansion.   *
*  Generalized gradient corrections after Perdew  added.   *
*  Key=1 - potential, =2 - energy density                  *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY: IEXC                             !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSV  !!! from readini
      USE COM_SPHERE  ,ONLY: ZNUC,ZCOR,SMT                    !!! from readini
      USE COM_SYMMLM  ,ONLY: SYM,LMSYM                        !!! from symlmm
      USE COM_POTDAT  ,ONLY: POT                              !!! from potfull
      USE COM_DENDAT  ,ONLY: RHO                              !!! from rhofull
      USE COM_RADMESH ,ONLY: NRAD,H,R,DR,WEIGHT,RL            !!! from radmesh
      USE COM_MASHDEP ,ONLY: LENCMP                           !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
	INTEGER, ALLOCATABLE :: NCUT(:)
	REAL*8,  ALLOCATABLE :: ZL(:,:)
	REAL*8,  ALLOCATABLE :: WL(:,:)
	COMPLEX*16, ALLOCATABLE :: G1RO(:,:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: G2RO(:,:,:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: FUN(:,:)
	COMPLEX*16, ALLOCATABLE :: DRODR(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: YLM(:)
	COMPLEX*16, ALLOCATABLE :: YLMI(:)
	COMPLEX*16 ROTOT(2,2),G1TOT(2,2,-1:1),G2TOT(2,2,-1:1,-1:1)
     &    ,GR1UP(-1:1),GR2UP(-1:1,-1:1),DIM,RHOL,D0M(-1:1)
     &    ,GR1DN(-1:1),GR2DN(-1:1,-1:1),XC(2),DXC(2)
     &    ,GR1RHO(-1:1),GR1MAG(-1:1,-1:1),GR2RHO(-1:1,-1:1)
     &    ,GR2MAG(-1:1,-1:1,-1:1),GR1MOD(-1:1),GR2MOD(-1:1,-1:1)
	LOGICAL TEILOR
	DATA PI/3.141592653589793D0/,TEILOR/.FALSE./
      CALL ABORTNOW()
	SQPI4=2.D0*SQRT(PI)
	SFACT=0.5D0*DBLE(NSPIN)
C MEMORY ALLOCATIONS FOR SCRATCH ARRAYS
	NTHEMEM=4*LMAXVMEM+6
	ALLOCATE(NCUT(NSORTMEM))
	ALLOCATE(ZL(NTHEMEM,2))
	ALLOCATE(WL(NTHEMEM,2))
	ALLOCATE(FUN(0:NRADMEM,LIMVMEM))
	ALLOCATE(DRODR(0:NRADMEM,NSPINMEM,NORBSMEM,2))
	ALLOCATE(YLM(LIMVMEM))
	ALLOCATE(YLMI(LIMVMEM))
	ALLOCATE(G1RO(0:NRADMEM,LIMVMEM,NSPINMEM,NORBSMEM,NGGAMEM))
	ALLOCATE(G2RO(0:NRADMEM,LIMVMEM,NSPINMEM,NORBSMEM,
     &NGGAMEM,NGGAMEM))
      SIZE_G1RO=DBLE(SIZE(G1RO)*LENCMP)/1024.D0**2
      SIZE_G2RO=DBLE(SIZE(G2RO)*LENCMP)/1024.D0**2
      CURMEM=CURMEM+SIZE_G1RO+SIZE_G2RO
      IF(TOTMEM.LT.CURMEM)TXTMEM='<VEXCH> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
C Set keys for LDA and GGA
      ILDA=MOD(IEXC,10)     !!! LDA key
      IGGA=(IEXC-ILDA)/10   !!! GGA key
C START LOOPING OVER ALL ATOMS IN CELL
      DO 1000 IATOM=1,NATOM               !!! over all atoms in cell
	ISORT=IS(IATOM)
C Set gradients to zero
	DO NY=-1,1
	GR1UP(NY)=(0.D0,0.D0)
	GR1DN(NY)=(0.D0,0.D0)
	DO NY1=-1,1
	GR2UP(NY,NY1)=(0.D0,0.D0)
	GR2DN(NY,NY1)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ALRUP=0.D0
	ALRDN=0.D0
C ***** COMPUTE DENSITY GRADIENTS FOR GGA ****
C Compute spherical density gradients
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	CALL CDERIV1(RHO(0,1,IATOM,IUPDN,IORBS),DRODR(0,IUPDN,IORBS,1),
     &NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),SMT(ISORT))
	CALL CDERIV1(DRODR(0,IUPDN,IORBS,1),DRODR(0,IUPDN,IORBS,2),
     &NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),SMT(ISORT))
	ENDDO 
	ENDDO
C Compute full density gradients
	IF(IGGA.NE.0)THEN
      DO IORBS=1,NORBS                    !!! over spins
      DO IUPDN=1,NSPIN                    !!! over spins
      DO L=0,ILSV(ISORT)
      DO M=-L,L
      LM=L*(L+1)+M+1
	ISYM=LMSYM(LM,IATOM)
      DO IRAD=0,NRAD(ISORT)
      FUN(IRAD,LM)=(0.D0,0.D0)
	IF(SYM(LM,IATOM))
     &FUN(IRAD,LM)=RHO(IRAD,ISYM,IATOM,IUPDN,IORBS)
      ENDDO
      ENDDO
      ENDDO
	DO NY=-1,1                          !!! over directions
C Nabla_mu(Rho)
	CALL GRADFUN(FUN(0,1),G1RO(0,1,IUPDN,IORBS,NY+2),NY,ILSV(ISORT),
     &NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),SMT(ISORT))
	DO NY1=-1,1                         !!! over directions
C Nabla_mu*Nabla_mu'(Rho)
	CALL GRADFUN(G1RO(0,1,IUPDN,IORBS,NY+2),
     &G2RO(0,1,IUPDN,IORBS,NY+2,NY1+2),NY1,ILSV(ISORT),
     &NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),SMT(ISORT))
	ENDDO                               !!! over directions
      ENDDO                               !!! over directions
      ENDDO                               !!! over spins
      ENDDO                               !!! over iorbs
	ENDIF
C ***** CALCULATE EXCHANGE-CORRELATION USING TEILOR SERIES *****
      IF(ABS(ZNUC(ISORT)).GE.1.D-05)
     &RCUT1=0.03D0*ZNUC(ISORT)**(1.D0/3.D0)
      IF(ABS(ZNUC(ISORT)).LE.1.D-05)RCUT1=0.0D0
	IF(RCUT1.GT.SMT(ISORT))
     &CALL FULLSTOP('<VEXCH>:RCUT>SMT NOT ASSUMED')
      NCUT(ISORT)=0
      DO IRAD=0,NRAD(ISORT)
      IF(R(IRAD,ISORT).LT.RCUT1)NCUT(ISORT)=IRAD
      ENDDO
	IF(.NOT.TEILOR)NCUT(ISORT)=-1       !!! switch off this part
      DO 100 IRAD=0,NCUT(ISORT)           !!! over irad
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	ROTOT(IUPDN,IORBS)=RHO(IRAD,1,IATOM,IUPDN,IORBS)/SQPI4
	ENDDO
	ENDDO
	ARHO=DREAL(ROTOT(1,1)+ROTOT(NSPIN,1))*SFACT
	ZMAG=DREAL(ROTOT(1,1)-ROTOT(NSPIN,1))
	AMAG=SQRT(ZMAG*ZMAG)
	IF(NORBS.EQ.2)THEN
	D0M( 0)=ROTOT(1,1)-ROTOT(NSPIN,1)
	D0M(-1)=ROTOT(1,NORBS)
	D0M(+1)=ROTOT(2,NORBS)
	AMAG=SQRT(DCONJG(D0M( 0))*D0M( 0)+
     &          DCONJG(D0M(-1))*D0M(-1)+
     &          DCONJG(D0M(+1))*D0M(+1))
	ENDIF
C Spin densities
	ROUP=0.5D0*(ARHO+AMAG)
	RODN=0.5D0*(ARHO-AMAG)
C Gradients from spherical densities, let x=y=z=r/sqrt(3)
	IF(IGGA.NE.0)THEN
	DO IA=-1,1
	GR1RHO(IA)  =(DRODR(IRAD,1,1,1)+DRODR(IRAD,NSPIN,1,1))/
     &SQRT(3.D0)/SQPI4*SFACT
	GR1MAG(IA,0)=(DRODR(IRAD,1,1,1)-DRODR(IRAD,NSPIN,1,1))/
     &SQRT(3.D0)/SQPI4
	GR1MAG(IA,-1)=(0.D0,0.D0)
	GR1MAG(IA,+1)=(0.D0,0.D0)
	IF(NORBS.EQ.2)THEN
	GR1MAG(IA,-1)=DRODR(IRAD,1,NORBS,1)*SQRT(3.D0)/SQPI4
	GR1MAG(IA,+1)=DRODR(IRAD,2,NORBS,1)*SQRT(3.D0)/SQPI4
	ENDIF
	ENDDO
	DO IA=-1,1
	DO IB=-1,1
	IF(IA.EQ.IB)SD=+2.D0
	IF(IA.NE.IB)SD=-1.D0
	IF(IRAD.EQ.0)RR=R(1,ISORT)
	IF(IRAD.NE.0)RR=R(IRAD,ISORT)
	GR2RHO(IA,IB)  =((DRODR(IRAD,1,1,1)+DRODR(IRAD,NSPIN,1,1))/RR*SD+
     &(DRODR(IRAD,1,1,2)+DRODR(IRAD,NSPIN,1,2)))/3.D0/SQPI4*SFACT
	GR2MAG(IA,IB,0)=((DRODR(IRAD,1,1,1)-DRODR(IRAD,NSPIN,1,1))/RR*SD+
     &(DRODR(IRAD,1,1,2)-DRODR(IRAD,NSPIN,1,2)))/3.D0/SQPI4
	GR2MAG(IA,IB,-1)=(0.D0,0.D0)
	GR2MAG(IA,IB,+1)=(0.D0,0.D0)
	IF(NORBS.EQ.2)THEN
	GR2MAG(IA,IB,-1)=(DRODR(IRAD,1,NORBS,1)/RR*SD+
     &DRODR(IRAD,1,NORBS,2))/3.D0/SQPI4
	GR2MAG(IA,IB,+1)=(DRODR(IRAD,2,NORBS,1)/RR*SD+
     &DRODR(IRAD,2,NORBS,2))/3.D0/SQPI4
	ENDIF
	ENDDO
	ENDDO
C
	IF(ABS(AMAG).GT.1.D-14)RMAG=1.D0/AMAG
	IF(ABS(AMAG).LE.1.D-14)RMAG=0.D0
	DO IA=-1,1
	GR1MOD(IA)=(0.D0,0.D0)
	DO MY=-1,1
	GR1MOD(IA)=GR1MOD(IA)+0.5D0*(DCONJG(D0M(MY))*GR1MAG(IA,MY)+
     &D0M(MY)*DCONJG(GR1MAG(IA,MY)))*RMAG
	ENDDO
	ENDDO
	DO IA=-1,1
	DO IB=-1,1
	GR2MOD(IA,IB)=-GR1MOD(IA)*GR1MOD(IB)*RMAG
	DO MY=-1,1
	GR2MOD(IA,IB)=GR2MOD(IA,IB)+0.5D0*RMAG*(
     &DCONJG(GR1MAG(IB,MY))*GR1MAG(IA,MY)+
     &DCONJG(GR1MAG(IA,MY))*GR1MAG(IB,MY)+
     &DCONJG(D0M(MY))*GR2MAG(IA,IB,MY)+
     &D0M(MY)*DCONJG(GR2MAG(IA,IB,MY)))
	ENDDO
	ENDDO
	ENDDO
C
	ALRUP=0.D0
	ALRDN=0.D0
	DO IA=-1,1
	GR1UP(IA)=0.5D0*(GR1RHO(IA)+GR1MOD(IA))
	GR1DN(IA)=0.5D0*(GR1RHO(IA)-GR1MOD(IA))
	DO IB=-1,1
	GR2UP(IA,IB)=0.5D0*(GR2RHO(IA,IB)+GR2MOD(IA,IB))
	GR2DN(IA,IB)=0.5D0*(GR2RHO(IA,IB)-GR2MOD(IA,IB))
	ENDDO
	ALRUP=ALRUP+GR2UP(IA,IA)
	ALRDN=ALRDN+GR2DN(IA,IA)
	ENDDO
	ENDIF
C SET EXCHANGE-CORRELATION
	CALL EXCVXC(ROUP,RODN,GR1UP,GR1DN,GR2UP,GR2DN,ALRUP,ALRDN,
     &     IEXC,KEY,NSPIN,EXCUP,EXCDN,VXCUP,VXCDN)
	IF(KEY.EQ.1)XC(1)=VXCUP
	IF(KEY.EQ.1)XC(2)=VXCDN
	IF(KEY.EQ.2)XC(1)=EXCUP
	IF(KEY.EQ.2)XC(2)=EXCDN
      DO IUPDN=1,NSPIN                    !!! over spins
	POT(IRAD,1,IATOM,IUPDN,1)=POT(IRAD,1,IATOM,IUPDN,1)+
     &0.5D0*(XC(1)+XC(NSPIN))
	IF(ABS(AMAG).GT.1.D-14)
     &POT(IRAD,1,IATOM,IUPDN,1)=POT(IRAD,1,IATOM,IUPDN,1)+
     &(-1)**(IUPDN+1)*0.5D0*(XC(1)-XC(NSPIN))*ZMAG/AMAG*SQPI4
	IF(NORBS.EQ.2.AND.ABS(AMAG).GT.1.D-14)
     &POT(IRAD,1,IATOM,IUPDN,NORBS)=POT(IRAD,1,IATOM,IUPDN,NORBS)+
     &0.5D0*(XC(1)-XC(NSPIN))*ROTOT(IUPDN,NORBS)/AMAG*SQPI4
	ENDDO                               !!! over spins
C	DO JSPIN=1,NSPIN                    !!! over spins
C SET CHANGE IN THE EXCHANGE-CORRELATION
C	IVAR=JSPIN ! vary with respect to spin densities only
C	CALL DEXCVXC(ROUP,RODN,GR1UP,GR1DN,GR2UP,GR2DN,ALRUP,ALRDN,
C    &     IEXC,IVAR,KEY,NSPIN,DEXCUP,DEXCDN,DVXCUP,DVXCDN)
C	IF(KEY.EQ.1)DXC(1)=DVXCUP
C	IF(KEY.EQ.1)DXC(2)=DVXCDN
C	IF(KEY.EQ.2)DXC(1)=DEXCUP
C	IF(KEY.EQ.2)DXC(2)=DEXCDN
C	DO ISPIN=1,NSPIN
C	DO L=1,ILSV(ISORT)                  !!! over l
C	DO M=-L,L                           !!! over m
C	LM=L*(L+1)+M+1
C	ISYM=LMSYM(LM,IATOM)
C	IF(SYM(LM,IATOM))THEN               !!! for only non-zero components
C	POT(IRAD,ISYM,IATOM,ISPIN,1)=POT(IRAD,ISYM,IATOM,ISPIN,1)+
C    &DXC(ISPIN)*RHO(IRAD,ISYM,IATOM,JSPIN,1)    ! without GGA here
C	ENDIF                               !!! for only non-zero components
C     ENDDO                               !!! over m
C     ENDDO                               !!! over l
C     ENDDO                               !!! over spins
C     ENDDO                               !!! over spins
 100  CONTINUE                            !!! over radial mesh
C **** CALCULATE EXCHANGE-CORRELATION BY DIRECT EXPANSION ****
      IF(ABS(ZNUC(ISORT)).GE.1.D-05)
     &RCUT2=0.3D0*ZNUC(ISORT)**(1.D0/3.D0)
      IF(ABS(ZNUC(ISORT)).LE.1.D-05)RCUT2=0.0D0
      NTHETA=2*ILSV(ISORT)+3
      IF(IGGA.EQ.0)NTWO=1 ! do not increase mesh in LDA
      IF(IGGA.NE.0)NTWO=2 ! increase mesh twice for GGA
	CALL MKLEGW(     NTHETA,ZL(1,1),WL(1,1),0)
	CALL MKLEGW(NTWO*NTHETA,ZL(1,2),WL(1,2),0)
	DO 400 IRAD=NCUT(ISORT)+1,NRAD(ISORT)!! over radial mesh
	IF(R(IRAD,ISORT).LE.RCUT2)MTWO=1
	IF(R(IRAD,ISORT).GT.RCUT2)MTWO=NTWO
	DO 300 ITHETA=1,NTHETA*MTWO         !!! over theta
	NPHI=NTHETA*MTWO
	ZCOORD=ZL(ITHETA,MTWO)
	STHETA=SQRT(1.D0-ZCOORD*ZCOORD)
	DPHI=2.D0*PI/DBLE(NPHI)
	WGTL=DPHI*WL(ITHETA,MTWO) 
	DO 200 IPHI=1,NPHI                  !!! over phi
	PHI=DBLE(IPHI-1)*DPHI
	XCOORD=COS(PHI)*STHETA
	YCOORD=SIN(PHI)*STHETA
 	CALL SPHHARM(XCOORD,YCOORD,ZCOORD,ILSV(ISORT),YLM)
 	DIM=(0.D0,-1.D0)
      DO L=0,ILSV(ISORT)
      DIM=DIM*(0.D0,1.D0)
      DO M=-L,L
      LM=L*(L+1)+M+1
      YLMI(LM)=YLM(LM)*DIM
      ENDDO
      ENDDO
C SET UP TOTAL DENSITY AT THE POINT "R,THETA,PHI"
	DO IORBS=1,NORBS                    !!! over iorbs
	DO IUPDN=1,NSPIN                    !!! over spins 
	ROTOT(IUPDN,IORBS)=(0.D0,0.D0)
	DO L=0,ILSV(ISORT)                  !!! over l 
	DO M=-L,L                           !!! over m 
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	ROTOT(IUPDN,IORBS)=ROTOT(IUPDN,IORBS)+
     &RHO(IRAD,ISYM,IATOM,IUPDN,IORBS)*YLMI(LM)
	ENDIF
      ENDDO                               !!! over m
      ENDDO                               !!! over l
      ENDDO                               !!! over spins
      ENDDO                               !!! over iorbs
C SET UP DENSITY GRADIENTS AT THE POINT "R,THETA,PHI"
	IF(IGGA.NE.0)THEN
	ITWO=2
	DO NY=-1,1                          !!! over directions
	DO IORBS=1,NORBS                    !!! over iorbs
	DO IUPDN=1,NSPIN                    !!! over spins 
	G1TOT(IUPDN,IORBS,NY   )=(0.D0,0.D0)
	G2TOT(IUPDN,IORBS,NY,-1)=(0.D0,0.D0)
	G2TOT(IUPDN,IORBS,NY, 0)=(0.D0,0.D0)
	G2TOT(IUPDN,IORBS,NY,+1)=(0.D0,0.D0)
	DO L=0,ILSV(ISORT)                  !!! over l 
	DO M=-L,L                           !!! over m 
	LM=L*(L+1)+M+1
	G1TOT(IUPDN,IORBS,NY   )=G1TOT(IUPDN,IORBS,NY   )+
     &  YLMI(LM)*G1RO(IRAD,LM,IUPDN,IORBS,NY+2   )
	G2TOT(IUPDN,IORBS,NY,-1)=G2TOT(IUPDN,IORBS,NY,-1)+
     &  YLMI(LM)*G2RO(IRAD,LM,IUPDN,IORBS,NY+2,-1+ITWO)
	G2TOT(IUPDN,IORBS,NY, 0)=G2TOT(IUPDN,IORBS,NY, 0)+
     &  YLMI(LM)*G2RO(IRAD,LM,IUPDN,IORBS,NY+2, 0+ITWO)
	G2TOT(IUPDN,IORBS,NY,+1)=G2TOT(IUPDN,IORBS,NY,+1)+
     &  YLMI(LM)*G2RO(IRAD,LM,IUPDN,IORBS,NY+2,+1+ITWO)
      ENDDO                               !!! over m
      ENDDO                               !!! over l
      ENDDO                               !!! over spins 
      ENDDO                               !!! over iorbs
	ENDDO                               !!! over directions
	ENDIF
C FIND CONTRIBUTION TO EXCHANGE-CORRELATION POTENTIAL FROM "R,THETA,PHI"
	ARHO=DREAL(ROTOT(1,1)+ROTOT(NSPIN,1))*SFACT
	ZMAG=DREAL(ROTOT(1,1)-ROTOT(NSPIN,1))
	AMAG=SQRT(ZMAG*ZMAG)
	IF(NORBS.EQ.2)THEN
	D0M( 0)=ROTOT(1,1)-ROTOT(NSPIN,1)
	D0M(-1)=ROTOT(1,NORBS)
	D0M(+1)=ROTOT(2,NORBS)
	AMAG=SQRT(DCONJG(D0M( 0))*D0M( 0)+
     &          DCONJG(D0M(-1))*D0M(-1)+
     &          DCONJG(D0M(+1))*D0M(+1))
	ENDIF
C Spin densities
	ROUP=0.5D0*(ARHO+AMAG)
	RODN=0.5D0*(ARHO-AMAG)
C Spin gradients
	IF(IGGA.NE.0)THEN
	DO NY=-1,1
	GR1RHO(NY)=(G1TOT(1,1,NY)+G1TOT(NSPIN,1,NY))*SFACT
	GR1MAG(NY,0)=(G1TOT(1,1,NY)-G1TOT(NSPIN,1,NY))
	GR1MAG(NY,-1)=(0.D0,0.D0)
	GR1MAG(NY,+1)=(0.D0,0.D0)
	IF(NORBS.EQ.2)THEN
	GR1MAG(NY,-1)=G1TOT(1,NORBS,NY)
	GR1MAG(NY,+1)=G1TOT(2,NORBS,NY)
	ENDIF
	ENDDO
	DO NY=-1,1
	DO NY1=-1,1
	GR2RHO(NY,NY1)=(G2TOT(1,1,NY,NY1)+G2TOT(NSPIN,1,NY,NY1))*SFACT
	GR2MAG(NY,NY1,0)=(G2TOT(1,1,NY,NY1)-G2TOT(NSPIN,1,NY,NY1))
	GR2MAG(NY,NY1,-1)=(0.D0,0.D0)
	GR2MAG(NY,NY1,+1)=(0.D0,0.D0)
	IF(NORBS.EQ.2)THEN
	GR2MAG(NY,NY1,-1)=G2TOT(1,NORBS,NY,NY1)
	GR2MAG(NY,NY1,+1)=G2TOT(2,NORBS,NY,NY1)
	ENDIF
	ENDDO
	ENDDO
C
	IF(ABS(AMAG).GT.1.D-14)RMAG=1.D0/AMAG
	IF(ABS(AMAG).LE.1.D-14)RMAG=0.D0
	DO NY=-1,1
	GR1MOD(NY)=(0.D0,0.D0)
	DO MY=-1,1
	GR1MOD(NY)=GR1MOD(NY)+0.5D0*(DCONJG(D0M(MY))*GR1MAG(NY,MY)+
     &D0M(MY)*DCONJG(GR1MAG(NY,MY)))*RMAG
	ENDDO
	ENDDO
	DO NY=-1,1
	DO NY1=-1,1
	GR2MOD(NY,NY1)=-GR1MOD(NY)*GR1MOD(NY1)*RMAG
	DO MY=-1,1
	GR2MOD(NY,NY1)=GR2MOD(NY,NY1)+0.5D0*RMAG*(
     &DCONJG(GR1MAG(NY1,MY))*GR1MAG(NY,MY)+
     &DCONJG(GR1MAG(NY,MY))*GR1MAG(NY1,MY)+
     &DCONJG(D0M(MY))*GR2MAG(NY,NY1,MY)+
     &D0M(MY)*DCONJG(GR2MAG(NY,NY1,MY)))
	ENDDO
	ENDDO
	ENDDO
C
	ALRUP=0.D0
	ALRDN=0.D0
	DO NY=-1,1
	GR1UP(NY)=0.5D0*(GR1RHO(NY)+GR1MOD(NY))
	GR1DN(NY)=0.5D0*(GR1RHO(NY)-GR1MOD(NY))
	DO NY1=-1,1
	GR2UP(NY,NY1)=0.5D0*(GR2RHO(NY,NY1)+GR2MOD(NY,NY1))
	GR2DN(NY,NY1)=0.5D0*(GR2RHO(NY,NY1)-GR2MOD(NY,NY1))
	ENDDO
	ALRUP=ALRUP+(-1)**NY*GR2UP(NY,-NY)
	ALRDN=ALRDN+(-1)**NY*GR2DN(NY,-NY)
	ENDDO
	ENDIF
 	CALL EXCVXC(ROUP,RODN,GR1UP,GR1DN,GR2UP,GR2DN,ALRUP,ALRDN,
     &     IEXC,KEY,NSPIN,EXCUP,EXCDN,VXCUP,VXCDN)
	IF(KEY.EQ.1)XC(1)=VXCUP
	IF(KEY.EQ.1)XC(2)=VXCDN
	IF(KEY.EQ.2)XC(1)=EXCUP
	IF(KEY.EQ.2)XC(2)=EXCDN
	DO IORBS=1,NORBS                    !!! over iorbs
	DO IUPDN=1,NSPIN                    !!! over spins
	IF(IORBS.EQ.1)
     &RHOL=0.5D0*(XC(1)+XC(NSPIN))
	IF(IORBS.EQ.1.AND.ABS(AMAG).GT.1.D-14)
     &RHOL=RHOL+(-1)**(IUPDN+1)*
     &0.5D0*(XC(1)-XC(NSPIN))*ZMAG/AMAG
	IF(IORBS.EQ.2)
     &RHOL=(0.D0,0.D0)
	IF(IORBS.EQ.2.AND.ABS(AMAG).GT.1.D-14)
     &RHOL=0.5D0*(XC(1)-XC(NSPIN))*ROTOT(IUPDN,NORBS)/AMAG
	RHOL=RHOL*WGTL
	DO L=0,ILSV(ISORT)                  !!! over l 
	DO M=-L,L                           !!! over m 
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	POT(IRAD,ISYM,IATOM,IUPDN,IORBS)=
     &POT(IRAD,ISYM,IATOM,IUPDN,IORBS)+DCONJG(YLMI(LM))*RHOL
	ENDIF
      ENDDO                               !!! over m
      ENDDO                               !!! over l
      ENDDO                               !!! over spins
      ENDDO                               !!! over iorbs
 200  CONTINUE                            !!! over phi
 300  CONTINUE                            !!! over theta
 400	CONTINUE                            !!! over radial points
1000	CONTINUE                            !!! over atoms
C MEMORY DEALLOCATIONS
	DEALLOCATE(NCUT,ZL,WL,FUN,DRODR,YLM,YLMI,G1RO,G2RO)
      CURMEM=CURMEM-SIZE_G1RO-SIZE_G2RO
	END
