	SUBROUTINE MIXRO1(ITER,EXIT)
*****************************************
*   Admixture in the main SCF loop      *
*****************************************
C SET ARRAY SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSV  !!! from readini
      USE COM_SCFLOOP ,ONLY: EPSRHO,EPSMAG                    !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,ORTH,OMEGAC,STRAIN           !!! from readini
      USE COM_LATTICE ,ONLY: RBAS,GBAS,TAU,TAO                !!! from readstr
      USE COM_SPHERE  ,ONLY: ZNUC,ZCOR,SMT,SASA,SWZ           !!! from readini
      USE COM_SYMMLM  ,ONLY: SYM,LMSYM,NSYM                   !!! from symlmm
      USE COM_DENDAT  ,ONLY: RHO,RHOCOR,RHOPS                 !!! from rhofull
      USE COM_MULTRO  ,ONLY: AMTOT                            !!! from multrho
      USE COM_MAGDAT  ,ONLY: AXMAG                            !!! from readini
      USE COM_PLWMESH ,ONLY: NPLW,GPLW                        !!! from plwmesh
      USE COM_FFTMESH ,ONLY: NFFTG                            !!! from makefft
      USE COM_RADMESH ,ONLY: NRAD,H,R,DR,WEIGHT               !!! from radmesh
	USE COM_MIXRHO1 ,ONLY: KEY,ADMIX1,ADMIN,ADMAX,ADMOPT    !!! from mixro1
     &                      ,KSP,ADMSPN,ASMIN,ASMAX,ADSPIN
	USE COM_MIXBROY ,ONLY: NBROY,LBROY,IBROY,ADMIXB,ADMIXH  !!! from mixrob
	USE COM_LMTINP  ,ONLY: SCFMADE                          !!! from mixro1
      USE COM_LMTOUT  ,ONLY: ICSCF,SCFFILE,ICSCR,SCRFILE      !!! from readini
      USE COM_CHANNELS,ONLY: IUSCF                            !!! from channels
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                      !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: ROCOLD(:,:)
	REAL*8, ALLOCATABLE :: POTOLD(:,:)
	COMPLEX*16, ALLOCATABLE :: RHOPSOLD(:,:,:)
	COMPLEX*16, ALLOCATABLE :: RHOPS1LD(:,:,:)
	COMPLEX*16, ALLOCATABLE :: WORK1(:)
	COMPLEX*16, ALLOCATABLE :: WORK2(:)
	COMPLEX*16, ALLOCATABLE :: RHOOLD(:,:,:,:)
	REAL*8 DM(-1:1),DMC(3),DMI(-1:1),DMCI(3)
	COMPLEX*16 ROINP,ROOUT,RONEW,AMINP,AMOUT,AMNEW,DELRHO,D0M(-1:1)
	CHARACTER FILE*130,TEXT*64
	LOGICAL EXIT
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
	IF(ITER.EQ.0)RETURN
C MEMORY ALLOCATIONS
	ALLOCATE(WORK1(0:NRADMEM))
	ALLOCATE(WORK2(0:NRADMEM))
	ALLOCATE(RHOOLD(0:NRADMEM,NSYMMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(ROCOLD(0:NRADMEM,NSPINMEM))
	ALLOCATE(POTOLD(0:NRADMEM,NSPINMEM))
	IF(NPLWMEM.NE.-1)
     &ALLOCATE(RHOPSOLD(0:NPLWMEM,NSPINMEM,NORBSMEM))
	IF(NPLWMEM.NE.-1)
     &ALLOCATE(RHOPS1LD(0:NPLWMEM,NSPINMEM,NORBSMEM))
C CALCULATE NEW ABSOLUTE CHARGE TRANFERE AND MAGNETISATION
	QTOT=0.D0
	ATOT=0.D0
	DO IATOM=1,NATOM
	QTOT=QTOT+ABS(AMTOT(1,IATOM,1,1)+AMTOT(1,IATOM,NSPIN,1))/
     &2.D0*DBLE(NSPIN)
	ATOT=ATOT+ABS(AMTOT(1,IATOM,1,1)-AMTOT(1,IATOM,NSPIN,1))
	IF(NORBS.EQ.2)THEN
	D0M( 0)=AMTOT(1,IATOM,1,1)-AMTOT(1,IATOM,NSPIN,1)
	D0M(-1)=AMTOT(1,IATOM,1,NORBS)
	D0M(+1)=AMTOT(1,IATOM,2,NORBS)
	ATOT=SQRT(DCONJG(D0M( 0))*D0M( 0)+
     &          DCONJG(D0M(-1))*D0M(-1)+
     &          DCONJG(D0M(+1))*D0M(+1))
	ENDIF
	ENDDO
C FIND OPTIMAL ADMIXTURE
      IF(LBROY.LT.0)THEN
      CALL PRATTC(QTOT,ITER,KEY,ADMIX1,ADMIN,ADMAX,ADMOPT)
      CALL PRATTM(ATOT,ITER,KSP,ADMSPN,ASMIN,ASMAX,ADSPIN)
      ELSEIF(LBROY.GE.0)THEN
C SET INPUT ADMIXTURE IF BROYDEN IS ON.
      ADMOPT=ADMIXH
      ADSPIN=ADMIXH
      ENDIF
	DZ=0.D0             ! charge difference in MTs
	DM( 0)=(0.D0,0.D0)  ! magnetization difference in MTs
	DM(-1)=(0.D0,0.D0)  
	DM(+1)=(0.D0,0.D0)  
	DI=0.D0             ! charge difference in cell
	DMI( 0)=(0.D0,0.D0) ! magnetisation difference in cell
	DMI(-1)=(0.D0,0.D0) 
	DMI(+1)=(0.D0,0.D0) 
C **********************************************************
C START EXTRACTING THE OLD CHARGE DENSITY FROM SCFFILE
	ICHN=IUSCF
      IF(ICSCF.GT.0)FILE=SCFFILE
      IF(ICSCF.EQ.0)FILE=SCRFILE(ICHN)
	OPEN(ICHN,FILE=FILE,STATUS='OLD',FORM='FORMATTED')
	READ(ICHN,FMT='(A)')TEXT
C Read control information:
      READ(ICHN,*)NATOM,NSORT,NSPIN,NORBS
	READ(ICHN,*)(IS(IATOM),IATOM=1,NATOM)
	READ(ICHN,*)RBAS,GBAS,PAR,ORTH,STRAIN,
     &((TAO(I,IATOM),I=1,3),IATOM=1,NATOM),
     &((TAU(I,IATOM),I=1,3),IATOM=1,NATOM),
     &(ZNUC(ISORT),ISORT=1,NSORT),
     &(SMT (ISORT),ISORT=1,NSORT),
     &((AXMAG(I,ISORT),I=1,3),ISORT=1,NSORT)
      READ(ICHN,*)
     &(NRAD(ISORT),ISORT=1,NSORT),
     &(NSYM(IATOM),IATOM=1,NATOM),
     &(ILSV(ISORT),ISORT=1,NSORT)
C READ: radial mesh
      READ(ICHN,*)((R(IRAD,ISORT),IRAD=0,NRAD(ISORT)),
     &ISORT=1,NSORT)
C READ: Charge density
      DO 100 IATOM=1,NATOM                         !!! over atoms
      ISORT=IS(IATOM)
      DO IORBS=1,NORBS
      DO IUPDN=1,NSPIN
      DO L=0,ILSV(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
      READ(ICHN,*)LM0
      READ(ICHN,*)(RHOOLD(IRAD,ISYM,IUPDN,IORBS),IRAD=0,NRAD(ISORT))
	ENDIF
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C DEFINE CHARGE CONVERGENCY BETWEEN ITERATIONS
      DO L=0,ILSV(ISORT)                          !!! over l
	DO M=-L,L                                   !!! over m
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN                       !!! for non-zero lm
	ISYM=LMSYM(LM,IATOM)
	DO IRAD=0,NRAD(ISORT)
	DELRHO=
     &(RHO   (IRAD,ISYM,IATOM,1,1)+RHO   (IRAD,ISYM,IATOM,NSPIN,1))/
     &2.D0*DBLE(NSPIN)-
     &(RHOOLD(IRAD,ISYM,      1,1)+RHOOLD(IRAD,ISYM,      NSPIN,1))/
     &2.D0*DBLE(NSPIN)
	WORK1(IRAD)=WEIGHT(IRAD,IS(IATOM))*DCONJG(DELRHO)*
     &DELRHO/4.D0/PI
	ENDDO
	CALL CQD(H(IS(IATOM)),WORK1,WORK2,NRAD(ISORT)+1)
	DZ=DZ+SQRT(ABS(WORK2(NRAD(ISORT))))
	DO IRAD=0,NRAD(ISORT)
	DELRHO=
     &(RHO   (IRAD,ISYM,IATOM,1,1)-RHO   (IRAD,ISYM,IATOM,NSPIN,1))-
     &(RHOOLD(IRAD,ISYM,      1,1)-RHOOLD(IRAD,ISYM,NSPIN,1      ))
	WORK1(IRAD)=WEIGHT(IRAD,IS(IATOM))*
     &DCONJG(DELRHO)*DELRHO/4.D0/PI
	ENDDO
	CALL CQD(H(IS(IATOM)),WORK1,WORK2,NRAD(ISORT)+1)
	DM(0)=DM(0)+SQRT(ABS(WORK2(NRAD(ISORT))))
	IF(NORBS.EQ.2)THEN
	DO IRAD=0,NRAD(ISORT)
	DELRHO=
     &RHO(IRAD,ISYM,IATOM,1,NORBS)-RHOOLD(IRAD,ISYM,1,NORBS)
	WORK1(IRAD)=WEIGHT(IRAD,IS(IATOM))*
     &DCONJG(DELRHO)*DELRHO/4.D0/PI
	ENDDO
	DM(-1)=DM(-1)+SQRT(ABS(WORK2(NRAD(ISORT))))
	DO IRAD=0,NRAD(ISORT)
	DELRHO=
     &RHO(IRAD,ISYM,IATOM,NSPIN,NORBS)-RHOOLD(IRAD,ISYM,NSPIN,NORBS)
	WORK1(IRAD)=WEIGHT(IRAD,IS(IATOM))*
     &DCONJG(DELRHO)*DELRHO/4.D0/PI
	ENDDO
	DM(+1)=DM(+1)+SQRT(ABS(WORK2(NRAD(ISORT))))
	ENDIF
C ADMIX NEW CHARGE DENSITY WITH THE OLD ONE
      IF(L.GT.LBROY)THEN                       !!! for l>l_broy
	DO IRAD=0,NRAD(ISORT)
C Total charge denisty within MT-spheres
	ROOUT=(RHO(IRAD,ISYM,IATOM,1,1)+RHO(IRAD,ISYM,IATOM,NSPIN,1))/
     &2.D0*DBLE(NSPIN)
	ROINP=(RHOOLD(IRAD,ISYM,1,1)+RHOOLD(IRAD,ISYM,NSPIN,1))/
     &2.D0*DBLE(NSPIN)
	RONEW=ADMOPT*ROOUT+(1.D0-ADMOPT)*ROINP
	AMOUT=(RHO(IRAD,ISYM,IATOM,1,1)-RHO(IRAD,ISYM,IATOM,NSPIN,1))
	AMINP=(RHOOLD(IRAD,ISYM,1,1)-RHOOLD(IRAD,ISYM,NSPIN,1))
	AMNEW=ADSPIN*AMOUT+(1.D0-ADSPIN)*AMINP
	RHO(IRAD,ISYM,IATOM,1,1)=(RONEW+AMNEW)/DBLE(NSPIN)
	RHO(IRAD,ISYM,IATOM,NSPIN,1)=(RONEW-AMNEW)/DBLE(NSPIN)
	ENDDO
      ENDIF                                   !!! for l>l_broy
C ADMIX TRANSVERSE MAGNETISATION
      IF(L.GT.LBROY)THEN                      !!! for l>l_broy
	DO IORBS=2,NORBS
	DO IUPDN=1,NSPIN
	DO IRAD=0,NRAD(ISORT)
	ROOUT=RHO(IRAD,ISYM,IATOM,IUPDN,IORBS)
	ROINP=RHOOLD(IRAD,ISYM,IUPDN,IORBS)
	RONEW=ADSPIN*ROOUT+(1.D0-ADSPIN)*ROINP
	RHO(IRAD,ISYM,IATOM,IUPDN,IORBS)=RONEW
	ENDDO
	ENDDO
	ENDDO
	ENDIF                                   !!! for l>l_broy
	ENDIF                                   !!! for non-zero components
	ENDDO                                   !!! over m
	ENDDO                                   !!! over l
 100	CONTINUE                                !!! over atoms
C READ OLD CORE DENSITY
      DO 200 ISORT=1,NSORT                    !!! over sorts
      DO ISPIN=1,NSPIN
      READ(ICHN,*)(ROCOLD(IRAD,ISPIN),IRAD=0,NRAD(ISORT))
      READ(ICHN,*)(POTOLD(IRAD,ISPIN),IRAD=0,NRAD(ISORT))
      ENDDO
 200	CONTINUE                                !!! over sorts
C ******************************************************************
C READ: pseudodensity
      READ(ICHN,*)RBAS,GBAS,ORTH,PAR,STRAIN,NPLW,NFFTG,
     &((TAO(I,IATOM),I=1,3),IATOM=1,NATOM),
     &((TAU(I,IATOM),I=1,3),IATOM=1,NATOM)
      IF(NPLW.NE.-1)THEN
	READ(ICHN,*)((GPLW(I,IPLW),I=1,3),IPLW=0,NPLW)
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	READ(ICHN,*)(RHOPSOLD(IPLW,IUPDN,IORBS),IPLW=0,NPLW)
	READ(ICHN,*)(RHOPS1LD(IPLW,IUPDN,IORBS),IPLW=0,NPLW)
	ENDDO
	ENDDO
	ELSEIF(NPLW.EQ.-1)THEN
	READ(ICHN,*)
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	READ(ICHN,*)
	READ(ICHN,*)
	ENDDO
	ENDDO
	ENDIF
	IF(NPLW.NE.-1)THEN
	DI=DI+OMEGAC*ABS(RHOPS(0,1,1)+RHOPS(0,NSPIN,1)-
     &RHOPSOLD(0,1,1)-RHOPSOLD(0,NSPIN,1))/2.D0*DBLE(NSPIN)
	DMI(0)=DMI(0)+OMEGAC*ABS(RHOPS(0,1,1)-RHOPS(0,NSPIN,1)-
     &RHOPSOLD(0,1,1)+RHOPSOLD(0,NSPIN,1))
	IF(NORBS.EQ.2)THEN
	DMI(-1)=DMI(-1)+OMEGAC*
     &ABS(RHOPS(0,1,NORBS)-RHOPSOLD(0,1,NORBS))
	DMI(+1)=DMI(+1)+OMEGAC*
     &ABS(RHOPS(0,NSPIN,NORBS)-RHOPSOLD(0,NSPIN,NORBS))
	ENDIF
	ENDIF
C PSEUDOCHARGE FOURIER TRANSFORMED
	IF(LBROY.LT.0)THEN
	DO IPLW=0,NPLW
	ROOUT=(RHOPS   (IPLW,1,1)+RHOPS   (IPLW,NSPIN,1))/2.D0*DBLE(NSPIN)
	ROINP=(RHOPSOLD(IPLW,1,1)+RHOPSOLD(IPLW,NSPIN,1))/2.D0*DBLE(NSPIN)
	RONEW=ADMOPT*ROOUT+(1.D0-ADMOPT)*ROINP
	AMOUT=(RHOPS   (IPLW,1,1)-RHOPS   (IPLW,NSPIN,1))
	AMINP=(RHOPSOLD(IPLW,1,1)-RHOPSOLD(IPLW,NSPIN,1))
	AMNEW=ADSPIN*AMOUT+(1.D0-ADSPIN)*AMINP
	RHOPS(IPLW,1    ,1)=(RONEW+AMNEW)/DBLE(NSPIN)
	RHOPS(IPLW,NSPIN,1)=(RONEW-AMNEW)/DBLE(NSPIN)
	ENDDO
	ENDIF
C TRANSVERSE MAGNETISATION FOURIER TRANSFORMED
	IF(LBROY.LT.0)THEN
	DO IORBS=2,NORBS
	DO IUPDN=1,NSPIN
	DO IPLW=0,NPLW
	ROOUT=RHOPS   (IPLW,IUPDN,IORBS)
	ROINP=RHOPSOLD(IPLW,IUPDN,IORBS)
	RONEW=ADSPIN*ROOUT+(1.D0-ADSPIN)*ROINP
	RHOPS(IPLW,IUPDN,IORBS)=RONEW
	ENDDO
	ENDDO
	ENDDO
	ENDIF
	CLOSE(ICHN)
C MIXING FINISHED.
	TZ=DZ+DI
	TM=DM(0)+DM(-1)+DM(+1)+DMI(0)+DMI(-1)+DMI(+1)
	IF(ABS(TZ).LE.EPSRHO.AND.ABS(TM).LE.EPSMAG)EXIT=.TRUE.
	IF(ABS(TZ).GT.EPSRHO.OR .ABS(TM).GT.EPSMAG)EXIT=.FALSE.
	SCFMADE=.TRUE.
	WRITE(IUN,1010)DZ,DI,ITER
	IF(IUN.NE.IUT)
     &WRITE(IUT,1010)DZ,DI,ITER
 1010 FORMAT(1X,'Charge Density Self-Consistency=',G14.7,2X,G14.7,
     &3X,I4)
	IF(NSPIN.EQ.2.AND.NORBS.EQ.1)
     &WRITE(IUN,1020)DM(0),DMI(0)
	IF(NSPIN.EQ.2.AND.NORBS.EQ.1.AND.IUN.NE.IUT)
     &WRITE(IUT,1020)DM(0),DMI(0)
 1020 FORMAT(1X,'Magnetization  Self-Consistency=',G14.7,2X,G14.7)
	IF(NSPIN.EQ.2.AND.NORBS.EQ.2)
     &WRITE(IUN,1030)DM(0),DMI(0)
	IF(NSPIN.EQ.2.AND.NORBS.EQ.2)
     &WRITE(IUN,1040)DM(-1),DMI(-1)
	IF(NSPIN.EQ.2.AND.NORBS.EQ.2)
     &WRITE(IUN,1050)DM(+1),DMI(+1)
	IF(NSPIN.EQ.2.AND.NORBS.EQ.2.AND.IUN.NE.IUT)
     &WRITE(IUT,1030)DM(0),DMI(0)
	IF(NSPIN.EQ.2.AND.NORBS.EQ.2.AND.IUN.NE.IUT)
     &WRITE(IUT,1040)DM(-1),DMI(-1)
	IF(NSPIN.EQ.2.AND.NORBS.EQ.2.AND.IUN.NE.IUT)
     &WRITE(IUT,1050)DM(+1),DMI(+1)
 1030 FORMAT(1X,'ZMagnetization Self-Consistency=',G14.7,2X,G14.7)
 1040 FORMAT(1X,'MMagnetization Self-Consistency=',G14.7,2X,G14.7)
 1050 FORMAT(1X,'PMagnetization Self-Consistency=',G14.7,2X,G14.7)
      IF(LBROY.LT.0)THEN
      WRITE(IUN,1060)ADMOPT
 1060 FORMAT(1X,'Charge Density Optimal Admixing=',G14.7)
      IF(NSPIN.EQ.2)WRITE(IUN,1070)ADSPIN
 1070 FORMAT(1X,'Magnetization  Optimal Admixing=',G14.7)
      CALL SCONVC(DZ,DI,ITER,ADMIN,ADMAX)
      CALL SCONVM(DM,DMI,ITER,ASMIN,ASMAX)
      ENDIF
C MEMORY DEALLOCATIONS
	DEALLOCATE(WORK1,WORK2,RHOOLD,ROCOLD,POTOLD)
	IF(NPLWMEM.NE.-1)
     &DEALLOCATE(RHOPSOLD,RHOPS1LD)
	END




	SUBROUTINE PRATTC(A,ITER,KEY,ADM0,ADMIN,ADMAX,ADM)
************************************************************
*  Optimal admixture choice in solving the equation:       *
*                         A=F[A]                           *
*  according to the Pratt scheme.                          *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	SAVE AINPI,AINPIP1,AOUTI
	IF(ITER.EQ.0)RETURN
C  SET INPUT AND OUTPUT VALUES
	AINPIM1=AINPI         !!! A(inp,i-1)=A(inp,i)
	AINPI=AINPIP1         !!! A(inp,i)=A(inp,i+1)
	AOUTIM1=AOUTI         !!! A(out,i-1)=A(out,i)
	AOUTI=A               !!! A(out,i)=A coming now
C  FIND OPTIMAL ADMIXTURE
	IF(ITER.EQ.1.AND.KEY.EQ.0)THEN
	ADM=ADM0              !!! input admixture in case key=0
	ELSEIF(ITER.EQ.1.AND.KEY.EQ.1)THEN
	ADM=1.D0              !!! no admixture in case key=1
	ELSEIF(ITER.EQ.2.OR.ITER.EQ.3)THEN
	ADM=ADM0              !!! constant admixture
	ELSE                  !!! optimal admixture choice
	DIF=(AOUTI-AINPI)-(AOUTIM1-AINPIM1)
	IF(ABS(DIF).LE.1.D-10)THEN
	ADM=ADM0
	ELSE
	ADM=(AINPIM1-AINPI)/(DIF+1.D-14)
	ENDIF
	ENDIF
	IF(ADM.LE.ADMIN)ADM=ADMIN
	IF(ADM.GE.ADMAX)ADM=ADMAX
C  FIND INPUT FOR THE NEXT ITERATION
	AINPIP1=AOUTI*ADM+AINPI*(1.D0-ADM) !!! A(inp,i+1)               
	END



	SUBROUTINE PRATTM(A,ITER,KEY,ADM0,ADMIN,ADMAX,ADM)
************************************************************
*  Optimal admixture choice in solving the equation:       *
*                         A=F[A]                           *
*  according to the Pratt scheme.                          *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	SAVE AINPI,AINPIP1,AOUTI
	IF(ITER.EQ.0)RETURN
C  SET INPUT AND OUTPUT VALUES
	AINPIM1=AINPI         !!! A(inp,i-1)=A(inp,i)
	AINPI=AINPIP1         !!! A(inp,i)=A(inp,i+1)
	AOUTIM1=AOUTI         !!! A(out,i-1)=A(out,i)
	AOUTI=A               !!! A(out,i)=A coming now
C  FIND OPTIMAL ADMIXTURE
	IF(ITER.EQ.1.AND.KEY.EQ.0)THEN
	ADM=ADM0              !!! input admixture in case key=0
	ELSEIF(ITER.EQ.1.AND.KEY.EQ.1)THEN
	ADM=1.D0              !!! no admixture in case key=1
	ELSEIF(ITER.EQ.2.OR.ITER.EQ.3)THEN
	ADM=ADM0              !!! constant admixture
	ELSE                  !!! optimal admixture choice
	DIF=(AOUTI-AINPI)-(AOUTIM1-AINPIM1)
	IF(ABS(DIF).LE.1.D-14)THEN
	ADM=ADM0
	ELSE
	ADM=(AINPIM1-AINPI)/(DIF+1.D-14)
	ENDIF
	ENDIF
	IF(ADM.LE.ADMIN)ADM=ADMIN
	IF(ADM.GE.ADMAX)ADM=ADMAX
C  FIND INPUT FOR THE NEXT ITERATION
	AINPIP1=AOUTI*ADM+AINPI*(1.D0-ADM) !!! A(inp,i+1)               
	END



      SUBROUTINE SCONVC(A,AI,ITER,ADMIN,ADMAX)
************************************************************
*  Checks whether the self-consistent cycle converges.     *
************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AOLD(2),AIOLD(2)
      SAVE AOLD,AIOLD
C  SAVE DATA OF PREVIOUS THREE ITERATIONS
      IF(ITER.EQ.1)THEN
      AOLD(1)=0.D0
      AOLD(2)=0.D0
      AIOLD(1)=0.D0
      AIOLD(2)=0.D0
      ELSEIF(ITER.GT.1)THEN
      AOLD(2)=AOLD(1)
      AOLD(1)=A
      AIOLD(2)=AIOLD(1)
      AIOLD(1)=AI
      ENDIF
C  CHECK WHETHER CONVERGENCY IS TAKEN PLACE
      IF(ITER.GT.3)THEN
      IF(AOLD(1).LE.AOLD(2).AND.AIOLD(1).LE.AIOLD(2))RETURN
      ADMIN=ADMIN/2.D0
      ADMAX=ADMAX/2.D0
      ENDIF
      END



      SUBROUTINE SCONVM(A,AI,ITER,ADMIN,ADMAX)
************************************************************
*  Checks whether the self-consistent cycle converges.     *
************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AOLD(2),AIOLD(2)
      SAVE AOLD,AIOLD
C  SAVE DATA OF PREVIOUS THREE ITERATIONS
      IF(ITER.EQ.1)THEN
      AOLD(1)=0.D0
      AOLD(2)=0.D0
      AIOLD(1)=0.D0
      AIOLD(2)=0.D0
      ELSEIF(ITER.GT.1)THEN
      AOLD(2)=AOLD(1)
      AOLD(1)=A
      AIOLD(2)=AIOLD(1)
      AIOLD(1)=AI
      ENDIF
C  CHECK WHETHER CONVERGENCY IS TAKEN PLACE
      IF(ITER.GT.3)THEN
      IF(AOLD(1).LE.AOLD(2).AND.AIOLD(1).LE.AIOLD(2))RETURN
      ADMIN=ADMIN/2.D0
      ADMAX=ADMAX/2.D0
      ENDIF
      END
