	SUBROUTINE STRMSH
**************************************************************
*  The preparation of the structure constants for the        *
*  LMTO method  at different energies and their energy       *
*  derivatives.                                              *
**************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM
      USE COM_CONTROL, ONLY : LMTO,IASA                       !!! from readini
      USE COM_PARAM,   ONLY : NATOM,NSORT,IS,ILST,ILSB,ILSV   !!! from readini
      USE COM_KAPPAR,  ONLY : NPAN,NKAP,EKAP,EK,EDGE          !!! from readini
      USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                 !!! from readstr
      USE COM_INPTTR,  ONLY : NDIV,NDIC,SH                    !!! from readini
      USE COM_KMESH,   ONLY : NPNT,PNT                        !!! from tetra
      USE COM_VECGEN,  ONLY : LIMDT                           !!! from vecgen
      USE COM_LMSTRS,  ONLY : NR2,NR4,ILS2,ILS4,ILD2,ILD4     !!! from vecgen
     &                       ,LIMLPL2,LIMLPL4,LIMLDL2,LIMLDL4 !!! from vecgen
      USE COM_LMTOUT,  ONLY : ICCON,CONFILE,ICSCR,SCRFILE     !!! from readini
      USE COM_UNIT,    ONLY : IUN,IUR,IUT                     !!! from setup
      USE COM_MASHDEP, ONLY : NVAL,LENINT,LENREL,LENCMP       !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, INTRINSIC :: SIZE
	INTEGER, ALLOCATABLE :: LIM2OLD(:)
	INTEGER, ALLOCATABLE :: LIM4OLD(:)
	INTEGER, ALLOCATABLE :: LID2OLD(:)
	INTEGER, ALLOCATABLE :: NKAP0  (:)
	COMPLEX*16, ALLOCATABLE :: SIGMA(:,:,:)
	COMPLEX*16, ALLOCATABLE :: SIGMD(:,:,:)
	COMPLEX*16, ALLOCATABLE :: SIGMM(:,:)
	COMPLEX*16, ALLOCATABLE :: EKOLD(:,:)
	LOGICAL FIRST,LAST,EXIST
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C MEMORY ALLOCATIONS FOR SCRATCH ARRAYS
	LTLMEM=(LMAXTMEM+1+LMAXBMEM+1)**2
	LDLMEM=(LMAXBMEM+1+LMAXBMEM+1)**2
	ALLOCATE(SIGMA(LTLMEM,LIMDTMEM,NKAPMEM),STAT=IALLOC)
	IF(IALLOC.EQ.1)CALL STRMSH_MESG01('SIGMA',
     &LTLMEM*LIMDTMEM*NKAPMEM*LENCMP)
	SIZE_SIGMA=DBLE(SIZE(SIGMA)*LENCMP)/1024.D0**2
	ALLOCATE(SIGMD(LDLMEM,LIMDTMEM,NKAPMEM),STAT=IALLOC)
	IF(IALLOC.EQ.1)CALL STRMSH_MESG01('SIGMD',
     &LDLMEM*LIMDTMEM*NKAPMEM*LENCMP)
	SIZE_SIGMD=DBLE(SIZE(SIGMD)*LENCMP)/1024.D0**2
	CURMEM=CURMEM+SIZE_SIGMA+SIZE_SIGMD
      IF(TOTMEM.LT.CURMEM)TXTMEM='<STRMSH> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
	ALLOCATE(NKAP0(NPANMEM))
	ALLOCATE(EKOLD(NKAPMEM,NPANMEM))
	ALLOCATE(LIM2OLD(LIMDTMEM))
	ALLOCATE(LIM4OLD(LIMDTMEM))
	ALLOCATE(LID2OLD(LIMDTMEM))
C **********************************************************
C OPEN FILE FOR SIGMA-CONSTANTS
1000	CONTINUE
	IF(ICCON.EQ.1)THEN
	OPEN(8,FILE=CONFILE,STATUS='NEW',FORM='UNFORMATTED',
     &ACCESS='DIRECT',RECL=NR2)
	WRITE(8,REC=1)NR2,LMTO,NDIV(1),NDIC(1),NPNT(1),NPNT(NPAN),
     &NATOM,LIMDT,NPAN,(NKAP(IPAN),IPAN=1,NPAN),((EK(IKAP,IPAN),
     &IKAP=1,NKAP(IPAN)),IPAN=1,NPAN)
C *********************************************************
C TEST STRUCTURE CONSTANTS FILE
	ELSEIF(ICCON.EQ.2)THEN    !!! test input data !!!
	INQUIRE(FILE=CONFILE,RECL=NRECL)
CWRONGIF(WRONG)THEN           !!! wrong compiler statement
	NRECL=NVAL
	OPEN(8,FILE=CONFILE,STATUS='OLD',FORM='UNFORMATTED',
     &ACCESS='DIRECT',RECL=NRECL)
	READ(8,REC=1)NRECL
	CLOSE(8)
CWRONGENDIF
	OPEN(8,FILE=CONFILE,STATUS='OLD',FORM='UNFORMATTED',
     &ACCESS='DIRECT',RECL=NRECL)
	READ(8,REC=1)NRECL,LMTO0,NDIV0,NDIC0,NPNT0,NPNTP,NATOM0,
     &LIMDT0,NPAN0
	IF(NDIV0.NE.NDIV(1))CALL STRMSH_MESG02
	IF(NDIV0.NE.NDIV(1))GOTO1000
	IF(NDIC0.NE.NDIC(1))CALL STRMSH_MESG02
	IF(NDIC0.NE.NDIC(1))GOTO1000
	IF(LIMDT0.NE.LIMDT)CALL STRMSH_MESG02
	IF(LIMDT0.NE.LIMDT)GOTO1000
	IF(NPAN.NE.NPAN0)CALL STRMSH_MESG02
	IF(NPAN.NE.NPAN0)GOTO1000
	READ(8,REC=1)NRECL,LMTO0,NDIV0,NDIC0,NPNT0,NPNTP,NATOM0,
     &LIMDT0,NPAN0,(NKAP0(IPAN),IPAN=1,NPAN)
	DO IPAN=1,NPAN
	IF(NKAP(IPAN).NE.NKAP0(IPAN))CALL STRMSH_MESG02
	IF(NKAP(IPAN).NE.NKAP0(IPAN))GOTO1000
	ENDDO
	READ(8,REC=1)NRECL,LMTO0,NDIV0,NDIC0,NPNT0,NPNTP,NATOM0,
     &LIMDT0,NPAN0,(NKAP0(IPAN),IPAN=1,NPAN),((EKOLD(IKAP,IPAN),
     &IKAP=1,NKAP0(IPAN)),IPAN=1,NPAN)
	DO IPAN=1,NPAN
	DO IKAP=1,NKAP(IPAN)
	IF(ABS(EK(IKAP,IPAN)-EKOLD(IKAP,IPAN)).GE.1.D-08)
     &CALL STRMSH_MESG02
	IF(ABS(EK(IKAP,IPAN)-EKOLD(IKAP,IPAN)).GE.1.D-08)
     &GOTO1000
	ENDDO 
	ENDDO
      DO ITAU=1,LIMDT0
      IREC=ITAU+1
      READ(8,REC=IREC)LIM2OLD(ITAU),LID2OLD(ITAU)
	ENDDO
	DO ITAU=1,LIMDT
	IF(LIMLPL2(ITAU).NE.LIM2OLD(ITAU))
     &CALL STRMSH_MESG02
	IF(LIMLPL2(ITAU).NE.LIM2OLD(ITAU))
     &GOTO1000
	IF(LIMLDL2(ITAU).NE.LID2OLD(ITAU))
     &CALL STRMSH_MESG02
	IF(LIMLDL2(ITAU).NE.LID2OLD(ITAU))
     &GOTO1000
	ENDDO
	IF(NR2.NE.NRECL)CALL STRMSH_MESG02
      IF(NR2.NE.NRECL)GOTO1000
	CLOSE(8)
	ENDIF
C *****************************************************************
C COMPUTE STRUCTURE CONSTANTS
	IF(ICCON.EQ.1)THEN
	IREC=1
	DO IPAN=1,NPAN                       !!! over energy panels
	DO IPNT=1,NPNT(IPAN)                 !!! over k-points
	IF(IPNT.EQ.1)FIRST=.TRUE.
	IF(IPNT.NE.1)FIRST=.FALSE.
	IF(IPNT.NE.NPNT(IPAN))LAST=.FALSE.
	IF(IPNT.EQ.NPNT(IPAN))LAST=.TRUE.
	XK=PNT(1,IPNT,IPAN)+SH(1,IPAN)
	YK=PNT(2,IPNT,IPAN)+SH(2,IPAN)
	ZK=PNT(3,IPNT,IPAN)+SH(3,IPAN)
	IF(IPAN.EQ.1.OR.(DREAL(EKAP(1,IPAN)).GE.EDGE.AND.IPAN.NE.1))
     &CALL DSTR(XK,YK,ZK,ILS2,ILD2,NKAP(IPAN),EK(1,IPAN),FIRST,
     &LAST,LTLMEM,LDLMEM,NKAPMEM,SIGMA,SIGMD)
	IF(IPAN.NE.1.AND.DREAL(EKAP(1,IPAN)).LT.EDGE)
     &CALL HSTR(XK,YK,ZK,ILS2,ILD2,NKAP(IPAN),EK(1,IPAN),FIRST,
     &LAST,LTLMEM,LDLMEM,NKAPMEM,SIGMA,SIGMD)
	FIRST=.FALSE.
	DO IKAP=1,NKAP(IPAN)
	DO ITAU=1,LIMDT
	IREC=IREC+1
	WRITE(8,REC=IREC)LIMLPL2(ITAU),LIMLDL2(ITAU),
     &(SIGMA(LM,ITAU,IKAP),LM=1,LIMLPL2(ITAU)),
     &(SIGMD(LM,ITAU,IKAP),LM=1,LIMLDL2(ITAU))
	ENDDO
	ENDDO
	ENDDO                                !!! over k-points
      ENDDO                                !!! over energy panels
	CLOSE(8)
C *****************************************************************
	ENDIF
C MEMORY DEALLOCATIONS
	DEALLOCATE(SIGMA)
	DEALLOCATE(SIGMD)
	CURMEM=CURMEM-SIZE_SIGMA-SIZE_SIGMD
	DEALLOCATE(LIM2OLD)
	DEALLOCATE(LIM4OLD)
	DEALLOCATE(LID2OLD)
	DEALLOCATE(NKAP0)
	DEALLOCATE(EKOLD)
C MEMORY ALLOCATIONS FOR SCRATCH ARRAYS
	LPLMEM=(2*LMAXVMEM+3)**2
	ALLOCATE(SIGMD(1,LIMDTMEM,1))
	ALLOCATE(SIGMM(LPLMEM,LIMDTMEM),STAT=IALLOC)
	IF(IALLOC.EQ.1)CALL STRMSH_MESG01('SIGMA',
     &LPLMEM*LIMDTMEM*LENCMP)
	SIZE_SIGMM=DBLE(SIZE(SIGMM)*LENCMP)/1024.D0**2
	CURMEM=CURMEM+SIZE_SIGMM
      IF(TOTMEM.LT.CURMEM)TXTMEM='<STRMSH> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
C *************************************************************
C CALCULATE MADELUNG MATRIX AND STORE IT
      OPEN(7,FILE=SCRFILE(7),STATUS='NEW',FORM='UNFORMATTED',
     &ACCESS='DIRECT',RECL=NR4)
      CALL DSTR(0.D0,0.D0,0.D0,ILS4,ILD4,1,(0.D0,0.D0),.TRUE.,
     &.TRUE.,LPLMEM,1,1,SIGMM,SIGMD)
      DO ITAU=1,LIMDT
      WRITE(7,REC=ITAU)LIMLPL4(ITAU),
     &(SIGMM(LM,ITAU),LM=1,LIMLPL4(ITAU))
	ENDDO
C *************************************************************
C MEMORY DEALLOCATIONS
	DEALLOCATE(SIGMM)
	CURMEM=CURMEM-SIZE_SIGMM
	DEALLOCATE(SIGMD)
      CONTAINS
C ERROR HANDLINGS
      SUBROUTINE STRMSH_MESG01(CHARV,LSIZE)
      CHARACTER CHARV*(*)
      WRITE(IUT,*)'Terminated in <STRMSH>:'
      WRITE(IUT,*)'Memory allocation problem detected by'
      WRITE(IUT,*)'the system. Array '//CHARV//' of the size:'
      WRITE(IUT,*) DBLE(LSIZE)/1024.D0**2,' Mbyte'
      WRITE(IUT,*)'cannot be allocated.'
      CALL FULLSTOP(' ')
      END SUBROUTINE STRMSH_MESG01
      SUBROUTINE STRMSH_MESG02
	WRITE(IUT,*)'Warning from <STRMSH>:'
	WRITE(IUT,*)'Structure constants CONFILE ',CONFILE
	WRITE(IUT,*)'does not match current setup. It will'
	WRITE(IUT,*)'be recalculated.'
	CLOSE(8,STATUS='DELETE')
	ICCON=1
      END SUBROUTINE STRMSH_MESG02
	END SUBROUTINE STRMSH
