	SUBROUTINE GRFFRM0(EF0,ZTOT,EF,NITER,EPS,H)
**************************************************************
*  Searches Fermi's energy without use of DOS hint           *
**************************************************************
C SET ARRAY SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                              !!! from setup
      USE COM_UNIT,    ONLY : IUN,IUR,IUT                         !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	DATA PI/3.141592653589793D0/
	ITER=0
	E1=EF0
	E2=EF0+H
	CALL GRFFRM_ROOT(EF,DIFF,E1,E2,ITER,IEXIT,IUN,EPS,NITER)
  100	ITER=ITER+1
	CALL TTRGRF(EF,0,(0.D0,0.D0),TOS,DOS,0,0)
	DIFF=ZTOT-TOS
	CALL GRFFRM_ROOT(EF,DIFF,E1,E2,ITER,IEXIT,IUN,EPS,NITER)
	IF(IEXIT.EQ.1)GOTO 200
	GOTO 100
  200 CONTINUE
	END


	SUBROUTINE GRFFRM_ROOT(ROOT,DIFF,R1,R2,ITER,IEXIT,IUN,EPS,NITER)
********************************************************************
*  Finds approximate root by cubic interpolation at approximately  *
*  given interval from R1 to R2. If no root is found the interval  *
*  is extended until root is located.                              *
********************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	SAVE
	DATA PI/3.141592653589793D0/,NSTEP/0/
C START CODE: 
	IEXIT=0
	IF(ABS(R2-R1).LE.1.D-10)
     &CALL FULLSTOP('<GRFFRM_ROOT> :: Zero interval set')
  100	STEP=(R2-R1)/2.D0*DBLE(NSTEP)
C Check first
	IF(ITER.EQ.0)THEN
	ROOT=R1-STEP
	RT1=ROOT
	RETURN
	ENDIF
C If iter=1, check doping
	IF(ITER.EQ.1)THEN
	DF1=DIFF
	ROOT=R2+STEP
	RT2=ROOT
	RETURN
	ENDIF
	IF(ITER.EQ.2)DF2=DIFF
C If there is no root between R1 and R2, increase step
	IF(DF2*DF1.GE.0.D0.AND.ITER.EQ.2)THEN
	ITER=0
	NSTEP=NSTEP+1
	IF(NSTEP.GT.NITER)THEN
	WRITE(IUN,10010)R1-STEP,R2+STEP
10010	FORMAT(1X,'Cannot locate root, interval = ',G12.5,1X,G12.5)
	IEXIT=1
	ENDIF
	GOTO 100
	RETURN
	ENDIF
C Root exists, try to locate it by linear/parabolic interpolations
	IF(ITER.EQ.2)THEN
	RTNEW=(DF2*RT1-DF1*RT2)/(DF2-DF1)
	ELSEIF(ITER.GT.2)THEN
	CALL PARAROOT(DF1,DIFF,DF2,RT1,ROOT,RT2,RR1,RI1,RR2,RI2)
	IF(RR1.GE.RT1.AND.RR1.LE.RT2.AND.ABS(RI1).LE.1.D-10)THEN
      RTNEW=RR1
	ELSEIF(RR2.GE.RT1.AND.RR2.LE.RT2.AND.ABS(RI2).LE.1.D-10)THEN
      RTNEW=RR2
	ELSE
	CALL FULLSTOP('<GRFFRM_ROOT> Error in locating the root')
	ENDIF
	ENDIF
C Save data
      IF(DIFF*DF1.GE.0.D0)THEN
	RT1=ROOT
	DF1=DIFF
	ELSEIF(DIFF*DF2.GE.0.D0)THEN
	RT2=ROOT
	DF2=DIFF
	ENDIF
C  CHECK FOR CONVERGENCY
	IF(ABS(RTNEW-ROOT).GT.EPS.OR .ABS(DIFF).GT.EPS)IEXIT=0
	IF(ABS(RTNEW-ROOT).LE.EPS.AND.ABS(DIFF).LE.EPS)IEXIT=1
	IF(ITER.EQ.NITER)THEN
	WRITE(IUN,10020)RTNEW,ROOT
10020	FORMAT(1X,'No convergency in Root = ',G12.5,1X,G12.5)
	IEXIT=1
	ENDIF
	ROOT=RTNEW
	NSTEP=0
	END






	SUBROUTINE GRFFRM(X1,Y0,X0,ITMAX,EPS,H)
**************************************************************
*  Searches Fermi's energy. Old version.                     *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	LOGICAL LEFT,RIGHT
C INITIATION
	ITER=1
	H1=1.D0/H
	X=X1
	LEFT=.FALSE.
	RIGHT=.FALSE.
C
C THE BEGINNING OF THE ITERATION LOOP.
C
  100	CALL TTRGRF(X,0,(0.D0,0.D0),Y,DY,0,1)
C	DY=DY/DX
	YY=Y-Y0
C	WRITE(IUT,*)'ITER,X,YY',ITER,X,YY  !!!DEBUGGING
	CALL SLTRT(X,YY,DY,XL,YYL,DYL,LEFT,XR,YYR,DYR,RIGHT)
	IF(.NOT.LEFT.OR..NOT.RIGHT) THEN
C	THE NEWTON'S METHOD.
	IF(DY.LE.ABS(YY*H1)) X=X-SIGN(H,YY)
C	WITH LIMITATION
	IF(DY.GT.ABS(YY*H1)) X=X-YY/DY
C	WITHOUT LIMITATION
	ELSEIF(LEFT.AND.RIGHT)THEN
C	THE PARABOLA METHOD.
	DELTX=XR-XL
	IF(DELTX.LE.1.D-10)GOTO 200
	DYS=(YYR-YYL)/DELTX
	IF(ABS(YYL).LE.YYR)THEN
	ALFA=ABS(YYL/DELTX)
	IF(ALFA.LE.DYL)THEN
	A=ALFA/DYL
	B=DYS/DYL
	X=XL+DELTX*F1(A,B)
	ELSE
	C=DYL/ALFA
	D=DYS/ALFA
	X=XL+DELTX*F2(C,D)
	END IF
	ELSE
	BETA=YYR/DELTX
	IF(BETA.LE.DYR)THEN
	A=BETA/DYR
	B=DYS/DYR
	X=XR-DELTX*F1(A,B)
	ELSE
	C=DYR/BETA
	D=DYS/BETA
	X=XR-DELTX*F2(C,D)
	END IF
	END IF
	END IF
C	EXITS
	IF(ITER.GE.ITMAX)
     &CALL FULLSTOP('THE EXCEEDING OF ITMAX IN EFERMI_SEARCH')
	IF(ABS(YY).LE.EPS) GOTO 200
	ITER=ITER+1
	GOTO 100
C	THE END OF THE LOOP.
  200	IF(ITER.NE.1)THEN
	X0=X
	ELSE
	X0=X1
	ENDIF
	RETURN
C INTERNAL PROCEDURES
      CONTAINS
      FUNCTION F1(A,B)
      IMPLICIT REAL*8 (A-H,O-Z)
      F1=2.D0*A/(1.D0+SQRT(1.D0+4.D0*A*(B-1.D0)))
      END FUNCTION F1
      FUNCTION F2(C,D)
      IMPLICIT REAL*8 (A-H,O-Z)
      F2=2.D0/(C+SQRT(C*C+4.D0*(D-C)))
      END FUNCTION F2
      SUBROUTINE SLTRT(X,YY,DY,XL,YYL,DYL,LEFT,XR,YYR,DYR,RIGHT)
*************************************************************
*  CLASSIFIES X INTO LEFT AND RIGHT POINTS.                 *
*************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      LOGICAL LEFT,RIGHT
      IF(YY.LE.0.D0) THEN
      XL=X
      YYL=YY
      DYL=DY
      LEFT=.TRUE.
      ELSE
      XR=X
      YYR=YY
      DYR=DY
      RIGHT=.TRUE.
      END IF
      RETURN
      END SUBROUTINE SLTRT
      END SUBROUTINE GRFFRM
